/* 
 * $RCSfile: common.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/06/28 13:38:29 $
 * 
 * $Revision: 1.18 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __common_h
#define __common_h

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <glib.h>

/***********************************************************************
 * IMAGE FILENAMES
 ***********************************************************************/

/*
 * Root directories
 */

/* #define IN_DEVELOPMENT */

/* paths */
#ifndef WIN32
#define PATH_USERDIR ".gnome-jabber"
#else
#define PATH_USERDIR "gnome-jabber"
#endif

#define PATH_LOG "logs"
#define PATH_HISTORY "history"
#define PATH_DATA PKGDATADIR

#ifdef IN_DEVELOPMENT
#  ifdef PATH_DATA
#    undef PATH_DATA
#  endif
#  define PATH_DATA "../images"
#endif /* IN_DEVELOPMENT */

/* gui */
#define FILE_GLADE "gnome-jabber.glade"

/* configuration */
#define FILE_CONFIG "gnome-jabber.config"

/* logging */
#define FILE_LOG "gnome-jabber.log"

/* images */
#define FILE_IMAGE_EXT ".png"

/* history */
#define FILE_CSS "gnome-jabber.css"

/* groups */
#define FILE_GROUPS PATH_DATA"/groups"FILE_IMAGE_EXT

/* presence */
#define FILE_PRESENCE_AVAILABLE PATH_DATA"/presence_online"FILE_IMAGE_EXT
#define FILE_PRESENCE_UNAVAILABLE PATH_DATA"/presence_offline"FILE_IMAGE_EXT
#define FILE_PRESENCE_SUBSCRIBE PATH_DATA"/presence_subscribe"FILE_IMAGE_EXT
#define FILE_PRESENCE_UNSUBSCRIBE PATH_DATA"/presence_unsubscribe"FILE_IMAGE_EXT
#define FILE_PRESENCE_SUBSCRIBED PATH_DATA"/presence_offline"FILE_IMAGE_EXT
#define FILE_PRESENCE_UNSUBSCRIBED PATH_DATA"/presence_unsubscribed"FILE_IMAGE_EXT
#define FILE_PRESENCE_ERROR PATH_DATA"/message_error"FILE_IMAGE_EXT
#define FILE_PRESENCE_NONE PATH_DATA"/presence_none"FILE_IMAGE_EXT

#define FILE_PRESENCE_AWAY PATH_DATA"/presence_away"FILE_IMAGE_EXT
#define FILE_PRESENCE_CHAT PATH_DATA"/presence_chat"FILE_IMAGE_EXT
#define FILE_PRESENCE_DND PATH_DATA"/presence_dnd"FILE_IMAGE_EXT
#define FILE_PRESENCE_NORMAL PATH_DATA"/presence_online"FILE_IMAGE_EXT
#define FILE_PRESENCE_XA PATH_DATA"/presence_xa"FILE_IMAGE_EXT

/* messages */
#define FILE_MESSAGE_NORMAL PATH_DATA"/message_normal"FILE_IMAGE_EXT
#define FILE_MESSAGE_CHAT PATH_DATA"/message_chat"FILE_IMAGE_EXT
#define FILE_MESSAGE_GROUPCHAT PATH_DATA"/message_groupchat"FILE_IMAGE_EXT
#define FILE_MESSAGE_HEADLINE PATH_DATA"/message_headline"FILE_IMAGE_EXT
#define FILE_MESSAGE_ERROR PATH_DATA"/message_error"FILE_IMAGE_EXT

/* emote icons */ 
#define FILE_EMOTE_BIGGRIN PATH_DATA"/emote_biggrin"FILE_IMAGE_EXT
#define FILE_EMOTE_CONFUSED PATH_DATA"/emote_confused"FILE_IMAGE_EXT
#define FILE_EMOTE_COOL PATH_DATA"/emote_cool"FILE_IMAGE_EXT
#define FILE_EMOTE_EEK PATH_DATA"/emote_eek"FILE_IMAGE_EXT
#define FILE_EMOTE_FROWN PATH_DATA"/emote_frown"FILE_IMAGE_EXT
#define FILE_EMOTE_MAD PATH_DATA"/emote_mad"FILE_IMAGE_EXT
#define FILE_EMOTE_REDFACE PATH_DATA"/emote_redface"FILE_IMAGE_EXT
#define FILE_EMOTE_ROLLEYES PATH_DATA"/emote_rolleyes"FILE_IMAGE_EXT
#define FILE_EMOTE_SMILE PATH_DATA"/emote_smile"FILE_IMAGE_EXT
#define FILE_EMOTE_TONGUE PATH_DATA"/emote_tongue"FILE_IMAGE_EXT
#define FILE_EMOTE_WINK PATH_DATA"/emote_wink"FILE_IMAGE_EXT

/* jabber software foundation */
#define FILE_JSF PATH_DATA"/jsf"FILE_IMAGE_EXT

/* absolute file/dir's */
#define PATH_FULL_HISTORY G_DIR_SEPARATOR_S PATH_USERDIR G_DIR_SEPARATOR_S PATH_HISTORY
#define FILE_FULL_CONFIG G_DIR_SEPARATOR_S PATH_USERDIR G_DIR_SEPARATOR_S FILE_CONFIG
#define FILE_FULL_CSS G_DIR_SEPARATOR_S PATH_USERDIR G_DIR_SEPARATOR_S FILE_CSS
#define FILE_FULL_GLADE PATH_DATA G_DIR_SEPARATOR_S FILE_GLADE

/***********************************************************************
 * ROSTER CONSTANTS        
 ***********************************************************************/

#define ROSTER_GROUP_OFFLINE "Offline"
#define ROSTER_GROUP_NOT_ON_ROSTER "Not On Roster"

/***********************************************************************
 * EMOTE ICONS        
 ***********************************************************************/

typedef enum {
  
    emote_biggrin = 1,
    emote_confused,
    emote_cool,
    emote_eek,
    emote_frown,
    emote_mad,
    emote_redface,
    emote_rolleyes,
    emote_smile,
    emote_tongue,
    emote_wink,
    emote_null
    
} msgEmote, chatEmote;

#define EMOTE_BIGGRIN ":D"
#define EMOTE_CONFUSED ":s"
#define EMOTE_COOL "(h)"
#define EMOTE_EEK ":O"
#define EMOTE_FROWN ":("
#define EMOTE_MAD ":@"
#define EMOTE_REDFACE ":$"
#define EMOTE_ROLLEYES "8)"
#define EMOTE_SMILE ":)"
#define EMOTE_TONGUE ":P"
#define EMOTE_WINK ";)"

/***********************************************************************
 * CONFIG        
 ***********************************************************************/

#define CONFIG_APP "gnome-jabber"

#define CONFIG_SECT_CS "connection"
#define CONFIG_SECT_MPF "preferences"
#define CONFIG_SECT_MI "information"
#define CONFIG_SECT_ROSTER "roster"

#define CONFIG_CS_SERVER "server"
#define CONFIG_CS_PORT "port"
#define CONFIG_CS_USERNAME "username"
#define CONFIG_CS_PASSWORD "password"
#define CONFIG_CS_RESOURCE "resource"
#define CONFIG_CS_NICKNAME "nickname"

#define CONFIG_CS_SAVE_PASSWORD "save_password"
#define CONFIG_CS_USE_PLAIN_TEXT_PASSWORD "use_plain_text_password"
#define CONFIG_CS_USE_SSL "use_ssl"

#define CONFIG_CS_AUTO_CONNECT_ON_STARTUP "auto_connect_on_startup"
#define CONFIG_CS_AUTO_RECONNECT_ON_DISCONNECT "auto_reconnect_on_disconnect"


#define CONFIG_MPF_HIDE_OFFLINE_CONTACTS "hide_offline_contacts"
#define CONFIG_MPF_HIDE_OFFLINE_GROUP "hide_offline_group"
#define CONFIG_MPF_HIDE_AGENTS "hide_agents"

#define CONFIG_MPF_CLOSE_PREVIOUS_MESSAGE_WINDOW_ON_REPLY "close_previous_message_window_on_reply"
#define CONFIG_MPF_RAISE_WINDOW_ON_NEW_MESSAGE "raise_window_on_new_message"
#define CONFIG_MPF_HIDE_TIME "hide_time"
#define CONFIG_MPF_REVERSE_TEXT_DIRECTION "reverse_text_direction"

#define CONFIG_MPF_USE_SPELL_CHECKER "use_spell_checker"

#define CONFIG_MPF_AUTO_AWAY_AFTER "auto_away_after"
#define CONFIG_MPF_AUTO_XA_AFTER "auto_xa_after"
#define CONFIG_MPF_AUTO_AWAY_STATUS "auto_away_status"
#define CONFIG_MPF_AUTO_XA_STATUS "auto_xa_status"

#define CONFIG_MPF_SOUND_ENABLED "sound_enabled"
#define CONFIG_MPF_SOUND_ON_USER_ONLINE "sound_on_user_online"
#define CONFIG_MPF_SOUND_ON_USER_OFFLINE "sound_on_user_offline"
#define CONFIG_MPF_SOUND_ON_RECEIVE_MESSAGE "sound_on_receive_message"
#define CONFIG_MPF_SOUND_ON_RECEIVE_CHAT "sound_on_receive_chat"
#define CONFIG_MPF_SOUND_ON_RECEIVE_URL "sound_on_receive_url"
#define CONFIG_MPF_SOUND_ON_RECEIVE_ERROR "sound_on_receive_error"
#define CONFIG_MPF_SOUND_BEEP_IF_NO_FILE "sound_beep_if_no_file"
#define CONFIG_MPF_SOUND_FILE_ON_USER_ONLINE "sound_file_on_user_online"
#define CONFIG_MPF_SOUND_FILE_ON_USER_OFFLINE "sound_file_on_user_offline"
#define CONFIG_MPF_SOUND_FILE_ON_RECEIVE_MESSAGE "sound_file_on_receive_message"
#define CONFIG_MPF_SOUND_FILE_ON_RECEIVE_CHAT "sound_file_on_receive_chat"
#define CONFIG_MPF_SOUND_FILE_ON_RECEIVE_URL "sound_file_on_receive_url"
#define CONFIG_MPF_SOUND_FILE_ON_RECEIVE_ERROR "sound_file_on_receive_error"

#define CONFIG_MPF_USE_DOCKLET "use_docklet"

#define CONFIG_MPF_LOG_LOCATION "log_location"
#define CONFIG_MPF_HISTORY_LOCATION "history_location"
#define CONFIG_MPF_USE_HISTORY "use_history"


#define CONFIG_MI_PERSONAL_FULL_NAME "full_name"
#define CONFIG_MI_PERSONAL_NAME_GIVEN "name_given"
#define CONFIG_MI_PERSONAL_NAME_FAMILY "name_family"
#define CONFIG_MI_PERSONAL_EMAIL "email"
#define CONFIG_MI_PERSONAL_URL "url"
#define CONFIG_MI_PERSONAL_TELEPHONE "telephone"

#define CONFIG_MI_LOCATION_STREET "street"
#define CONFIG_MI_LOCATION_EXTADD "extadd"
#define CONFIG_MI_LOCATION_LOCALITY "locality"
#define CONFIG_MI_LOCATION_REGION "region"
#define CONFIG_MI_LOCATION_PCODE "pcode"
#define CONFIG_MI_LOCATION_COUNTRY "country"

#define CONFIG_MI_ORG_ORGNAME "org_orgname"
#define CONFIG_MI_ORG_ORGUNIT "org_orgunit"
#define CONFIG_MI_TITLE "title"
#define CONFIG_MI_ROLE "role"

#define CONFIG_MI_ABOUT_DOB_DAY "dob_day"
#define CONFIG_MI_ABOUT_DOB_MONTH "dob_month"
#define CONFIG_MI_ABOUT_DOB_YEAR "dob_year"
#define CONFIG_MI_ABOUT_DESCRIPTION "description"

#define CONFIG_MI_OPTIONS_PUBLISH_IN_JUD "publish_in_jud"

#endif

#ifdef __cplusplus
}
#endif
