/* 
 * $RCSfile: gj_agents.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/05/31 12:17:55 $
 * 
 * $Revision: 1.3 $ 
 *
 */

#ifndef __gj_agents_h
#define __gj_agents_h

#include <glib.h>

#include <libxml/tree.h>

typedef struct t_agent *agent;

typedef void (*agentResponseProc)(GList *agents, gint error_code, gchar *error_message);

/* list functions */
gboolean agentInit();
gboolean agentTerm();

/* list functions */
GList *agentListGet();

/* item functions */
agent agentNew(gchar *jid);
void agentFree(agent ag);

gboolean agentSetJID(agent ag, gchar *jid);
gboolean agentSetName(agent ag, gchar *name);
gboolean agentSetDescription(agent ag, gchar *description);
gboolean agentSetTransport(agent ag, gchar *transport);
gboolean agentSetGroupchat(agent ag, gchar *groupchat);
gboolean agentSetService(agent ag, gchar *service);
gboolean agentSetRegisters(agent ag, gchar *registers);
gboolean agentSetSearch(agent ag, gchar *search);

gchar *agentGetJID(agent ag);
gchar *agentGetName(agent ag);
gchar *agentGetDescription(agent ag);
gchar *agentGetTransport(agent ag);
gchar *agentGetGroupchat(agent ag);
gchar *agentGetService(agent ag);
gchar *agentGetRegisters(agent ag);
gchar *agentGetSearch(agent ag);

gboolean agentListRequest(gchar *server, agentResponseProc proc);

agent agentFindByName(gchar *name);
agent agentFindByJID(gchar *jid);

/* debugging */
void agentPrint(agent ag);
void agentPrintAll();

#endif

