/* 
 * $RCSfile: gj_config_handler.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/04/22 10:54:28 $
 * 
 * $Revision: 1.2 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_config_handler_h
#define __gj_config_handler_h

#include <glib.h>

typedef struct
{
  gchar *key;
  gchar *value;

} configLine;

typedef struct
{
  gchar *name;
  GList *lines;

} configSection;

typedef struct
{
  GList *sections;

} configFile;

configFile *gj_config_handler_new(void);
configFile *gj_config_handler_open_file(gchar *filename);
gboolean gj_config_handler_write_file(configFile *cfg, gchar *filename);
void gj_config_handler_free(configFile *cfg);
configFile *gj_config_handler_open_default_file(void);
gboolean gj_config_handler_write_default_file(configFile *cfg);

gboolean gj_config_handler_read_string(configFile *cfg, gchar *section, gchar *key, gchar ** value);
gboolean gj_config_handler_read_int(configFile *cfg, gchar *section, gchar *key, gint *value);
gboolean gj_config_handler_read_boolean(configFile *cfg, gchar *section, gchar *key, gboolean *value);
gboolean gj_config_handler_read_float(configFile *cfg, gchar *section, gchar *key, gfloat *value);
gboolean gj_config_handler_read_double(configFile *cfg, gchar *section, gchar *key, gdouble *value);

void gj_config_handler_write_string(configFile *cfg, gchar *section, gchar *key, gchar *value);
void gj_config_handler_write_int(configFile *cfg, gchar *section, gchar *key, gint value);
void gj_config_handler_write_boolean(configFile *cfg, gchar *section, gchar *key, gboolean value);
void gj_config_handler_write_float(configFile *cfg, gchar *section, gchar *key, gfloat value);
void gj_config_handler_write_double(configFile *cfg, gchar *section, gchar *key, gdouble value);

void gj_config_handler_remove_key(configFile *cfg, gchar *section, gchar *key);

#ifdef __cplusplus
};
#endif

#endif
