/* 
 * $RCSfile: gj_event.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/04/22 10:54:28 $
 * 
 * $Revision: 1.2 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_event_h
#define __gj_event_h

#include <glib.h>

#include "gj_presence.h"
#include "gj_message.h"
#include "gj_roster.h"


/* 
 * event types
 */
typedef enum eventType {
  eventTypePresence = 1,
  eventTypeMessage,
  eventTypeFile,

  eventTypeEnd
} eventType;


typedef struct t_event *event;

typedef void (*eventProc)(gint eventID);

gboolean eventInit();
gboolean eventTerm();

/* item event functions */
#if 0
gboolean eventSetProc(event ev, eventProc proc);
eventProc eventGetProc(event ev);
#endif

gboolean eventSetResponseProc(eventProc proc);
eventProc eventGetResponseProc();

/* create/delete */
event eventNew(gchar *jid, eventType type, void *data);
gboolean eventNewByPostFromJID(gchar *jid, eventType type, void *data);
gboolean eventNewByPostFromRosterItem(rosterItem ri, eventType type, void *data);
gboolean eventFree(event ev);
gboolean eventFreeByID(gint eventID);

/* get */
event eventNth(gint index);
event eventNthByRosterItem(rosterItem ri, gint index);
gint eventIDNext(rosterItem ri);

/* utils */
gint eventCount(rosterItem ri);
gint eventCountByType(rosterItem ri, eventType type);

/* find */
event eventFindByEventID(gint eventID);
event eventFindNextByType(rosterItem ri, eventType type);
event eventFindNextByTypeAndMessageType(rosterItem ri, eventType type, messageType messageType);

/* member information */
gboolean eventSetRosterItem(event ev, rosterItem ri);

gint eventGetID(event ev);
gchar *eventGetJID(event ev);
eventType eventGetType(event ev);
void *eventGetData(event ev);
time_t eventGetTime(event ev);
rosterItem eventGetRosterItem(event ev);

gboolean eventSetRosterItem(event ev, rosterItem ri);


/* debugging */
void eventPrintAll(rosterItem ri);
void eventPrint(event ev);

#endif

#ifdef __cplusplus
}
#endif
