/*
 * $RCSfile: gj_gtk_about.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/06/08 13:18:46 $
 *
 * $Revision: 1.5 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/* gui */
#include <glade/glade.h>
#include <gtk/gtk.h>

/* local */
#include "common.h"

#include "gj_main.h"
#include "gj_gtk_about.h"
#include "gj_gtk_support.h"

/* local functions */
gboolean gj_gtk_about_setup(gchar *title, 
			    gchar *semititle, 
			    guint version_major, 
			    guint version_minor, 
			    guint version_revision, 
			    gchar *build, 
			    gchar *copyright, 
			    gchar *license,
			    gchar *sn);

void on_button_about_close_clicked(GtkButton *button, gpointer user_data);
gboolean on_about_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data);


struct 
{
    /* search */
    GtkWidget *window;

    GtkWidget *label_title;
    GtkWidget *label_semititle;
    GtkWidget *label_version;
    GtkWidget *label_build;
    GtkWidget *label_copyright;
    GtkWidget *label_license;
    GtkWidget *label_sn;

    GtkWidget *image_icon;

    GtkWidget *button_close;

} ctlAbout;

/*
 * external functions...
 */
gboolean gj_gtk_about_load(gchar *title, 
			   gchar *semititle, 
			   guint version_major, 
			   guint version_minor, 
			   guint version_revision, 
			   gchar *build, 
			   gchar *copyright, 
			   gchar *license,
			   gchar *sn)
{
    GladeXML *xml = NULL;

    if(ctlAbout.window != NULL)
      {
	gtk_window_present(GTK_WINDOW(ctlAbout.window));
	return FALSE;
      }
    
    /* check vars */
    if(title == NULL)
    {
	g_warning("gj_gtk_about_load: title was NULL");
	return FALSE;
    }

    if(semititle == NULL)
    {
	g_warning("gj_gtk_about_load: semititle was NULL");
	return FALSE;
    }

    if(version_major < 0 || version_minor < 0 || version_revision < 0)
    {
	g_warning("gj_gtk_about_load: version major:%d, minor:%d or revision:%d was < 0",
		  version_major,
		  version_minor,
		  version_revision);
	return FALSE;
    }

    if(build == NULL)
    {
	g_warning("gj_gtk_about_load: build was NULL");
	return FALSE;
    }

    if(copyright == NULL)
    {
	g_warning("gj_gtk_about_load: copyright was NULL");
	return FALSE;
    }

    if(license == NULL)
    {
	g_warning("gj_gtk_about_load: license was NULL");
	return FALSE;
    }

    if(sn == NULL)
    {
	g_warning("gj_gtk_about_load: serial number was NULL");
	return FALSE;
    }

    /* load dialog */
    if((xml = glade_xml_new(gnome_jabber_get_glade_file(), 
			    "about", 
			    NULL)) == NULL)
    {
	g_warning("gj_gtk_about_load: couldn't open glade file at root 'about'");
	return FALSE;
    }
  
    /* controls */
    ctlAbout.window = glade_xml_get_widget(xml, "about");

    ctlAbout.label_title = glade_xml_get_widget(xml, "label_about_title");
    ctlAbout.label_semititle = glade_xml_get_widget(xml, "label_about_semititle");
    ctlAbout.label_version = glade_xml_get_widget(xml, "label_about_version");
    ctlAbout.label_build = glade_xml_get_widget(xml, "label_about_build");
    ctlAbout.label_copyright = glade_xml_get_widget(xml, "label_about_copyright");
    ctlAbout.label_license = glade_xml_get_widget(xml, "label_about_license");
    ctlAbout.label_sn = glade_xml_get_widget(xml, "label_about_sn");

    ctlAbout.image_icon = glade_xml_get_widget(xml, "image_about_icon");

    ctlAbout.button_close = glade_xml_get_widget(xml, "button_about_close");

    gdk_window_set_decorations (GDK_WINDOW(ctlAbout.window->window), 
				GDK_DECOR_BORDER | GDK_DECOR_TITLE);

    /* signals */
#ifndef WIN32
    glade_xml_signal_autoconnect(xml);
#else
    gtk_signal_connect (GTK_OBJECT (ctlAbout.button_close), "clicked",
			GTK_SIGNAL_FUNC (on_button_about_close_clicked),
			NULL);
  
    gtk_signal_connect (GTK_OBJECT (ctlAbout.window), "delete_event",
			GTK_SIGNAL_FUNC (on_about_delete_event),
			NULL);    
#endif

    /* check window is created ok */
    if(ctlAbout.window == NULL)
    {
	g_warning("gj_gtk_about_load: failed to create message box, window was NULL");
	return FALSE;
    }

    g_message("gj_gtk_about_load: using title:'%s'", title);
    g_message("gj_gtk_about_load: using semititle:'%s'", semititle);
    g_message("gj_gtk_about_load: using version major:%d, minor:%d, revision:%d", 
	      version_major, version_minor, version_revision);
    g_message("gj_gtk_about_load: using build:'%s'", build);
    g_message("gj_gtk_about_load: using copyright:'%s'", copyright);
    g_message("gj_gtk_about_load: using license:'%s'", license);
    g_message("gj_gtk_about_load: using serial number:'%s'", sn);

    gj_gtk_about_setup(title,
		       semititle,
		       version_major,
		       version_minor,
		       version_revision,
		       build,
		       copyright,
		       license,
		       sn);

    if(xml != NULL)
    {
	g_object_unref(G_OBJECT(xml));
	xml = NULL;
    }

    return TRUE;
}

gboolean gj_gtk_about_unload()
{
    gtk_widget_destroy(ctlAbout.window);
    ctlAbout.window = NULL;

    return TRUE;
}

gboolean gj_gtk_about_setup(gchar *title, 
			    gchar *semititle, 
			    guint version_major, 
			    guint version_minor, 
			    guint version_revision, 
			    gchar *build, 
			    gchar *copyright, 
			    gchar *license,
			    gchar *sn)
{
    gchar *text = NULL;
    GdkPixbuf *pb = NULL;

#if defined G_OS_WIN32
    const char *os = "Windows";
#elif defined G_OS_UNIX
    const char *os = "Unix";
#elif defined G_OS_BEOS
    const char *os = "BeOS";
#else
    const char *os = "unknown operating system";
#endif

    if(title != NULL)
    {
	text = g_strdup_printf("<span size=\"xx-large\" weight=\"heavy\" stretch=\"ultraexpanded\">%s</span>", 
			       title);
	gtk_label_set_markup(GTK_LABEL(ctlAbout.label_title), text);
	g_free(text);
    }

    if(semititle != NULL)
    {
	text = g_strdup_printf("<span size=\"large\" weight=\"heavy\">%s</span>", 
			       semititle);
	gtk_label_set_markup(GTK_LABEL(ctlAbout.label_semititle), text);
	g_free(text);
    }
    
    if(version_major >= 0 && version_minor >=0 && version_revision >= 0)
    {
	text = g_strdup_printf("Version %d.%.2d.%1d", 
			       version_major,
			       version_minor,
			       version_revision);
	gtk_label_set_markup(GTK_LABEL(ctlAbout.label_version), text);
	g_free(text);
    }

    if(build != NULL)
    {
	text = g_strdup_printf("Build %s (for %s)", build, os);
	gtk_label_set_markup(GTK_LABEL(ctlAbout.label_build), text);
	g_free(text);
    }

    if(copyright != NULL)
	gtk_label_set_markup(GTK_LABEL(ctlAbout.label_copyright), copyright);
    
    if(license != NULL)
	gtk_label_set_markup(GTK_LABEL(ctlAbout.label_license), license);

    if(sn != NULL)
	gtk_label_set_markup(GTK_LABEL(ctlAbout.label_sn), sn);

    /* setting image */
    if((pb = gj_gtk_support_pixbuf_new_from_file(FILE_JSF)) != NULL)
      {
	gtk_image_set_from_pixbuf(GTK_IMAGE(ctlAbout.image_icon), pb);
	g_object_unref(G_OBJECT(pb));
      }

    return TRUE;
}

/*
 * actual gui functions
 */

void on_button_about_close_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_about_unload();
}

gboolean on_about_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
  gj_gtk_about_unload();
  return TRUE;
}

#ifdef __cplusplus
}
#endif
