#ifndef __gj_gtk_chat_h
#define __gj_gtk_chat_h

typedef struct t_chatWindow *chatWindow;

chatWindow gj_gtk_cw_find_by_jid(gchar *jid);
chatWindow gj_gtk_cw_find_by_widget(GtkWidget *widget);
chatWindow gj_gtk_cw_find_by_last_recv_xevent_id(gchar *message_id);
chatWindow gj_gtk_cw_find_by_last_sent_xevent_id(gchar *message_id);
chatWindow gj_gtk_cw_find_by_thread(gchar *thread);

void gj_gtk_cw_print_all();
void gj_gtk_cw_print(chatWindow cw);

/* 
 * member functions 
 */

/* gets */
gchar *gj_gtk_cw_get_jid(chatWindow cw);
gchar *gj_gtk_cw_get_nickname(chatWindow cw);
gchar *gj_gtk_cw_get_groups(chatWindow cw);
gchar *gj_gtk_cw_get_thread(chatWindow cw);

GtkTreeIter *gj_gtk_cw_get_iter(chatWindow cw);

gboolean gj_gtk_cw_get_reverse_text_direction(chatWindow cw);

gint gj_gtk_cw_get_last_recv_xevent_type(chatWindow cw);
gchar *gj_gtk_cw_get_last_recv_xevent_id(chatWindow cw);

gint gj_gtk_cw_get_last_sent_xevent_type(chatWindow cw);
gchar *gj_gtk_cw_get_last_sent_xevent_id(chatWindow cw);

/* sets */
gboolean gj_gtk_cw_set_jid(chatWindow cw, gchar *jid);
gboolean gj_gtk_cw_set_nickname(chatWindow cw, gchar *nickname);
gboolean gj_gtk_cw_set_groups(chatWindow cw, gchar *groups);
gboolean gj_gtk_cw_set_thread(chatWindow cw, gchar *thread);

gboolean gj_gtk_cw_set_reverse_text_direction(chatWindow cw, gboolean reverse_text_direction);

gboolean gj_gtk_cw_set_last_recv_xevent_type(chatWindow cw, gint type);
gboolean gj_gtk_cw_set_last_recv_xevent_id(chatWindow cw, gchar *id);

gboolean gj_gtk_cw_set_last_sent_xevent_type(chatWindow cw, gint type);
gboolean gj_gtk_cw_set_last_sent_xevent_id(chatWindow cw, gchar *id);

/* 
 * window functions 
 */
chatWindow gj_gtk_cw_notification_new(message msg);
void gj_gtk_cw_notification_of_xevent_new(chatWindow cw, message msg);
void gj_gtk_cw_default_action(gchar *jid); 

chatWindow gj_gtk_cw_receive_new(gchar *jid);
chatWindow gj_gtk_cw_send_new(gchar *jid);

gboolean gj_gtk_cw_show(chatWindow cw, gboolean show);

void gj_gtk_cw_presence_update(chatWindow cw, presence pres);


#endif
