/* 
 * $RCSfile: gj_gtk_my_information.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/02 00:06:31 $
 * 
 * $Revision: 1.7 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>
#include <glade/glade.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_GNOME
#include <gnome.h>
#endif

#include "common.h"

#include "gj_main.h"
#include "gj_iq_requests.h"
#include "gj_parser.h"

#include "gj_gtk_my_information.h"
#include "gj_gtk_connection_settings.h"

struct 
{
  GtkWidget *window;
  
  GtkWidget *entry_full_name;
  GtkWidget *entry_name_given;
  GtkWidget *entry_name_family;
  GtkWidget *entry_name_nickname;

  GtkWidget *entry_email;
  GtkWidget *entry_url;
  GtkWidget *entry_tel;
  
  GtkWidget *entry_street;
  GtkWidget *entry_extadd;
  GtkWidget *entry_locality;
  GtkWidget *entry_region;
  GtkWidget *entry_pcode;
  GtkWidget *entry_country;

  GtkWidget *entry_org_orgname;
  GtkWidget *entry_org_orgunit;
  GtkWidget *entry_title;
  GtkWidget *entry_role;
  
  GtkWidget *calendar_dob;
  GtkWidget *textview_description;
  
  GtkWidget *checkbutton_publish_in_jud;
  
  GtkWidget *button_ok;
  GtkWidget *button_apply;
  GtkWidget *button_cancel;

} ctlMI;

void on_button_mi_ok_clicked(GtkButton *button, gpointer user_data);
void on_button_mi_apply_clicked(GtkButton *button, gpointer user_data);
void on_button_mi_cancel_clicked(GtkButton *button, gpointer user_data);

gboolean on_my_information_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data);

gboolean gj_gtk_mi_set();
gboolean gj_gtk_mi_get();

void gj_gtk_mi_set_entry(GtkWidget *widget, gchar *fmt, ...);

void gj_gtk_mi_vcard_response(guint id);

/*
 * code
 */
gboolean gj_gtk_mi_load()
{
  GladeXML *xml = NULL;

  if((xml = glade_xml_new(gnome_jabber_get_glade_file(),
			  "my_information",
			  NULL)) == NULL)
    {
      g_warning("gj_gtk_mi_load: couldn't open glade file at root 'my_information'");
      return FALSE;
    }
  
  ctlMI.window = glade_xml_get_widget(xml,"my_information");

  ctlMI.entry_full_name = glade_xml_get_widget(xml,"entry_mi_full_name");
  ctlMI.entry_name_given = glade_xml_get_widget(xml,"entry_mi_name_given");
  ctlMI.entry_name_family = glade_xml_get_widget(xml,"entry_mi_name_family");
  ctlMI.entry_name_nickname = glade_xml_get_widget(xml,"entry_mi_name_nickname");

  ctlMI.entry_email = glade_xml_get_widget(xml,"entry_mi_email");
  ctlMI.entry_url = glade_xml_get_widget(xml,"entry_mi_url");
  ctlMI.entry_tel = glade_xml_get_widget(xml,"entry_mi_tel");
  
  ctlMI.entry_street = glade_xml_get_widget(xml,"entry_mi_street");
  ctlMI.entry_extadd = glade_xml_get_widget(xml,"entry_mi_extadd");
  ctlMI.entry_locality = glade_xml_get_widget(xml,"entry_mi_locality");
  ctlMI.entry_region = glade_xml_get_widget(xml,"entry_mi_region");
  ctlMI.entry_pcode = glade_xml_get_widget(xml,"entry_mi_pcode");
  ctlMI.entry_country = glade_xml_get_widget(xml,"entry_mi_country");

  ctlMI.entry_org_orgname = glade_xml_get_widget(xml,"entry_mi_org_orgname");
  ctlMI.entry_org_orgunit = glade_xml_get_widget(xml,"entry_mi_org_orgunit");
  ctlMI.entry_title = glade_xml_get_widget(xml,"entry_mi_title");
  ctlMI.entry_role = glade_xml_get_widget(xml,"entry_mi_role");
  
  ctlMI.calendar_dob = glade_xml_get_widget(xml,"calendar_mi_dob");
  ctlMI.textview_description = glade_xml_get_widget(xml,"textview_mi_description");
  
  ctlMI.checkbutton_publish_in_jud = glade_xml_get_widget(xml,"checkbutton_mi_publish_in_jud");
  
  ctlMI.button_ok = glade_xml_get_widget(xml,"button_mi_apply");
  ctlMI.button_apply = glade_xml_get_widget(xml,"button_mi_apply");
  ctlMI.button_cancel = glade_xml_get_widget(xml,"button_mi_cancel");
  
#ifndef WIN32
  glade_xml_signal_autoconnect(xml);
#else
  gtk_signal_connect (GTK_OBJECT (ctlMI.window), "delete_event",
                      GTK_SIGNAL_FUNC (on_my_information_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMI.button_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mi_cancel_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMI.button_apply), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mi_apply_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMI.button_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mi_ok_clicked),
                      NULL);
#endif

  /* get my information */
  gj_gtk_mi_get();

  /* clean up */
  if(xml != NULL)
    {
      g_object_unref(G_OBJECT(xml));
      xml = NULL;
    }

  return TRUE;
}

gboolean gj_gtk_mi_unload()
{
  if(ctlMI.window == NULL)
    return TRUE;

  gtk_widget_destroy(ctlMI.window);

  ctlMI.window = NULL;

  ctlMI.entry_full_name = NULL;
  ctlMI.entry_name_given = NULL;
  ctlMI.entry_name_family = NULL;
  ctlMI.entry_name_nickname = NULL;

  ctlMI.entry_email = NULL;
  ctlMI.entry_url = NULL;
  ctlMI.entry_tel = NULL;
  
  ctlMI.entry_street = NULL;
  ctlMI.entry_extadd = NULL;
  ctlMI.entry_locality = NULL;
  ctlMI.entry_region = NULL;
  ctlMI.entry_pcode = NULL;
  ctlMI.entry_country = NULL;

  ctlMI.entry_org_orgname = NULL;
  ctlMI.entry_org_orgunit = NULL;
  ctlMI.entry_title = NULL;
  ctlMI.entry_role = NULL;
  
  ctlMI.calendar_dob = NULL;
  ctlMI.textview_description = NULL;
  
  ctlMI.checkbutton_publish_in_jud = NULL;
  
  ctlMI.button_ok = NULL;
  ctlMI.button_apply = NULL;
  ctlMI.button_cancel = NULL;

  return TRUE;
}

gboolean gj_gtk_mi_set()
{
  GtkTextBuffer *buffer = NULL;
  GtkTextIter bufStart;
  GtkTextIter bufStop;

  gchar *full_name = NULL;
  gchar *name_given = NULL;
  gchar *name_family = NULL;
  gchar *name_nickname = NULL;

  gchar *email = NULL;
  gchar *url = NULL;
  gchar *tel = NULL;
  
  gchar *street = NULL;
  gchar *extadd = NULL;
  gchar *locality = NULL;
  gchar *region = NULL;
  gchar *pcode = NULL;
  gchar *country = NULL;
  
  gchar *org_orgname = NULL;
  gchar *org_orgunit = NULL;
  gchar *title = NULL;
  gchar *role = NULL;

  guint dob_day = 0;
  guint dob_month = 0;
  guint dob_year = 0;

  gchar *dob = NULL;
  gchar *description = NULL;
  
  gboolean publish_in_jud = FALSE;

  /* get values */
  if((publish_in_jud = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMI.checkbutton_publish_in_jud))) == FALSE)
    {
      g_message("gj_gtk_mi_save: publishing information on 'personal' page in Jabber User Directory!");

      full_name = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_full_name),0,-1);
      name_given = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_name_given),0,-1); 
      name_family = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_name_family),0,-1);
      name_nickname = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_name_nickname),0,-1);
      email = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_email),0,-1);
      url = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_url),0,-1);
      tel = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_tel),0,-1);
    }

  street = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_street),0,-1);
  extadd = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_extadd),0,-1);
  locality = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_locality),0,-1);
  region = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_region),0,-1);
  pcode = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_pcode),0,-1);
  country = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_country),0,-1);

  org_orgname = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_org_orgname),0,-1);
  org_orgunit = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_org_orgunit),0,-1);
  title = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_title),0,-1);
  role = gtk_editable_get_chars(GTK_EDITABLE(ctlMI.entry_role),0,-1);

  gtk_calendar_get_date(GTK_CALENDAR(ctlMI.calendar_dob), &dob_year, &dob_month, &dob_day);
  dob = g_strdup_printf("%d-%d-%d", dob_year, ++dob_month, dob_day);

  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(ctlMI.textview_description));
  gtk_text_buffer_get_iter_at_offset(buffer, &bufStart, 0);
  gtk_text_buffer_get_iter_at_offset(buffer, &bufStop, -1);
  description = gtk_text_buffer_get_text(buffer,&bufStart,&bufStop,TRUE);

  /* save vcard */
  infoqueryRequestVCardChange(full_name,
			      name_given,
			      name_family,
			      name_nickname, /* nickname */
			      url,
			      tel,
			      email,
			      description,
			      dob,
			      street,
			      extadd,
			      locality,
			      region,
			      pcode,
			      country,
			      org_orgname,
			      org_orgunit,
			      title,
			      role,
			      gj_gtk_mi_set_response);
  
  /* print to log changes... */
  g_message("gj_gtk_mi_save: saving VCard:\n\tname - full:'%s'\n\tname - given:'%s'\n\tname - family:'%s'\n\tname - nickname:'%s'\n\turl:'%s'\n\ttelephone:'%s'\n\temail:'%s'\n\tdescription:'%s'\n\tdob:'%s'\n\tstreet:'%s'\n\textadd:'%s'\n\tlocality:'%s'\n\tregion:'%s'\n\tpcode:'%s'\n\tcountry:'%s'\n\torg_name:'%s'\n\torg_unit:'%s'\n\ttitle:'%s'\n\trole:'%s'",
	    full_name,
	    name_given,
	    name_family,
	    name_nickname,
	    url,
	    tel,
	    email,
	    description,
	    dob,
	    street,
	    extadd,
	    locality,
	    region,
	    pcode,
	    country,
	    org_orgname,
	    org_orgunit,
	    title,
	    role);

  /* clean up */
  if(full_name != NULL) g_free(full_name);
  if(name_given != NULL) g_free(name_given);
  if(name_family != NULL) g_free(name_family);
  if(name_nickname != NULL) g_free(name_nickname);
  if(email != NULL) g_free(email);
  if(url != NULL) g_free(url);
  if(tel != NULL) g_free(tel);
  
  if(street != NULL) g_free(street);
  if(extadd != NULL) g_free(extadd);
  if(locality != NULL) g_free(locality);
  if(region != NULL) g_free(region);
  if(pcode != NULL) g_free(pcode);
  if(country != NULL) g_free(country);
  
  if(org_orgname != NULL) g_free(org_orgname);
  if(org_orgunit != NULL) g_free(org_orgunit);
  if(title != NULL) g_free(title);
  if(role != NULL) g_free(role);

  if(dob != NULL) g_free(dob);
  if(description != NULL) g_free(description);

  return TRUE;
}

gboolean gj_gtk_mi_get()
{
  gchar *jid = NULL;

  /* get information from config */
  jid = g_strdup_printf("%s@%s", gj_gtk_cs_get_username(), gj_gtk_cs_get_server());
  infoqueryRequestVCard(jid, gj_gtk_mi_vcard_response,NULL);

  /* cleanup */
  if(jid != NULL) g_free(jid);

  return TRUE;
}

void gj_gtk_mi_set_entry(GtkWidget *widget, gchar *fmt, ...)
{
  va_list args;
  gchar *buffer = NULL;

  if(widget == NULL)
    {
      g_warning("gj_gtk_mi_set_entry: widget was NULL");
      return;
    }
  
  va_start(args,fmt);
  buffer = g_strdup_vprintf(fmt,args);
  va_end(args);

  if(buffer == NULL)
    {
      g_warning("gj_gtk_mi_set_entry: buffer to use was NULL");
      return;
    }

  gtk_entry_set_text(GTK_ENTRY(widget),buffer);
}

void gj_gtk_mi_set_response(guint eventID)
{
  /* !!!!!!!! NEED TO CHECK FOR ERRORS here */
  infoquery iq = NULL;
  infoquery iq_related = NULL;

  xmlChar *type = NULL;
  xmlNodePtr node = NULL;

  g_message("gj_gtk_mi_set_response: received eventIDRelated:%d",eventID);

  if((iq = infoqueryFindByEventID(eventID)) == NULL)
    {
      g_warning("gj_gtk_mi_set_response: failed to find IQ based on eventID:%d",eventID);
      return;
    }

  if((iq_related = infoqueryFindByEventIDRelated(eventID)) == NULL)
    {
      g_warning("gj_gtk_mi_set_response: failed to find IQ based on eventIDRelated:%d",eventID);
      return;
    }

  node = infoqueryGetXML(iq_related);
  type = parserFindByAttrAndReturn(node, (guchar*)"type");

  if(type != NULL && xmlStrcmp(type, (guchar*)"error") == 0)
    {
      gchar *detail = NULL;

      xmlChar *errorCode = NULL;
      xmlChar *errorMessage = NULL;

      if((node = parserFindByNode(node, (guchar*)"error")) == NULL)
	{
	  g_warning("gj_gtk_mi_set_response: failed to find node 'error'");

	  infoqueryFreeByEventID(eventID);
	  return;
	}

      if((errorCode = parserFindByAttrAndReturn(node, (guchar*)"code")) != NULL)
	{
	  detail = g_strdup_printf("Error:%s",errorCode);
	}

      if((errorMessage = parserFindByNodeAndReturn(node, (guchar*)"error")) != NULL) 
	{
	  if(detail != NULL)
	    detail = g_strdup_printf("%s - %s",detail,errorMessage);
	}

      g_warning("gj_gtk_mi_set_response: IQ type is error, eventID:%d",eventID);

      /* clean up */
      g_free(detail);
      infoqueryFreeEventAndRelatedByEventID(eventID);
     
      return;
    }

  /* clean up */
  infoqueryFreeEventAndRelatedByEventID(eventID);
}

void gj_gtk_mi_vcard_response(guint id)
{
  GtkTextBuffer *buffer = NULL;

  xmlChar *tmp = NULL;
  infoquery iq = NULL;

  g_message("gj_gtk_mi_vcard_response: response with eventID:%d",id);

  if((iq = infoqueryFindByEventIDRelated(id)) == NULL)
    {
      g_warning("gj_gtk_mi_vcard_response: failed to find IQ based on eventIDRelated:%d",id);

      return;
    }

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"fn");
  gj_gtk_mi_set_entry(ctlMI.entry_full_name, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"given");
  gj_gtk_mi_set_entry(ctlMI.entry_name_given, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"family");
  gj_gtk_mi_set_entry(ctlMI.entry_name_family, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"nickname");
  gj_gtk_mi_set_entry(ctlMI.entry_name_nickname, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"url");
  gj_gtk_mi_set_entry(ctlMI.entry_url, "%s",tmp?(gchar*)tmp:"");
  
  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"tel");
  gj_gtk_mi_set_entry(ctlMI.entry_tel, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"email");
  gj_gtk_mi_set_entry(ctlMI.entry_email, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"desc");
  if(tmp != NULL && xmlStrlen(tmp) > 0)
    {
      buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(ctlMI.textview_description));
      gtk_text_buffer_set_text(buffer,(gchar*)tmp,-1);
    }

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"bday");
  if(tmp != NULL && xmlStrlen(tmp) > 0)
    {
      /* NOTE: this must comply with ISO 8601 which shows the date
	       in the format YYYY-MM-DD
      */
      gchar **vDate = NULL;
      vDate = g_strsplit((gchar*)tmp,"-",4);
     
      if(vDate != NULL && vDate[0] != NULL && vDate[1] != NULL && vDate[2] != NULL)
	{
	  gtk_calendar_select_day(GTK_CALENDAR(ctlMI.calendar_dob), atoi(vDate[2]));
	  gtk_calendar_select_month(GTK_CALENDAR(ctlMI.calendar_dob), atoi(vDate[1])-1, atoi(vDate[0]));
				    
	  g_strfreev(vDate);
	}
      else
	g_warning("gj_gtk_mi_vcard_response: could not get birth date from:'%s' on vcard",tmp);
    }

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"street");
  gj_gtk_mi_set_entry(ctlMI.entry_street, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"extadd");
  gj_gtk_mi_set_entry(ctlMI.entry_extadd, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"locality");
  gj_gtk_mi_set_entry(ctlMI.entry_locality, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"region");
  gj_gtk_mi_set_entry(ctlMI.entry_region, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"pcode");
  gj_gtk_mi_set_entry(ctlMI.entry_pcode, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"country");
  gj_gtk_mi_set_entry(ctlMI.entry_country, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"orgname");
  gj_gtk_mi_set_entry(ctlMI.entry_org_orgname, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"orgunit");
  gj_gtk_mi_set_entry(ctlMI.entry_org_orgunit, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"title");
  gj_gtk_mi_set_entry(ctlMI.entry_title, "%s",tmp?(gchar*)tmp:"");

  tmp = parserFindByNodeAndReturn(infoqueryGetXML(iq), (guchar*)"role");
  gj_gtk_mi_set_entry(ctlMI.entry_role, "%s",tmp?(gchar*)tmp:"");

  /* clean up */
  infoqueryFreeEventAndRelatedByRelatedID(id);
}

/*
 * GUI events
 */
void on_button_mi_ok_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mi_set();
  gj_gtk_mi_unload();
}

void on_button_mi_apply_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mi_set();
}

void on_button_mi_cancel_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mi_unload();
}

gboolean on_my_information_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
  gj_gtk_mi_unload();

  return TRUE;
}

#ifdef __cplusplus
}
#endif
