
/* 
 * $RCSfile: gj_gtk_my_preferences.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/06/08 13:18:46 $
 * 
 * $Revision: 1.6 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "common.h"

#include "gj_main.h"
#include "gj_roster.h"
#include "gj_config.h"
#include "gj_me.h"

#include "gj_gtk_roster.h"
#include "gj_gtk_my_preferences.h"

struct 
{
  GtkWidget *window;

  GtkWidget *checkbutton_hide_offline_contacts;
  GtkWidget *checkbutton_hide_offline_group;
  GtkWidget *checkbutton_hide_agents;

  GtkWidget *checkbutton_close_previous_message_window_on_reply;
  GtkWidget *checkbutton_raise_window_on_new_message;
  GtkWidget *checkbutton_hide_time;
  GtkWidget *checkbutton_reverse_text_direction;

  GtkWidget *checkbutton_use_spell_checker;

  GtkWidget *spinbutton_auto_away_after;
  GtkWidget *spinbutton_auto_xa_after;
  GtkWidget *textview_auto_away_status;
  GtkWidget *textview_auto_xa_status;

  GtkWidget *entry_browse_log_location;

  GtkWidget *file_selector;

  GtkWidget *button_browse_sound_on_user_online;
  GtkWidget *button_browse_sound_on_user_offline;
  GtkWidget *button_browse_sound_on_receive_message;
  GtkWidget *button_browse_sound_on_receive_chat;
  GtkWidget *button_browse_sound_on_receive_url;
  GtkWidget *button_browse_sound_on_receive_error;

  GtkWidget *table_sound;
/*  GtkWidget *checkbutton_sound_enabled;*/
  GtkWidget *checkbutton_sound_on_user_online;
  GtkWidget *checkbutton_sound_on_user_offline;
  GtkWidget *checkbutton_sound_on_receive_message;
  GtkWidget *checkbutton_sound_on_receive_chat;
  GtkWidget *checkbutton_sound_on_receive_url;
  GtkWidget *checkbutton_sound_on_receive_error;
/*  GtkWidget *checkbutton_sound_beep_if_no_file;*/
  GtkWidget *entry_sound_file_on_user_online;
  GtkWidget *entry_sound_file_on_user_offline;
  GtkWidget *entry_sound_file_on_receive_message;
  GtkWidget *entry_sound_file_on_receive_chat;
  GtkWidget *entry_sound_file_on_receive_url;
  GtkWidget *entry_sound_file_on_receive_error;
/*  GtkWidget *entry_sound_beep_if_no_file;*/

  GtkWidget *checkbutton_use_docklet;

  GtkWidget *button_browse_log_location;
  GtkWidget *button_browse_history_location;
  GtkWidget *checkbutton_use_history;
  GtkWidget *entry_browse_history_location;
    
  GtkWidget *button_ok;
  GtkWidget *button_apply;
  GtkWidget *button_cancel;

} ctlMPF;

struct
{
  gboolean hide_offline_contacts;
  gboolean hide_offline_group;
  gboolean hide_agents;

  gboolean close_previous_message_window_on_reply;
  gboolean raise_window_on_new_message;
  gboolean hide_time;
  gboolean reverse_text_direction;

  gboolean use_spell_checker;

  gint auto_away_after;
  gint auto_xa_after;
  gchar *auto_away_status;
  gchar *auto_xa_status;

  gboolean sound_enabled;
  gboolean sound_on_user_online;
  gboolean sound_on_user_offline;
  gboolean sound_on_receive_message;
  gboolean sound_on_receive_chat;
  gboolean sound_on_receive_url;
  gboolean sound_on_receive_error;
  gboolean sound_beep_if_no_file;
  gchar *sound_file_on_user_online;
  gchar *sound_file_on_user_offline;
  gchar *sound_file_on_receive_message;
  gchar *sound_file_on_receive_chat;
  gchar *sound_file_on_receive_url;
  gchar *sound_file_on_receive_error;

  gboolean use_docklet;

  gchar *log_location;
  gchar *history_location;
  gboolean use_history;

} optMPF;

#define BROWSE_SOUND_ON_USER_ONLINE 1
#define BROWSE_SOUND_ON_USER_OFFLINE 2
#define BROWSE_SOUND_ON_RECEIVE_MESSAGE 3
#define BROWSE_SOUND_ON_RECEIVE_CHAT 4
#define BROWSE_SOUND_ON_RECEIVE_URL 5
#define BROWSE_SOUND_ON_RECEIVE_ERROR 6
#define BROWSE_LOG_LOCATION 7
#define BROWSE_HISTORY_LOCATION 8

gboolean gj_gtk_mpf_set();

void gj_gtk_mpf_store_filename(GtkFileSelection *file_selector, gpointer user_data);
void gj_gtk_mpf_create_file_selection(guint sound);

/*
 * GUI functions
 */
void on_checkbutton_mpf_sound_enabled_toggled(GtkToggleButton *togglebutton, gpointer user_data);
void on_checkbutton_mpf_hide_offline_contacts_toggled(GtkToggleButton *togglebutton, gpointer user_data);

void on_button_mpf_browse_sound_on_user_online_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_browse_sound_on_user_offline_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_browse_sound_on_receive_message_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_browse_sound_on_receive_chat_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_browse_sound_on_receive_url_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_browse_sound_on_receive_error_clicked(GtkButton *button, gpointer user_data);

void on_button_mpf_browse_log_location_clicked(GtkButton *button, gpointer user_data);

void on_checkbutton_mpf_use_history_toggled(GtkToggleButton *togglebutton, gpointer user_data);
void on_button_mpf_browse_history_location_clicked(GtkButton *button, gpointer user_data);


void on_button_mpf_ok_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_apply_clicked(GtkButton *button, gpointer user_data);
void on_button_mpf_cancel_clicked(GtkButton *button, gpointer user_data);

gboolean on_my_preferences_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data);

/*
 * code
 */
gboolean gj_gtk_mpf_load()
{
  GladeXML *xml = NULL;

  GtkTextBuffer *buffer = NULL;
  GtkTextIter iter;

  if(ctlMPF.window != NULL)
    {
      g_message("showing");
      gtk_window_present(GTK_WINDOW(ctlMPF.window));
      return TRUE;
    }

  if((xml = glade_xml_new(gnome_jabber_get_glade_file(),
			  "my_preferences",
			  NULL)) == NULL)
    {
      g_warning("gj_gtk_mpf_load: couldn't open glade file at root 'my_preferences'");
      return FALSE;
    }
  
  ctlMPF.window = glade_xml_get_widget(xml,"my_preferences");

  ctlMPF.checkbutton_hide_offline_contacts = glade_xml_get_widget(xml,"checkbutton_mpf_hide_offline_contacts");
  ctlMPF.checkbutton_hide_offline_group = glade_xml_get_widget(xml,"checkbutton_mpf_hide_offline_group");
  ctlMPF.checkbutton_hide_agents = glade_xml_get_widget(xml,"checkbutton_mpf_hide_agents");

  ctlMPF.checkbutton_close_previous_message_window_on_reply = glade_xml_get_widget(xml,"checkbutton_mpf_close_previous_message_window_on_reply");
  ctlMPF.checkbutton_raise_window_on_new_message = glade_xml_get_widget(xml,"checkbutton_mpf_raise_window_on_new_message");
  ctlMPF.checkbutton_hide_time = glade_xml_get_widget(xml,"checkbutton_mpf_hide_time");
  ctlMPF.checkbutton_reverse_text_direction = glade_xml_get_widget(xml,"checkbutton_mpf_reverse_text_direction");

  ctlMPF.checkbutton_use_spell_checker = glade_xml_get_widget(xml,"checkbutton_mpf_use_spell_checker");

  ctlMPF.spinbutton_auto_away_after = glade_xml_get_widget(xml,"spinbutton_mpf_auto_away_after");
  ctlMPF.spinbutton_auto_xa_after = glade_xml_get_widget(xml,"spinbutton_mpf_auto_xa_after");
  ctlMPF.textview_auto_away_status = glade_xml_get_widget(xml,"textview_mpf_auto_away_status");
  ctlMPF.textview_auto_xa_status = glade_xml_get_widget(xml,"textview_mpf_auto_xa_status");

  ctlMPF.entry_browse_log_location = glade_xml_get_widget(xml,"entry_mpf_browse_log_location");

  ctlMPF.button_browse_sound_on_user_online = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_user_online");
  ctlMPF.button_browse_sound_on_user_offline = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_user_offline");
  ctlMPF.button_browse_sound_on_receive_message = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_receive_message");
  ctlMPF.button_browse_sound_on_receive_chat = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_receive_chat");
  ctlMPF.button_browse_sound_on_receive_url = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_receive_url");
  ctlMPF.button_browse_sound_on_receive_error = glade_xml_get_widget(xml,"button_mpf_browse_sound_on_receive_error");

  ctlMPF.table_sound = glade_xml_get_widget(xml,"table_mpf_sound");
/*  ctlMPF.checkbutton_sound_enabled = glade_xml_get_widget(xml,"checkbutton_mpf_sound_enabled");*/
  ctlMPF.checkbutton_sound_on_user_online = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_user_online");
  ctlMPF.checkbutton_sound_on_user_offline = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_user_offline");
  ctlMPF.checkbutton_sound_on_receive_message = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_receive_message");
  ctlMPF.checkbutton_sound_on_receive_chat = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_receive_chat");
  ctlMPF.checkbutton_sound_on_receive_url = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_receive_url");
  ctlMPF.checkbutton_sound_on_receive_error = glade_xml_get_widget(xml,"checkbutton_mpf_sound_on_receive_error");
/*  ctlMPF.checkbutton_sound_beep_if_no_file = glade_xml_get_widget(xml,"checkbutton_mpf_sound_beep_if_no_file");*/
  ctlMPF.entry_sound_file_on_user_online = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_user_online");
  ctlMPF.entry_sound_file_on_user_offline = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_user_offline");
  ctlMPF.entry_sound_file_on_receive_message = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_receive_message");
  ctlMPF.entry_sound_file_on_receive_chat = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_receive_chat");
  ctlMPF.entry_sound_file_on_receive_url = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_receive_url");
  ctlMPF.entry_sound_file_on_receive_error = glade_xml_get_widget(xml,"entry_mpf_browse_sound_on_receive_error");

  ctlMPF.checkbutton_use_docklet = glade_xml_get_widget(xml,"checkbutton_mpf_use_docklet");

  ctlMPF.button_browse_log_location = glade_xml_get_widget(xml,"button_mpf_browse_log_location");
  ctlMPF.button_browse_history_location = glade_xml_get_widget(xml,"button_mpf_browse_history_location");
  ctlMPF.checkbutton_use_history = glade_xml_get_widget(xml,"checkbutton_mpf_use_history");
  ctlMPF.entry_browse_history_location = glade_xml_get_widget(xml,"entry_mpf_browse_history_location");

  ctlMPF.button_ok = glade_xml_get_widget(xml,"button_mpf_apply");
  ctlMPF.button_apply = glade_xml_get_widget(xml,"button_mpf_apply");
  ctlMPF.button_cancel = glade_xml_get_widget(xml,"button_mpf_cancel");
  
#ifndef WIN32
  glade_xml_signal_autoconnect(xml);
#else
  gtk_signal_connect (GTK_OBJECT (ctlMPF.window), "delete_event",
                      GTK_SIGNAL_FUNC (on_my_preferences_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.checkbutton_hide_offline_contacts), "toggled",
                      GTK_SIGNAL_FUNC (on_checkbutton_mpf_hide_offline_contacts_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_browse_sound_on_user_online), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_browse_sound_on_user_online_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_browse_sound_on_user_offline), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_browse_sound_on_user_offline_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_browse_sound_on_receive_message), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_browse_sound_on_receive_message_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_browse_sound_on_receive_chat), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_browse_sound_on_receive_chat_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_browse_sound_on_receive_url), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_browse_sound_on_receive_url_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_browse_sound_on_receive_error), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_browse_sound_on_receive_error_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_browse_log_location), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_browse_log_location_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_browse_history_location), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_browse_history_location_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.checkbutton_use_history), "toggled",
                      GTK_SIGNAL_FUNC (on_checkbutton_mpf_use_history_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_cancel_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_apply), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_apply_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ctlMPF.button_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_button_mpf_ok_clicked),
                      NULL);
#endif

  /* get settings */
  gj_gtk_mpf_get();

  /* set up settings */
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_user_online),optMPF.sound_on_user_online);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_user_offline),optMPF.sound_on_user_offline);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_message),optMPF.sound_on_receive_message);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_chat),optMPF.sound_on_receive_chat);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_url),optMPF.sound_on_receive_url);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_error),optMPF.sound_on_receive_error);

  if(optMPF.sound_file_on_user_online != NULL && strlen(optMPF.sound_file_on_user_online) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_online),optMPF.sound_file_on_user_online);
  if(optMPF.sound_file_on_user_offline != NULL && strlen(optMPF.sound_file_on_user_offline) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_offline),optMPF.sound_file_on_user_offline);
  if(optMPF.sound_file_on_receive_message != NULL && strlen(optMPF.sound_file_on_receive_message) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_message),optMPF.sound_file_on_receive_message);
  if(optMPF.sound_file_on_receive_chat != NULL && strlen(optMPF.sound_file_on_receive_chat) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_chat),optMPF.sound_file_on_receive_chat);
  if(optMPF.sound_file_on_receive_url != NULL && strlen(optMPF.sound_file_on_receive_url) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_url),optMPF.sound_file_on_receive_url);
  if(optMPF.sound_file_on_receive_error != NULL && strlen(optMPF.sound_file_on_receive_error) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_error),optMPF.sound_file_on_receive_error);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_offline_contacts),optMPF.hide_offline_contacts);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_offline_group),optMPF.hide_offline_group);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_agents),optMPF.hide_agents);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_close_previous_message_window_on_reply),optMPF.close_previous_message_window_on_reply);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_raise_window_on_new_message),optMPF.raise_window_on_new_message);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_time),optMPF.hide_time);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_reverse_text_direction),optMPF.reverse_text_direction);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_spell_checker),optMPF.use_spell_checker);

  gtk_spin_button_set_value(GTK_SPIN_BUTTON(ctlMPF.spinbutton_auto_away_after),(gdouble)optMPF.auto_away_after);
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(ctlMPF.spinbutton_auto_xa_after),(gdouble)optMPF.auto_xa_after);
  
  if(optMPF.auto_away_status != NULL && strlen(optMPF.auto_away_status) > 0)
    {
      buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(ctlMPF.textview_auto_away_status));
      gtk_text_buffer_get_start_iter(buffer, &iter);
      gtk_text_buffer_insert(buffer, &iter, optMPF.auto_away_status, strlen(optMPF.auto_away_status));
    }

  if(optMPF.auto_xa_status != NULL && strlen(optMPF.auto_xa_status) > 0)
    {
      buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(ctlMPF.textview_auto_xa_status));
      gtk_text_buffer_get_start_iter(buffer, &iter);
      gtk_text_buffer_insert(buffer, &iter, optMPF.auto_xa_status, strlen(optMPF.auto_xa_status));
    }

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_user_online),optMPF.sound_on_user_online);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_user_offline),optMPF.sound_on_user_offline);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_message),optMPF.sound_on_receive_message);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_chat),optMPF.sound_on_receive_chat);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_url),optMPF.sound_on_receive_url);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_error),optMPF.sound_on_receive_error);

  if(optMPF.sound_file_on_user_online != NULL && strlen(optMPF.sound_file_on_user_online) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_online),optMPF.sound_file_on_user_online);
  if(optMPF.sound_file_on_user_offline != NULL && strlen(optMPF.sound_file_on_user_offline) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_offline),optMPF.sound_file_on_user_offline);
  if(optMPF.sound_file_on_receive_message != NULL && strlen(optMPF.sound_file_on_receive_message) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_message),optMPF.sound_file_on_receive_message);
  if(optMPF.sound_file_on_receive_chat != NULL && strlen(optMPF.sound_file_on_receive_chat) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_chat),optMPF.sound_file_on_receive_chat);
  if(optMPF.sound_file_on_receive_url != NULL && strlen(optMPF.sound_file_on_receive_url) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_url),optMPF.sound_file_on_receive_url);
  if(optMPF.sound_file_on_receive_error != NULL && strlen(optMPF.sound_file_on_receive_error) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_error),optMPF.sound_file_on_receive_error);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_docklet),optMPF.use_docklet);

  if(optMPF.log_location != NULL && strlen(optMPF.log_location) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_browse_log_location),optMPF.log_location);
  if(optMPF.history_location != NULL && strlen(optMPF.history_location) > 0)
    gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_browse_history_location),optMPF.history_location);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_history),optMPF.use_history);

  /* clean up */
  if(xml != NULL)
    {
      g_object_unref(G_OBJECT(xml));
      xml = NULL;
    }

  return TRUE;
}

gboolean gj_gtk_mpf_unload()
{
  gtk_widget_destroy(ctlMPF.window);
  ctlMPF.window = NULL;

  return TRUE;
}

gboolean gj_gtk_mpf_set()
{
  GtkTextBuffer *buffer = NULL;
  GtkTextIter bufStart;
  GtkTextIter bufStop;

  /* get values */
  optMPF.use_docklet = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_docklet));

  optMPF.sound_on_user_online = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_user_online));
  optMPF.sound_on_user_offline = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_user_offline));
  optMPF.sound_on_receive_message = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_message));
  optMPF.sound_on_receive_chat = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_chat));
  optMPF.sound_on_receive_url = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_url));
  optMPF.sound_on_receive_error = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_sound_on_receive_error));

  optMPF.sound_file_on_user_online = gtk_editable_get_chars(GTK_EDITABLE(ctlMPF.entry_sound_file_on_user_online),0,-1);
  optMPF.sound_file_on_user_offline = gtk_editable_get_chars(GTK_EDITABLE(ctlMPF.entry_sound_file_on_user_offline),0,-1);
  optMPF.sound_file_on_receive_message = gtk_editable_get_chars(GTK_EDITABLE(ctlMPF.entry_sound_file_on_receive_message),0,-1);
  optMPF.sound_file_on_receive_chat = gtk_editable_get_chars(GTK_EDITABLE(ctlMPF.entry_sound_file_on_receive_chat),0,-1);
  optMPF.sound_file_on_receive_url = gtk_editable_get_chars(GTK_EDITABLE(ctlMPF.entry_sound_file_on_receive_url),0,-1);
  optMPF.sound_file_on_receive_error = gtk_editable_get_chars(GTK_EDITABLE(ctlMPF.entry_sound_file_on_receive_error),0,-1);

  optMPF.hide_offline_contacts = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_offline_contacts));
  optMPF.hide_offline_group = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_offline_group));
  optMPF.hide_agents = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_agents));

  optMPF.close_previous_message_window_on_reply = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_close_previous_message_window_on_reply));
  optMPF.raise_window_on_new_message = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_raise_window_on_new_message));
  optMPF.hide_time = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_hide_time));
  optMPF.reverse_text_direction = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_reverse_text_direction));

  optMPF.use_spell_checker = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_spell_checker));

  optMPF.auto_away_after = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(ctlMPF.spinbutton_auto_away_after));
  optMPF.auto_xa_after = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(ctlMPF.spinbutton_auto_xa_after));

  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(ctlMPF.textview_auto_away_status));
  gtk_text_buffer_get_iter_at_offset(buffer, &bufStart, 0);
  gtk_text_buffer_get_iter_at_offset(buffer, &bufStop, -1);
  optMPF.auto_away_status = gtk_text_buffer_get_text(buffer,&bufStart,&bufStop,TRUE);

  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(ctlMPF.textview_auto_xa_status));
  gtk_text_buffer_get_iter_at_offset(buffer, &bufStart, 0);
  gtk_text_buffer_get_iter_at_offset(buffer, &bufStop, -1);
  optMPF.auto_xa_status = gtk_text_buffer_get_text(buffer,&bufStart,&bufStop,TRUE);

  optMPF.log_location = gtk_editable_get_chars(GTK_EDITABLE(ctlMPF.entry_browse_log_location),0,-1);
  optMPF.history_location = gtk_editable_get_chars(GTK_EDITABLE(ctlMPF.entry_browse_history_location),0,-1);
  optMPF.use_history = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlMPF.checkbutton_use_history));


  gj_config_set_mpf_hide_offline_contacts(gj_gtk_mpf_get_hide_offline_contacts());
  gj_config_set_mpf_hide_offline_group(gj_gtk_mpf_get_hide_offline_group());
  gj_config_set_mpf_hide_agents(gj_gtk_mpf_get_hide_agents());

  gj_config_set_mpf_close_previous_message_window_on_reply(gj_gtk_mpf_get_close_previous_message_window_on_reply());
  gj_config_set_mpf_raise_window_on_new_message(gj_gtk_mpf_get_raise_window_on_new_message());
  gj_config_set_mpf_hide_time(gj_gtk_mpf_get_hide_time());
  gj_config_set_mpf_reverse_text_direction(gj_gtk_mpf_get_reverse_text_direction());

  gj_config_set_mpf_use_spell_checker(gj_gtk_mpf_get_use_spell_checker());

  gj_config_set_mpf_auto_away_after(gj_gtk_mpf_get_auto_away_after());
  gj_config_set_mpf_auto_xa_after(gj_gtk_mpf_get_auto_xa_after());
  gj_config_set_mpf_auto_away_status(gj_gtk_mpf_get_auto_away_status());
  gj_config_set_mpf_auto_xa_status(gj_gtk_mpf_get_auto_xa_status());

  gj_config_set_mpf_sound_on_user_online(gj_gtk_mpf_get_sound_on_user_online());
  gj_config_set_mpf_sound_on_user_offline(gj_gtk_mpf_get_sound_on_user_offline());
  gj_config_set_mpf_sound_on_receive_message(gj_gtk_mpf_get_sound_on_receive_message());
  gj_config_set_mpf_sound_on_receive_chat(gj_gtk_mpf_get_sound_on_receive_chat());
  gj_config_set_mpf_sound_on_receive_url(gj_gtk_mpf_get_sound_on_receive_url());
  gj_config_set_mpf_sound_on_receive_error(gj_gtk_mpf_get_sound_on_receive_error());
  gj_config_set_mpf_sound_file_on_user_online(gj_gtk_mpf_get_sound_file_on_user_online());
  gj_config_set_mpf_sound_file_on_user_offline(gj_gtk_mpf_get_sound_file_on_user_offline());
  gj_config_set_mpf_sound_file_on_receive_message(gj_gtk_mpf_get_sound_file_on_receive_message());
  gj_config_set_mpf_sound_file_on_receive_chat(gj_gtk_mpf_get_sound_file_on_receive_chat());
  gj_config_set_mpf_sound_file_on_receive_url(gj_gtk_mpf_get_sound_file_on_receive_url());
  gj_config_set_mpf_sound_file_on_receive_error(gj_gtk_mpf_get_sound_file_on_receive_error());
  gj_config_set_mpf_use_docklet(gj_gtk_mpf_get_use_docklet());

  gj_config_set_mpf_log_location(gj_gtk_mpf_get_log_location());
  gj_config_set_mpf_history_location(gj_gtk_mpf_get_history_location());
  gj_config_set_mpf_use_history(gj_gtk_mpf_get_use_history());

  if(gj_config_write() == FALSE)
    return FALSE;

  if(gj_me_get_is_connected() == TRUE)
    {
      /* set program up */
      gj_gtk_roster_model_unload();
      gj_gtk_roster_model_load(rosterGet());
    }

  if(gj_gtk_mpf_get_use_docklet() == TRUE)
    gj_gtk_docklet_load();
  else
    gj_gtk_docklet_unload();

  return TRUE;
}

gboolean gj_gtk_mpf_get()
{
  if(gj_config_read() == FALSE)
    g_message("gj_gtk_mpf_get: config read failed, continuing anyway...");
  
  gj_gtk_mpf_set_hide_offline_contacts(gj_config_get_mpf_hide_offline_contacts());
  gj_gtk_mpf_set_hide_offline_group(gj_config_get_mpf_hide_offline_group());
  gj_gtk_mpf_set_hide_agents(gj_config_get_mpf_hide_agents());

  gj_gtk_mpf_set_close_previous_message_window_on_reply(gj_config_get_mpf_close_previous_message_window_on_reply());
  gj_gtk_mpf_set_raise_window_on_new_message(gj_config_get_mpf_raise_window_on_new_message());
  gj_gtk_mpf_set_hide_time(gj_config_get_mpf_hide_time());
  gj_gtk_mpf_set_reverse_text_direction(gj_config_get_mpf_reverse_text_direction());

  gj_gtk_mpf_set_use_spell_checker(gj_config_get_mpf_use_spell_checker());

  gj_gtk_mpf_set_auto_away_after(gj_config_get_mpf_auto_away_after());
  gj_gtk_mpf_set_auto_xa_after(gj_config_get_mpf_auto_xa_after());
  gj_gtk_mpf_set_auto_away_status(gj_config_get_mpf_auto_away_status());
  gj_gtk_mpf_set_auto_xa_status(gj_config_get_mpf_auto_xa_status());

  gj_gtk_mpf_set_sound_on_user_online(gj_config_get_mpf_sound_on_user_online());
  gj_gtk_mpf_set_sound_on_user_offline(gj_config_get_mpf_sound_on_user_offline());
  gj_gtk_mpf_set_sound_on_receive_message(gj_config_get_mpf_sound_on_receive_message());
  gj_gtk_mpf_set_sound_on_receive_chat(gj_config_get_mpf_sound_on_receive_chat());
  gj_gtk_mpf_set_sound_on_receive_url(gj_config_get_mpf_sound_on_receive_url());
  gj_gtk_mpf_set_sound_on_receive_error(gj_config_get_mpf_sound_on_receive_error());
  gj_gtk_mpf_set_sound_file_on_user_online(gj_config_get_mpf_sound_file_on_user_online());
  gj_gtk_mpf_set_sound_file_on_user_offline(gj_config_get_mpf_sound_file_on_user_offline());
  gj_gtk_mpf_set_sound_file_on_receive_message(gj_config_get_mpf_sound_file_on_receive_message());
  gj_gtk_mpf_set_sound_file_on_receive_chat(gj_config_get_mpf_sound_file_on_receive_chat());
  gj_gtk_mpf_set_sound_file_on_receive_url(gj_config_get_mpf_sound_file_on_receive_url());
  gj_gtk_mpf_set_sound_file_on_receive_error(gj_config_get_mpf_sound_file_on_receive_error());
  gj_gtk_mpf_set_use_docklet(gj_config_get_mpf_use_docklet());

  gj_gtk_mpf_set_log_location(gj_config_get_mpf_log_location());
  gj_gtk_mpf_set_history_location(gj_config_get_mpf_history_location());
  gj_gtk_mpf_set_use_history(gj_config_get_mpf_use_history());

  return TRUE;
}

void gj_gtk_mpf_store_filename(GtkFileSelection *file_selector, gpointer user_data) 
{
   const gchar *selected_filename;
   guint browse = 0;
 
   browse = GPOINTER_TO_INT(user_data);
   selected_filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(ctlMPF.file_selector));

   if(selected_filename == NULL || strlen(selected_filename) < 1)
     {
       g_warning("gj_gtk_mpf_store_filename: not saving filename for browse id:%d, filename was NULL or length was < 1", browse);
       return;
     }

   g_message("gj_gtk_mpf_store_filename: selected filename: %s for browse:%d", selected_filename, browse);

   switch(browse)
     {
     case BROWSE_SOUND_ON_USER_ONLINE:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_online), selected_filename);
       break;
     case BROWSE_SOUND_ON_USER_OFFLINE:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_user_offline), selected_filename);
       break;
     case BROWSE_SOUND_ON_RECEIVE_MESSAGE:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_message), selected_filename);
       break;
     case BROWSE_SOUND_ON_RECEIVE_CHAT:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_chat), selected_filename);
       break;
     case BROWSE_SOUND_ON_RECEIVE_URL:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_url), selected_filename);
       break;
     case BROWSE_SOUND_ON_RECEIVE_ERROR:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_sound_file_on_receive_error), selected_filename);
       break;
     case BROWSE_LOG_LOCATION:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_browse_log_location), selected_filename);
       break;
     case BROWSE_HISTORY_LOCATION:
       gtk_entry_set_text(GTK_ENTRY(ctlMPF.entry_browse_history_location), selected_filename);
       break;


     default:
       g_warning("gj_gtk_mpf_store_filename: default reached when checking browse id");
       break;
     }

   ctlMPF.file_selector = NULL;
}

void gj_gtk_mpf_create_file_selection(guint sound) 
{
   /* Create the selector */
   ctlMPF.file_selector = gtk_file_selection_new("Select File for Sound");
   
   g_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(ctlMPF.file_selector)->ok_button),
		    "clicked",
		    G_CALLBACK(gj_gtk_mpf_store_filename),
		    GINT_TO_POINTER(sound));
   			   
   /* Ensure that the dialog box is destroyed when the user clicks a button. */
   g_signal_connect_swapped(GTK_OBJECT(GTK_FILE_SELECTION(ctlMPF.file_selector)->ok_button),
			    "clicked",
			    G_CALLBACK(gtk_widget_destroy), 
			    (gpointer)ctlMPF.file_selector); 
   
   g_signal_connect_swapped(GTK_OBJECT(GTK_FILE_SELECTION(ctlMPF.file_selector)->cancel_button),
			    "clicked",
			    G_CALLBACK(gtk_widget_destroy),
			    (gpointer)ctlMPF.file_selector); 
   
   /* Display that dialog */
   gtk_widget_show(ctlMPF.file_selector);
}

gboolean gj_gtk_mpf_get_use_docklet() { return optMPF.use_docklet; }
gboolean gj_gtk_mpf_get_sound_enabled() { return optMPF.sound_enabled; }
gboolean gj_gtk_mpf_get_sound_on_user_online() { return optMPF.sound_on_user_online; }
gboolean gj_gtk_mpf_get_sound_on_user_offline() { return optMPF.sound_on_user_offline; }
gboolean gj_gtk_mpf_get_sound_on_receive_message() { return optMPF.sound_on_receive_message; }
gboolean gj_gtk_mpf_get_sound_on_receive_chat() { return optMPF.sound_on_receive_chat; }
gboolean gj_gtk_mpf_get_sound_on_receive_url() { return optMPF.sound_on_receive_url; }
gboolean gj_gtk_mpf_get_sound_on_receive_error() { return optMPF.sound_on_receive_error; }
gboolean gj_gtk_mpf_get_sound_beep_if_no_file() { return optMPF.sound_beep_if_no_file; }
gchar *gj_gtk_mpf_get_sound_file_on_user_online() { return optMPF.sound_file_on_user_online; }
gchar *gj_gtk_mpf_get_sound_file_on_user_offline() { return optMPF.sound_file_on_user_offline; }
gchar *gj_gtk_mpf_get_sound_file_on_receive_message() { return optMPF.sound_file_on_receive_message; }
gchar *gj_gtk_mpf_get_sound_file_on_receive_chat() { return optMPF.sound_file_on_receive_chat; }
gchar *gj_gtk_mpf_get_sound_file_on_receive_url() { return optMPF.sound_file_on_receive_url; }
gchar *gj_gtk_mpf_get_sound_file_on_receive_error() { return optMPF.sound_file_on_receive_error; }
gboolean gj_gtk_mpf_get_hide_offline_contacts() { return optMPF.hide_offline_contacts; }
gboolean gj_gtk_mpf_get_hide_offline_group() { return optMPF.hide_offline_group; }
gboolean gj_gtk_mpf_get_hide_agents() { return optMPF.hide_agents; }
gboolean gj_gtk_mpf_get_close_previous_message_window_on_reply() { return optMPF.close_previous_message_window_on_reply; }
gboolean gj_gtk_mpf_get_raise_window_on_new_message() { return optMPF.raise_window_on_new_message; }
gboolean gj_gtk_mpf_get_hide_time() { return optMPF.hide_time; }
gboolean gj_gtk_mpf_get_reverse_text_direction() { return optMPF.reverse_text_direction; }
gboolean gj_gtk_mpf_get_use_spell_checker() { return optMPF.use_spell_checker; }
gint gj_gtk_mpf_get_auto_away_after() { return optMPF.auto_away_after; }
gint gj_gtk_mpf_get_auto_xa_after() { return optMPF.auto_xa_after; }
gchar *gj_gtk_mpf_get_auto_away_status() { return optMPF.auto_away_status; }
gchar *gj_gtk_mpf_get_auto_xa_status() { return optMPF.auto_xa_status; }
gchar *gj_gtk_mpf_get_log_location() { return optMPF.log_location; }
gchar *gj_gtk_mpf_get_history_location() { return optMPF.history_location; }
gboolean gj_gtk_mpf_get_use_history() { return optMPF.use_history; }

/* set */
gboolean gj_gtk_mpf_set_use_docklet(gboolean bool)
{
  if(bool == TRUE)
    optMPF.use_docklet = TRUE;
  else
    optMPF.use_docklet = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_enabled(gboolean bool)
{
  if(bool == TRUE)
    optMPF.sound_enabled = TRUE;
  else
    optMPF.sound_enabled = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_on_user_online(gboolean bool)
{
  if(bool == TRUE)
    optMPF.sound_on_user_online = TRUE;
  else
    optMPF.sound_on_user_online = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_on_user_offline(gboolean bool)
{
  if(bool == TRUE)
    optMPF.sound_on_user_offline = TRUE;
  else
    optMPF.sound_on_user_offline = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_on_receive_message(gboolean bool)
{
  if(bool == TRUE)
    optMPF.sound_on_receive_message = TRUE;
  else
    optMPF.sound_on_receive_message = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_on_receive_chat(gboolean bool)
{
  if(bool == TRUE)
    optMPF.sound_on_receive_chat = TRUE;
  else
    optMPF.sound_on_receive_chat = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_on_receive_url(gboolean bool)
{
  if(bool == TRUE)
    optMPF.sound_on_receive_url = TRUE;
  else
    optMPF.sound_on_receive_url = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_on_receive_error(gboolean bool)
{
  if(bool == TRUE)
    optMPF.sound_on_receive_error = TRUE;
  else
    optMPF.sound_on_receive_error = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_beep_if_no_file(gboolean bool)
{
  if(bool == TRUE)
    optMPF.sound_beep_if_no_file = TRUE;
  else
    optMPF.sound_beep_if_no_file = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_file_on_user_online(gchar *string)
{
  if(string == NULL) 
    return FALSE;

  if(optMPF.sound_file_on_user_online != NULL)
    {
      g_free(optMPF.sound_file_on_user_online);
      optMPF.sound_file_on_user_online = NULL;
    }

  optMPF.sound_file_on_user_online = g_strdup(string);

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_file_on_user_offline(gchar *string)
{
  if(string == NULL) 
    return FALSE;

  if(optMPF.sound_file_on_user_offline != NULL)
    {
      g_free(optMPF.sound_file_on_user_offline);
      optMPF.sound_file_on_user_offline = NULL;
    }

  optMPF.sound_file_on_user_offline = g_strdup(string);

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_file_on_receive_message(gchar *string)
{
  if(string == NULL) 
    return FALSE;

  if(optMPF.sound_file_on_receive_message != NULL)
    {
      g_free(optMPF.sound_file_on_receive_message);
      optMPF.sound_file_on_receive_message = NULL;
    }

  optMPF.sound_file_on_receive_message = g_strdup(string);

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_file_on_receive_chat(gchar *string)
{
  if(string == NULL) 
    return FALSE;

  if(optMPF.sound_file_on_receive_chat != NULL)
    {
      g_free(optMPF.sound_file_on_receive_chat);
      optMPF.sound_file_on_receive_chat = NULL;
    }

  optMPF.sound_file_on_receive_chat = g_strdup(string);

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_file_on_receive_url(gchar *string)
{
  if(string == NULL) 
    return FALSE;

  if(optMPF.sound_file_on_receive_url != NULL)
    {
      g_free(optMPF.sound_file_on_receive_url);
      optMPF.sound_file_on_receive_url = NULL;
    }

  optMPF.sound_file_on_receive_url = g_strdup(string);

  return TRUE;
}

gboolean gj_gtk_mpf_set_sound_file_on_receive_error(gchar *string)
{
  if(string == NULL) 
    return FALSE;

  if(optMPF.sound_file_on_receive_error != NULL)
    {
      g_free(optMPF.sound_file_on_receive_error);
      optMPF.sound_file_on_receive_error = NULL;
    }

  optMPF.sound_file_on_receive_error = g_strdup(string);

  return TRUE;
}

gboolean gj_gtk_mpf_set_hide_offline_contacts(gboolean bool)
{
  if(bool == TRUE)
    optMPF.hide_offline_contacts = TRUE;
  else
    optMPF.hide_offline_contacts = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_hide_offline_group(gboolean bool)
{
  if(bool == TRUE)
    optMPF.hide_offline_group = TRUE;
  else
    optMPF.hide_offline_group = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_hide_agents(gboolean bool)
{
  if(bool == TRUE)
    optMPF.hide_agents = TRUE;
  else
    optMPF.hide_agents = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_close_previous_message_window_on_reply(gboolean bool)
{
  if(bool == TRUE)
    optMPF.close_previous_message_window_on_reply = TRUE;
  else
    optMPF.close_previous_message_window_on_reply = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_raise_window_on_new_message(gboolean bool)
{
  if(bool == TRUE)
    optMPF.raise_window_on_new_message = TRUE;
  else
    optMPF.raise_window_on_new_message = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_hide_time(gboolean bool)
{
  if(bool == TRUE)
    optMPF.hide_time = TRUE;
  else
    optMPF.hide_time = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_reverse_text_direction(gboolean bool)
{
  if(bool == TRUE)
    optMPF.reverse_text_direction = TRUE;
  else
    optMPF.reverse_text_direction = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_use_spell_checker(gboolean bool)
{
  if(bool == TRUE)
    optMPF.use_spell_checker = TRUE;
  else
    optMPF.use_spell_checker = FALSE;

  return TRUE;
}

gboolean gj_gtk_mpf_set_auto_away_after(guint integer)
{
  if(integer < 1 || integer > 1000)
    {
      g_warning("gj_gtk_mpf_set_auto_away_after: value:%d was out of range (1 to 1000)", integer);
      return FALSE;
    }

  optMPF.auto_away_after = integer;

  return TRUE;
}

gboolean gj_gtk_mpf_set_auto_xa_after(guint integer)
{
  if(integer < 1 || integer > 1000)
    {
      g_warning("gj_gtk_mpf_set_auto_xa_after: value:%d was out of range (1 to 1000)", integer);
      return FALSE;
    }

  optMPF.auto_xa_after = integer;

  return TRUE;
}

gboolean gj_gtk_mpf_set_auto_away_status(gchar *string)
{
  if(string == NULL) 
    return FALSE;

  if(optMPF.auto_away_status != NULL)
    {
      g_free(optMPF.auto_away_status);
      optMPF.auto_away_status = NULL;
    }

  optMPF.auto_away_status = g_strdup(string);

  return TRUE;
}

gboolean gj_gtk_mpf_set_auto_xa_status(gchar *string)
{
  if(string == NULL) 
    return FALSE;

  if(optMPF.auto_xa_status != NULL)
    {
      g_free(optMPF.auto_xa_status);
      optMPF.auto_xa_status = NULL;
    }

  optMPF.auto_xa_status = g_strdup(string);

  return TRUE;
}

gboolean gj_gtk_mpf_set_log_location(gchar *string)
{
  if(string == NULL) 
    return FALSE;

  if(optMPF.log_location != NULL)
    {
      g_free(optMPF.log_location);
      optMPF.log_location = NULL;
    }

  optMPF.log_location = g_strdup(string);

  return TRUE;
}

gboolean gj_gtk_mpf_set_history_location(gchar *string)
{
  if(string == NULL) 
    return FALSE;

  if(optMPF.history_location != NULL)
    {
      g_free(optMPF.history_location);
      optMPF.history_location = NULL;
    }

  optMPF.history_location = g_strdup(string);

  return TRUE;
}

gboolean gj_gtk_mpf_set_use_history(gboolean bool)
{
  if(bool == TRUE)
    optMPF.use_history = TRUE;
  else
    optMPF.use_history = FALSE;

  return TRUE;
}


/*
 * GUI events
 */
void on_button_mpf_browse_sound_on_user_online_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_USER_ONLINE);
}

void on_button_mpf_browse_sound_on_user_offline_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_USER_OFFLINE);
}

void on_button_mpf_browse_sound_on_receive_message_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_RECEIVE_MESSAGE);
}

void on_button_mpf_browse_sound_on_receive_chat_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_RECEIVE_CHAT);
}

void on_button_mpf_browse_sound_on_receive_url_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_RECEIVE_URL);
}

void on_button_mpf_browse_sound_on_receive_error_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_SOUND_ON_RECEIVE_ERROR);
}

void on_button_mpf_browse_log_location_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_LOG_LOCATION);
}

void on_button_mpf_browse_history_location_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_create_file_selection(BROWSE_HISTORY_LOCATION);
}

void on_checkbutton_mpf_use_history_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
  gboolean active = FALSE;
  active = gtk_toggle_button_get_active(togglebutton);
  gtk_widget_set_sensitive(GTK_WIDGET(ctlMPF.entry_browse_history_location), active);
  gtk_widget_set_sensitive(GTK_WIDGET(ctlMPF.button_browse_history_location), active);
}

void on_checkbutton_mpf_sound_enabled_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
  gboolean active = FALSE;
  active = gtk_toggle_button_get_active(togglebutton);
  gtk_widget_set_sensitive(GTK_WIDGET(ctlMPF.table_sound), active);
}

void on_checkbutton_mpf_hide_offline_contacts_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
  gtk_widget_set_sensitive(GTK_WIDGET(ctlMPF.checkbutton_hide_offline_group), 
			   !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton)));
}

void on_button_mpf_ok_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_set();
  gj_gtk_mpf_unload();
}

void on_button_mpf_apply_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_set();
}

void on_button_mpf_cancel_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_mpf_unload();
}

gboolean on_my_preferences_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
  gj_gtk_mpf_unload();

  return TRUE;
}

#ifdef __cplusplus
}
#endif
