/*
 * $RCSfile: gj_gtk_register_service.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/02 00:06:31 $
 *
 * $Revision: 1.7 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/* gui */
#include <glade/glade.h>
#include <gtk/gtk.h>

/* local */
#include "common.h"

#include "gj_main.h"
#include "gj_registration.h"
#include "gj_parser.h"

#include "gj_gtk_register_service.h"
#include "gj_gtk_support.h"
#include "gj_gtk_msg.h"

/*
 * member functions
 */

/* gets */
gchar *gj_gtk_rs_get_key();
gchar *gj_gtk_rs_get_service();
gboolean gj_gtk_rs_get_require_username();
gboolean gj_gtk_rs_get_require_password();
gboolean gj_gtk_rs_get_require_email();
gboolean gj_gtk_rs_get_require_nickname();

/* sets */
gboolean gj_gtk_rs_set_key(gchar *key);
gboolean gj_gtk_rs_set_service(gchar *service);
gboolean gj_gtk_rs_set_require_username(gboolean require);
gboolean gj_gtk_rs_set_require_password(gboolean require);
gboolean gj_gtk_rs_set_require_email(gboolean require);
gboolean gj_gtk_rs_set_require_nickname(gboolean require);

/*
 * window functions 
 */
gboolean gj_gtk_rs_setup();
gboolean gj_gtk_rs_check();

void gj_gtk_rs_registration_requirements_response(registration rgr, gint error_code, gchar *error_reason);
void gj_gtk_rs_registration_response(registration rgr, gint error_code, gchar *error_reason);

gboolean gj_gtk_rs_page_forward();

/* 
 * internal callbacks
 */
gint gj_gtk_rs_progress_timer_requirements(gpointer data);

/*
 * actual GUI functions
 */
void on_register_service_response(GtkDialog *dialog, gint response, gpointer user_data);

struct 
{
  /* search */
  GtkWidget *window;

  GtkWidget *notebook;
  
  GtkWidget *progressbar_requirements;

  GtkWidget *label_instructions;
  GtkWidget *label_service;

  GtkWidget *label_username;
  GtkWidget *label_password;
  GtkWidget *label_email;
  GtkWidget *label_nickname;
  GtkWidget *entry_username;  
  GtkWidget *entry_password;
  GtkWidget *entry_email;
  GtkWidget *entry_nickname;

  GtkWidget *progressbar_registering;

  GtkWidget *button_ok;
  GtkWidget *button_cancel;
  GtkWidget *button_help;

} ctlRS;

struct
{
  gchar *key; /* key used as part of registration */

  gchar *service;

  gboolean require_username;
  gboolean require_password;
  gboolean require_email;
  gboolean require_nickname;

  guint progress_timer_requirements;

} optRS;

/*
 * member functions
 */

/* gets */
gchar *gj_gtk_rs_get_key()
{
  return optRS.key;
}

gchar *gj_gtk_rs_get_service()
{
  return optRS.service;
}

gboolean gj_gtk_rs_get_require_username()
{
  return optRS.require_username;
}

gboolean gj_gtk_rs_get_require_password()
{
  return optRS.require_password;
}

gboolean gj_gtk_rs_get_require_email()
{
  return optRS.require_email;
}

gboolean gj_gtk_rs_get_require_nickname()
{
  return optRS.require_nickname;
}

/* sets */
gboolean gj_gtk_rs_set_key(gchar *key)
{
  if(key == NULL)
    {
      g_warning("gj_gtk_rs_set_key: key was NULL");
      return FALSE;
    }
  
  if(optRS.key != NULL)
    {
      g_free(optRS.key);
      optRS.key = NULL;
    }

  optRS.key = g_strdup(key);
  return TRUE;
}

gboolean gj_gtk_rs_set_service(gchar *service)
{
  if(service == NULL)
    {
      g_warning("gj_gtk_rs_set_service: service was NULL");
      return FALSE;
    }
  
  if(optRS.service != NULL)
    {
      g_free(optRS.service);
      optRS.service = NULL;
    }

  optRS.service = g_strdup(service);
  return TRUE;
}

gboolean gj_gtk_rs_set_require_username(gboolean require)
{
  optRS.require_username = require;
  return TRUE;
}

gboolean gj_gtk_rs_set_require_password(gboolean require)
{
  optRS.require_password = require;
  return TRUE;
}

gboolean gj_gtk_rs_set_require_email(gboolean require)
{
  optRS.require_email = require;
  return TRUE;
}

gboolean gj_gtk_rs_set_require_nickname(gboolean require)
{
  optRS.require_nickname = require;
  return TRUE;
}

/*
 * external functions...
 */
gboolean gj_gtk_rs_load(const gchar *service)
{
  GladeXML *xml = NULL;

  if(service == NULL)
    {
      g_warning("gj_gtk_rs_load: service was NULL");
      return FALSE;
    }

  /* init vars */
  optRS.key = NULL;
  gj_gtk_rs_set_service((gchar*)service);

  gj_gtk_rs_set_require_username(FALSE);
  gj_gtk_rs_set_require_password(FALSE);
  gj_gtk_rs_set_require_email(FALSE);
  gj_gtk_rs_set_require_nickname(FALSE);

  /* load dialog */
  if((xml = glade_xml_new(gnome_jabber_get_glade_file(),
			  "register_service",
			  NULL)) == NULL)
    {
      g_warning("gj_gtk_rs_load: couldn't open glade file at root 'register_service'");
      return FALSE;
    }
  
  /* controls */
  ctlRS.window = glade_xml_get_widget(xml, "register_service");

  ctlRS.notebook = glade_xml_get_widget(xml, "notebook_rs");
  ctlRS.progressbar_requirements = glade_xml_get_widget(xml, "progressbar_rs_requirements");

  ctlRS.button_ok = glade_xml_get_widget(xml, "button_rs_ok");

  ctlRS.label_instructions = glade_xml_get_widget(xml, "label_rs_instructions");
  ctlRS.label_service = glade_xml_get_widget(xml, "label_rs_service");

  ctlRS.label_username = glade_xml_get_widget(xml, "label_rs_username"); 
  ctlRS.label_password = glade_xml_get_widget(xml, "label_rs_password");  
  ctlRS.label_email = glade_xml_get_widget(xml, "label_rs_email");  
  ctlRS.label_nickname = glade_xml_get_widget(xml, "label_rs_nickname");  
  ctlRS.entry_username = glade_xml_get_widget(xml, "entry_rs_username"); 
  ctlRS.entry_password = glade_xml_get_widget(xml, "entry_rs_password");  
  ctlRS.entry_email = glade_xml_get_widget(xml, "entry_rs_email");  
  ctlRS.entry_nickname = glade_xml_get_widget(xml, "entry_rs_nickname");  

#ifndef WIN32
  glade_xml_signal_autoconnect(xml);
#else
  gtk_signal_connect (GTK_OBJECT (ctlRS.window), "response",
                      GTK_SIGNAL_FUNC (on_register_service_response),
                      NULL);
#endif

  gj_gtk_rs_setup(service);

  /* clean up */
  if(xml != NULL)
    {
      g_object_unref(G_OBJECT(xml));
      xml = NULL;
    }

  return TRUE;
}

gboolean gj_gtk_rs_unload()
{
  if(ctlRS.window != NULL)
    gtk_widget_destroy(ctlRS.window);

  if(optRS.key != NULL)
    {
      g_free(optRS.key);
      optRS.key = NULL;
    }

  if(optRS.service != NULL)
    {
      g_free(optRS.service);
      optRS.service = NULL;
    }

  optRS.require_username = FALSE;
  optRS.require_password = FALSE;
  optRS.require_email = FALSE;
  optRS.require_nickname = FALSE;  

  if(optRS.progress_timer_requirements != -1) 
    {
      gtk_timeout_remove(optRS.progress_timer_requirements);
      optRS.progress_timer_requirements = -1;
    }

  return TRUE;
}

gboolean gj_gtk_rs_setup(gchar *service)
{
  /* set up control */
  gtk_label_set_text(GTK_LABEL(ctlRS.label_service), service);

  /* set up progress bar */
  optRS.progress_timer_requirements = gtk_timeout_add(75, gj_gtk_rs_progress_timer_requirements, NULL);

  /* get request authentication from server */
  registrationRequestRequirements(service, gj_gtk_rs_registration_requirements_response);  
  
  return TRUE;
}

gboolean gj_gtk_rs_check()
{
  gboolean passed = FALSE;

  G_CONST_RETURN gchar *service = NULL;
  G_CONST_RETURN gchar *username = NULL;
  G_CONST_RETURN gchar *password = NULL;
  G_CONST_RETURN gchar *email = NULL;
  G_CONST_RETURN gchar *nickname = NULL;
  
  service = gtk_label_get_text(GTK_LABEL(ctlRS.label_service));
  username = gtk_entry_get_text(GTK_ENTRY(ctlRS.entry_username));
  password = gtk_entry_get_text(GTK_ENTRY(ctlRS.entry_password));
  email = gtk_entry_get_text(GTK_ENTRY(ctlRS.entry_email));
  nickname = gtk_entry_get_text(GTK_ENTRY(ctlRS.entry_nickname));

  /* do checks */
  if(service == NULL || strlen(service) < 1)
    {
      /* service not entered */
      gj_gtk_msg_new("Details incomplete.", 
		     "Register Service", 
		     "Service was not specified.",
		     TRUE,
		     GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_EXCLAIMATION,
		     (MsgCb)NULL,
		     NULL);

      passed = FALSE;
    }
  else if(gj_gtk_rs_get_require_username() == TRUE && (username == NULL || strlen(username) < 1))
    {
      /* username not entered */
      gj_gtk_msg_new("Details incomplete.", 
		     "Register Service", 
		     "Username was not specified.",
		     TRUE,
		     GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_EXCLAIMATION,
		     (MsgCb)NULL,
		     NULL);

      passed = FALSE;
    }
  else if(gj_gtk_rs_get_require_password() == TRUE && (password == NULL || strlen(password) < 1))
    {
      /* passwords not entered */
      gj_gtk_msg_new("Details incomplete.", 
		     "Register Service", 
		     "Password was not specified.",
		     TRUE,
		     GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_EXCLAIMATION,
		     (MsgCb)NULL,
		     NULL);

      passed = FALSE;
    }
  else if(gj_gtk_rs_get_require_email() == TRUE && (email == NULL || strlen(email) < 1))
    {
      /* passwords not entered */
      gj_gtk_msg_new("Details incomplete.", 
		     "Register Service", 
		     "Email address was not specified.",
		     TRUE,
		     GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_EXCLAIMATION,
		     (MsgCb)NULL,
		     NULL);

      passed = FALSE;
    }
  else if(gj_gtk_rs_get_require_nickname() == TRUE && (nickname == NULL || strlen(nickname) < 1))
    {
      /* passwords not entered */
      gj_gtk_msg_new("Details incomplete.", 
		     "Register Service", 
		     "Nickname was not specified.",
		     TRUE,
		     GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_EXCLAIMATION,
		     (MsgCb)NULL,
		     NULL);

      passed = FALSE;
    }
  else
    {
      /* ok */
      passed = TRUE;
    }

  return passed;
}

void gj_gtk_rs_registration_requirements_response(registration rgr, gint error_code, gchar *error_reason)
{
  g_message("gj_gtk_rs_registration_requirements_response: received response.");

  /* stop progress timer */
  if(optRS.progress_timer_requirements != -1)
    {
      gtk_timeout_remove(optRS.progress_timer_requirements);
      optRS.progress_timer_requirements = -1;
    }

  gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(ctlRS.progressbar_requirements), (gdouble) 1);
  gj_gtk_rs_page_forward();

  if(rgr == NULL)
    {
      g_warning("gj_gtk_rs_registration_requirements_response: rgr was NULL");
      return;
    }

  if(error_code != 0 || error_reason != NULL)
    {
      gchar *details = NULL;

      details = g_strdup_printf("Error %d, %s", error_code, error_reason);

      /* passwords not entered */
      gj_gtk_msg_new(details, 
		     "Register Service", 
		     "Correct the error and retry!",
		     TRUE,
		     GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_EXCLAIMATION,
		     (MsgCb)NULL,
		     NULL);   
 
      /* clean up */
      registrationFree(rgr);

      return;
    }

  gtk_label_set_text(GTK_LABEL(ctlRS.label_instructions), registrationGetInstructions(rgr));

  if(registrationGetRequireUsername(rgr) == TRUE)
    {
      gtk_widget_show(GTK_WIDGET(ctlRS.label_username));
      gtk_widget_show(GTK_WIDGET(ctlRS.entry_username));
      gj_gtk_rs_set_require_username(TRUE);
    }

  if(registrationGetRequirePassword(rgr) == TRUE)
    {
      gtk_widget_show(GTK_WIDGET(ctlRS.label_password));
      gtk_widget_show(GTK_WIDGET(ctlRS.entry_password));
      gj_gtk_rs_set_require_password(TRUE);
    }

  if(registrationGetRequireEmail(rgr) == TRUE)
    {
      gtk_widget_show(GTK_WIDGET(ctlRS.label_email));
      gtk_widget_show(GTK_WIDGET(ctlRS.entry_email));
      gj_gtk_rs_set_require_email(TRUE);
    }

  if(registrationGetRequireNickname(rgr) == TRUE)
    {
      gtk_widget_show(GTK_WIDGET(ctlRS.label_nickname));
      gtk_widget_show(GTK_WIDGET(ctlRS.entry_nickname));
      gj_gtk_rs_set_require_nickname(TRUE);
    }

  if(registrationGetKey(rgr) == NULL)
    {
      g_warning("gj_gtk_rs_registration_requirements_response: no registration key for response");
      return;
    }
  else
    gj_gtk_rs_set_key(registrationGetKey(rgr));

  /* clean up */
  registrationFree(rgr);
}

void gj_gtk_rs_registration_response(registration rgr, gint error_code, gchar *error_reason)
{
    g_message("gj_gtk_rs_registration_response: registration response");

    if(error_code == 0 && error_reason == NULL)
      {
	gj_gtk_msg_new("Registered successfully.", 
		       "Register Service", 
		       "No errors.",
		       FALSE,
		       GJ_GTK_MSG_BUTTON_CLOSE | GJ_GTK_MSG_ICON_INFORMATION,
		       (MsgCb)NULL,
		       NULL);  
      }
    else
      {
	gchar *details = NULL;

	details = g_strdup_printf("Error %d, %s", error_code, error_reason);
	
	/* passwords not entered */
	gj_gtk_msg_new("Registration failed!", 
		       "Register Service", 
		       details,
		       TRUE,
		       GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_EXCLAIMATION,
		       (MsgCb)NULL,
		       NULL);   
	
	/* clean up */
	g_free(details);
      }

    /* clean up */
    registrationFree(rgr);
}

gboolean gj_gtk_rs_page_forward()
{
  gint index = 0;

  if((index = gtk_notebook_get_current_page(GTK_NOTEBOOK(ctlRS.notebook))) < 0)
    {
      g_warning("gj_gtk_rs_page_forward: error, -1 returned, meaning NO notebook pages.  This should NEVER happen");
      return FALSE;
    } 

  /* what do we want to do here? check for the right information at each stage?? */
  gtk_notebook_next_page(GTK_NOTEBOOK(ctlRS.notebook));

  return TRUE;
}

/*
 * internal callbacks
 */
gint gj_gtk_rs_progress_timer_requirements(gpointer data)
{
  gtk_progress_bar_pulse(GTK_PROGRESS_BAR(ctlRS.progressbar_requirements));
  return TRUE;
} 


/*
 * actual gui functions
 */
void on_register_service_response(GtkDialog *dialog, gint response, gpointer user_data)
{
  G_CONST_RETURN gchar *service = NULL;
  G_CONST_RETURN gchar *username = NULL;
  G_CONST_RETURN gchar *password = NULL;
  G_CONST_RETURN gchar *email = NULL;
  G_CONST_RETURN gchar *nickname = NULL;

  switch(response) 
    {
    case GTK_RESPONSE_OK:
      if(gj_gtk_rs_check() == FALSE)
	return;
      
      service = gtk_label_get_text(GTK_LABEL(ctlRS.label_service));
      username = gtk_entry_get_text(GTK_ENTRY(ctlRS.entry_username));
      password = gtk_entry_get_text(GTK_ENTRY(ctlRS.entry_password));
      email = gtk_entry_get_text(GTK_ENTRY(ctlRS.entry_email));
      nickname = gtk_entry_get_text(GTK_ENTRY(ctlRS.entry_nickname));
      
      registrationRequest((gchar*)service, gj_gtk_rs_registration_response, 
			  gj_gtk_rs_get_key(), (gchar*)username, (gchar*)password, (gchar*)email, (gchar*)nickname);
      break;

    case GTK_RESPONSE_HELP:
    case GTK_RESPONSE_NONE:
    case GTK_RESPONSE_REJECT:
    case GTK_RESPONSE_ACCEPT:
    case GTK_RESPONSE_DELETE_EVENT:
    case GTK_RESPONSE_CANCEL:
    case GTK_RESPONSE_CLOSE:
    case GTK_RESPONSE_YES:
    case GTK_RESPONSE_NO:
    case GTK_RESPONSE_APPLY:
      break;
    }

  gj_gtk_rs_unload();
}


#ifdef __cplusplus
}
#endif
