/* 
 * $RCSfile: gj_gtk_roster.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/02 09:58:19 $
 * 
 * $Revision: 1.25 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "common.h"

#include "gj_main.h"
#include "gj_iq_requests.h"
#include "gj_roster.h"
#include "gj_presence.h"
#include "gj_message.h"
#include "gj_translate.h"
#include "gj_autoaway.h"
#include "gj_me.h"
#include "gj_parser.h"
#include "gj_event.h"
#include "gj_history.h"
#include "gj_config.h"

#include "gj_gtk_roster.h"
#include "gj_gtk_support.h"
#include "gj_gtk_msg.h"
#include "gj_gtk_message.h"
#include "gj_gtk_send_message.h"
#include "gj_gtk_chat.h"
#include "gj_gtk_headline.h"
#include "gj_gtk_my_presence.h"
#include "gj_gtk_my_information.h"
#include "gj_gtk_my_preferences.h"
#include "gj_gtk_connection_progress.h"
#include "gj_gtk_connection_settings.h"
#include "gj_gtk_password_change.h"
#include "gj_gtk_log.h"
#include "gj_gtk_user_information.h"
#include "gj_gtk_register_new.h"
#include "gj_gtk_msg.h"
#include "gj_gtk_edit_groups.h"
#include "gj_gtk_group_message.h"
#include "gj_gtk_add_contact.h"
#include "gj_gtk_subscription_request.h"
#include "gj_gtk_about.h"
#include "gj_gtk_debug.h"
#include "gj_gtk_event_viewer.h"
#include "gj_gtk_browse_services.h"
#include "gj_gtk_docklet.h"

/*#include "gj_gtk_gatherdata.h"*/

/* gui functions */
gboolean gj_gtk_roster_set_mode_connected();
gboolean gj_gtk_roster_set_mode_disconnected();

/* model functions */
gboolean gj_gtk_roster_model_setup();
gboolean gj_gtk_roster_model_populate_columns(GtkTreeView *view);
gboolean gj_gtk_roster_model_populate_from_roster(GList *roster);
gboolean gj_gtk_roster_model_add_contact_not_permanent(rosterItem ri);
gboolean gj_gtk_roster_model_add_contact_offline(rosterItem ri);
gboolean gj_gtk_roster_model_add_contact_permanent(rosterItem ri);
gboolean gj_gtk_roster_model_move_contact_online(rosterItem ri);

presenceType gj_gtk_roster_model_get_presence_type(rosterItem ri);

GtkTreeIter *gj_gtk_roster_model_find_iter_by_name(gchar *name);
GtkTreeIter *gj_gtk_roster_model_find_iter_by_group(gchar *group);
GtkTreeIter *gj_gtk_roster_model_find_iter_by_jid(gchar *jid, GtkTreeIter *iter);
GtkTreeIter *gj_gtk_roster_model_find_iter_by_jid_from_iter(gchar *jid, GtkTreeIter *iter);

gboolean gj_gtk_roster_model_get_selection(gchar **name, gchar **jid);

/* roster contact functions */
gboolean gj_gtk_roster_contact_read();
gboolean gj_gtk_roster_contact_new_message();
gboolean gj_gtk_roster_contact_new_chat();
gboolean gj_gtk_roster_contact_history();
gboolean gj_gtk_roster_contact_information();
gboolean gj_gtk_roster_contact_edit_groups();
gboolean gj_gtk_roster_contact_remove();
gboolean gj_gtk_roster_contact_remove_by_jid(gchar *jid);

/* events */
gboolean gj_gtk_roster_handle_next_event(gchar *jid);

gboolean gj_gtk_roster_timeout_start(rosterItem ri);
gboolean gj_gtk_roster_timeout_stop(rosterItem ri);
gboolean gj_gtk_roster_timeout_function(gpointer data);

/* menus */
gboolean gj_gtk_roster_generate_mnu_user(rosterItem ri, GdkEventButton *gdk_event);
gboolean gj_gtk_roster_generate_mnu_agent(rosterItem ri, GdkEventButton *gdk_event);
gboolean gj_gtk_roster_generate_mnu_group(rosterItem ri, GdkEventButton *gdk_event);

/* call backs */
void gj_gtk_roster_event_proc(gint eventID);

void gj_gtk_roster_event_presence_from(presence pres);
void gj_gtk_roster_event_message_from(message msg);

void gj_gtk_roster_get_response(GList *roster);

/* message boxes */
void gj_gtk_roster_unsubscribed_contact_msgbox_cb(gint response, void *userdata);
void gj_gtk_roster_remove_contact_msgbox_cb(gint response, void *userdata);
void gj_gtk_roster_remove_contact_completion_cb(guint id);
void gj_gtk_roster_remove_agent_contacts_msgbox_cb(gint response, void *userdata);
void gj_gtk_roster_user_changed_cb(guint id);
void gj_gtk_roster_unregister_cb(guint id);
void gj_gtk_roster_unregister_msgbox_cb(gint response, void *userdata);

/* gui callbacks */
void on_treeview_roster_selection_changed(GtkTreeSelection *treeselection, gpointer user_data);
void on_treeview_roster_row_inserted(GtkTreeModel *treemodel, GtkTreePath *path, GtkTreeIter *iter, gpointer user_data);
void on_treeview_roster_row_deleted(GtkTreeModel *treemodel, GtkTreePath *path, gpointer user_data);
gboolean on_treeview_roster_button_press_event(GtkWidget *widget, GdkEventButton *gdk_event, gpointer user_data);
gboolean on_treeview_roster_button_release_event(GtkWidget *widget, GdkEventButton *gdk_event, gpointer user_data);
void on_treeview_roster_cell_edited(GtkCellRendererText *cell, const gchar *path_string, const gchar *new_name, gpointer data);

void on_button_iqs_clicked(GtkButton *button, gpointer user_data);

void on_mnu_jabber_connect_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_jabber_disconnect_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_jabber_register_new_account_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_jabber_unregister_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_jabber_change_password_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_jabber_preferences_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_jabber_connection_settings_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_jabber_my_information_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_jabber_quit_activate(GtkMenuItem *menuitem, gpointer user_data);

void on_mnu_roster_add_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_roster_send_message_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_roster_export_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_roster_import_activate(GtkMenuItem *menuitem, gpointer user_data);

void on_mnu_roster_event_viewer_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_roster_browse_services_activate(GtkMenuItem *menuitem, gpointer user_data);

void on_mnu_help_homepage_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_help_project_information_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_help_log_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_help_debug_activate(GtkMenuItem *menuitem, gpointer user_data);
void on_mnu_help_about_activate(GtkMenuItem *menuitem, gpointer user_data);

void gj_gtk_roster_user_menu_cb(GtkMenuItem *menuitem, gpointer user_data);
void gj_gtk_roster_agent_menu_cb(GtkMenuItem *menuitem, gpointer user_data);
void gj_gtk_roster_group_menu_cb(GtkMenuItem *menuitem, gpointer user_data);
void gj_gtk_roster_presence_menu_cb(GtkMenuItem *menuitem, gpointer user_data);

gboolean on_roster_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data);

/*
 * USER menu
 */
enum
{
  user_mnu_read = 1,
  user_mnu_new_message,
  user_mnu_new_chat,
  user_mnu_send_file,
  user_mnu_send_contacts,
  user_mnu_view_headlines,
  user_mnu_history,
  user_mnu_information,
  user_mnu_subscription_request,
  user_mnu_subscription_cancel,
  user_mnu_edit_groups,
  user_mnu_rename,
  user_mnu_add,
  user_mnu_remove
} gj_gtk_roster_user_mnu_ids;

/*
 * AGENT menu
 */
enum
{
  agent_mnu_new_message = 1,
  agent_mnu_view_headlines,
  agent_mnu_information,
  agent_mnu_log_in,
  agent_mnu_log_out,
  agent_mnu_subscription_request,
  agent_mnu_subscription_cancel,
  agent_mnu_edit_groups,
  agent_mnu_rename,
  agent_mnu_remove
} gj_gtk_roster_agent_mnu_ids;

/*
 * GROUP menu
 */
enum
{
  group_mnu_send_message_to_all = 1,
  group_mnu_rename,
  group_mnu_remove
} gj_gtk_roster_group_mnu_ids;

/*
 * PRESENCE menu
 */ 
enum
{
  presence_mnu_available = 1,
  presence_mnu_chat,
  presence_mnu_away,
  presence_mnu_xa,
  presence_mnu_dnd,
  presence_mnu_unavailable,

} gj_gtk_roster_presence_mnu_ids;


/* 
 * roster columns 
 */
enum
  {
    COL_ROSTER_IMAGE = 0,
    COL_ROSTER_IMAGE_OLD,
    COL_ROSTER_NAME,
    COL_ROSTER_JID,
    COL_ROSTER_GROUP,
    COL_ROSTER_AGENT,
    COL_ROSTER_IS_AGENT,
    COL_ROSTER_SUBSCRIPTION,
    COL_ROSTER_RESOURCE,
    COL_ROSTER_PRESENCE_TYPE,
    COL_ROSTER_PRESENCE_SHOW,
    COL_ROSTER_TIMER,
    COL_ROSTER_VISIBLE,
    COL_ROSTER_EDITABLE,
    COL_ROSTER_COUNT
  };

struct 
{
  GtkWidget *window; 

  GtkWidget *treeview;

  GtkWidget *button_iqs;
  
  GtkWidget *label_status;

  /* menu items */
  GtkWidget *mnu_jabber_connect;
  GtkWidget *mnu_jabber_disconnect;
  GtkWidget *mnu_jabber_register_new_account;
  GtkWidget *mnu_jabber_unregister;
  GtkWidget *mnu_jabber_change_password;
  GtkWidget *mnu_jabber_preferences;
  GtkWidget *mnu_jabber_connection_settings;
  GtkWidget *mnu_jabber_my_information;
  GtkWidget *mnu_jabber_quit;

  GtkWidget *mnu_roster;
  GtkWidget *mnu_roster_add;
  GtkWidget *mnu_roster_send_message;
  GtkWidget *mnu_roster_import;
  GtkWidget *mnu_roster_event_viewer;
  GtkWidget *mnu_roster_browse_services;

  GtkWidget *mnu_help_homepage;
  GtkWidget *mnu_help_project_information;
  GtkWidget *mnu_help_log;
  GtkWidget *mnu_help_debug;
  GtkWidget *mnu_help_about;

  GtkWidget *menubar_presence;
  GtkWidget *mnu_presence;

} ctlRoster;

void gj_gtk_roster_cb_connected()
{
  gj_gtk_roster_set_status("Connected.");
  infoqueryRequestRoster(gj_gtk_roster_get_response);
}

void gj_gtk_roster_cb_disconnected()
{
  gj_gtk_roster_set_status("Disconnected.");
  gj_gtk_roster_model_unload();
}

void gj_gtk_roster_get_response(GList *roster)
{
  gint index = 0;

  for(index=0;index<g_list_length(roster);index++)
  {
    rosterItem ri = (rosterItem) g_list_nth_data(roster,index);

    if(ri != NULL)
      {
	const gchar *type = translateRosterItemType(rosterItemGetType(ri));
	const gchar *subscription = translateRosterItemSubscription(rosterItemGetSubscription(ri));
	gchar *groups = NULL;
	gint i = 0;
	
	groups = rosterItemGetGroupsAsString(ri);

	g_message("gj_gtk_roster_get_response: (%2.2d) jid:'%s', name:'%s', groups:'%s', type:'%d'->'%s', subscription:'%d'->'%s', resource:'%s', agent:'%s'",
		  index,
		  rosterItemGetJID(ri),
		  rosterItemGetName(ri),
		  groups?groups:"none",
		  rosterItemGetType(ri),
		  type,
		  rosterItemGetSubscription(ri),
		  subscription,
		  rosterItemGetResource(ri)?rosterItemGetResource(ri):"",
		  rosterItemGetAgent(ri)?rosterItemGetAgent(ri):"");

	/* clean up */
	if(groups != NULL) g_free(groups);
      }
    else
      g_warning("gj_gtk_roster_get_response: (%2.2d) failed, ri was NULL",index);
  }

  gj_gtk_roster_model_load(roster);
}

/*
 * code
 */
gboolean gj_gtk_roster_load()
{
  GladeXML *xml = NULL;

  if((xml = glade_xml_new(gnome_jabber_get_glade_file(),
			  "roster",
			  NULL)) == NULL)
    {
      g_error("gj_gtk_roster_load: couldn't open glade file at root 'roster'");
      return FALSE;
    }
  
  ctlRoster.window = glade_xml_get_widget(xml, "roster");

  ctlRoster.treeview = glade_xml_get_widget(xml,"treeview_roster");

  ctlRoster.button_iqs = glade_xml_get_widget(xml,"button_iqs");

  ctlRoster.label_status = glade_xml_get_widget(xml,"label_roster_status");

  ctlRoster.mnu_jabber_connect = glade_xml_get_widget(xml, "mnu_jabber_connect");
  ctlRoster.mnu_jabber_disconnect = glade_xml_get_widget(xml, "mnu_jabber_disconnect");
  ctlRoster.mnu_jabber_register_new_account = glade_xml_get_widget(xml, "mnu_jabber_register_new_account");
  ctlRoster.mnu_jabber_unregister = glade_xml_get_widget(xml, "mnu_jabber_unregister");
  ctlRoster.mnu_jabber_change_password = glade_xml_get_widget(xml, "mnu_jabber_change_password");
  ctlRoster.mnu_jabber_preferences = glade_xml_get_widget(xml, "mnu_jabber_preferences");
  ctlRoster.mnu_jabber_connection_settings = glade_xml_get_widget(xml, "mnu_jabber_connection_settings");
  ctlRoster.mnu_jabber_my_information = glade_xml_get_widget(xml, "mnu_jabber_my_information");
  ctlRoster.mnu_jabber_quit = glade_xml_get_widget(xml, "mnu_jabber_quit");

  ctlRoster.mnu_roster = glade_xml_get_widget(xml, "mnu_roster");
  ctlRoster.mnu_roster_add = glade_xml_get_widget(xml, "mnu_roster_add");
  ctlRoster.mnu_roster_import = glade_xml_get_widget(xml, "mnu_roster_import");
  ctlRoster.mnu_roster_event_viewer = glade_xml_get_widget(xml, "mnu_roster_event_viewer");
  ctlRoster.mnu_roster_browse_services = glade_xml_get_widget(xml, "mnu_roster_browse_services");

  ctlRoster.mnu_help_homepage = glade_xml_get_widget(xml, "mnu_help_homepage");
  ctlRoster.mnu_help_project_information = glade_xml_get_widget(xml, "mnu_help_project_information");
  ctlRoster.mnu_help_log = glade_xml_get_widget(xml, "mnu_help_log");
  ctlRoster.mnu_help_debug = glade_xml_get_widget(xml, "mnu_help_debug");
  ctlRoster.mnu_help_about = glade_xml_get_widget(xml, "mnu_help_about");

  ctlRoster.menubar_presence = glade_xml_get_widget(xml, "menubar_presence");

#ifndef WIN32
  glade_xml_signal_autoconnect(xml);
#else
  /* menus */
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_jabber_connect), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_jabber_connect_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_jabber_disconnect), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_jabber_disconnect_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_jabber_register_new_account), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_jabber_register_new_account_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_jabber_unregister), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_jabber_unregister_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_jabber_change_password), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_jabber_change_password_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_jabber_preferences), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_jabber_preferences_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_jabber_connection_settings), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_jabber_connection_settings_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_jabber_my_information), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_jabber_my_information_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_jabber_quit), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_jabber_quit_activate), NULL);

  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_help_homepage), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_help_homepage_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_help_project_information), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_help_project_information_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_help_log), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_help_log_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_help_debug), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_help_debug_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_help_about), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_help_about_activate), NULL);

  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_roster_add), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_roster_add_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_roster_send_message), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_roster_send_message_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_roster_import), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_roster_import_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_roster_event_viewer), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_roster_event_viewer_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (ctlRoster.mnu_roster_browse_services), "activate",
		      GTK_SIGNAL_FUNC(on_mnu_roster_browse_services_activate), NULL);
#endif

  /* set up menus, etc */
  gj_gtk_roster_setup();

  /* set up roster */
  if(gj_gtk_roster_model_setup() == FALSE)
    {
      g_warning("gj_gtk_roster_load: could not set up roster");
      return FALSE;
    }

  /*
   * start external things:
   *  - event viewer, docklet, etc 
   */

  /* start applet */
  gj_gtk_docklet_load();

  /* set event viewer up */
  gj_gtk_ev_load();

  gj_me_set_is_auto_away(FALSE);

  /* get connection information */
  gj_gtk_cs_open();

  /* 
   * set callbacks up for messages/presence 
   */

  /* set presence / message response proc */
  if(messageInit() != FALSE)
    {
      eventSetResponseProc(gj_gtk_roster_event_proc);

      messageFromSetResponseProc(gj_gtk_roster_event_message_from);
      presenceFromSetResponseProc(gj_gtk_roster_event_presence_from); 
      
      /*presenceSend(presenceTypeAvailable,presenceShowNormal,NULL,0);*/
    }
  else
    g_warning("gj_gtk_roster_load: message and presence callbacks have not been initiated, failed to init messageInit()");

  /* should we auto connect ? */
  if(gj_gtk_cs_get_auto_connect_on_startup() == TRUE)
      gj_gtk_cp_load(gj_gtk_roster_cb_connected, gj_gtk_roster_cb_disconnected);

  /* 
   * cleanup 
   */
  if(xml != NULL)
    {
      g_object_unref(G_OBJECT(xml));
      xml = NULL;
    }

  return TRUE;
}

gboolean gj_gtk_roster_unload()
{
  if(ctlRoster.window != NULL)
    gtk_widget_destroy(ctlRoster.window);

  ctlRoster.window = NULL;

  return TRUE;
}

gboolean gj_gtk_roster_setup()
{
  GtkWidget *menu = NULL;
  GtkWidget *item = NULL;
  GtkWidget *image = NULL;

  GdkPixbuf *pb = NULL;

  menu = gtk_menu_new();
  
  item = gtk_image_menu_item_new_with_mnemonic("Available");
  image = gj_gtk_support_image_new_from_file(FILE_PRESENCE_AVAILABLE);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_presence_menu_cb), 
		      GINT_TO_POINTER(presence_mnu_available));

  item = gtk_image_menu_item_new_with_mnemonic("Chat");
  image = gj_gtk_support_image_new_from_file(FILE_PRESENCE_CHAT);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_presence_menu_cb), 
		      GINT_TO_POINTER(presence_mnu_chat));

  item = gtk_image_menu_item_new_with_mnemonic("Away");
  image = gj_gtk_support_image_new_from_file(FILE_PRESENCE_AWAY);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_presence_menu_cb), 
		      GINT_TO_POINTER(presence_mnu_away));

  item = gtk_image_menu_item_new_with_mnemonic("eXtended Away");
  image = gj_gtk_support_image_new_from_file(FILE_PRESENCE_XA);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_presence_menu_cb), 
		      GINT_TO_POINTER(presence_mnu_xa));

  item = gtk_image_menu_item_new_with_mnemonic("Do Not Disturb");
  image = gj_gtk_support_image_new_from_file(FILE_PRESENCE_DND);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_presence_menu_cb), 
		      GINT_TO_POINTER(presence_mnu_dnd));

  item = gtk_separator_menu_item_new();
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);

  item = gtk_image_menu_item_new_with_mnemonic("Unavailable");
  image = gj_gtk_support_image_new_from_file(FILE_PRESENCE_UNAVAILABLE);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_presence_menu_cb), 
		      GINT_TO_POINTER(presence_mnu_unavailable));

  /* main menu item shown at all times */
  item = gtk_image_menu_item_new_with_mnemonic("Presence");
  image = gj_gtk_support_image_new_from_file(FILE_PRESENCE_AVAILABLE);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);

  /* add submenu */
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), menu);

  /* show */
  gtk_widget_show_all(GTK_WIDGET(item));
  gtk_widget_set_sensitive(GTK_WIDGET(item), FALSE);

  /* attach to menu bar */
  gtk_menu_shell_append(GTK_MENU_SHELL(ctlRoster.menubar_presence), item);

  /* remember menu for future use... */
  ctlRoster.mnu_presence = item;

  /* set status */
  gj_gtk_roster_set_status("Disconnected.");

  /* set icon */
  pb = gj_gtk_support_pixbuf_new_from_file(FILE_PRESENCE_AVAILABLE);
  gtk_window_set_icon(GTK_WINDOW(ctlRoster.window), pb);
  g_object_unref(G_OBJECT(pb));

  return TRUE;  
}

gboolean gj_gtk_roster_show()
{
  if(ctlRoster.window == NULL)
    return FALSE;
  
  gtk_window_present(GTK_WINDOW(ctlRoster.window));
  return TRUE;
}

gboolean gj_gtk_roster_hide()
{
  if(ctlRoster.window == NULL)
    return FALSE;
  
  gtk_widget_hide_all(GTK_WIDGET(ctlRoster.window));
  return TRUE;
}

gboolean gj_gtk_roster_set_mode_connected()
{
  GtkTreeView *view = NULL;
  
  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_set_mode_connected: view was NULL");
      return FALSE;
    }

  /* set presence */
  gj_gtk_roster_user_set_presence_and_save(presenceTypeAvailable,presenceShowNormal, gj_gtk_cs_get_nickname(), 0);

  /* enable roster */
  gtk_widget_set_sensitive(ctlRoster.treeview, TRUE);
  
  /* enable menu */
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_connect,FALSE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_disconnect,TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_register_new_account,FALSE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_unregister,TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_change_password,TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_preferences,TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_connection_settings,TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_my_information,TRUE);

  gtk_widget_set_sensitive(ctlRoster.mnu_roster, TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_roster_event_viewer, TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_roster_browse_services, TRUE);

  gtk_widget_set_sensitive(ctlRoster.mnu_help_debug, TRUE);

  /* enable presence button */
  gtk_widget_set_sensitive(ctlRoster.mnu_presence,TRUE);
  
  return TRUE;
}

gboolean gj_gtk_roster_set_mode_disconnected()
{
  GtkTreeView *view = NULL;

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_set_mode_disconnected: view was NULL");
      return FALSE;
    }

  /* disable roster */
  gtk_widget_set_sensitive(GTK_WIDGET(view), FALSE);

  /* enable menu */
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_connect,TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_disconnect,FALSE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_register_new_account,TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_unregister,FALSE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_change_password,FALSE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_preferences,TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_connection_settings,TRUE);
  gtk_widget_set_sensitive(ctlRoster.mnu_jabber_my_information,FALSE);

  gtk_widget_set_sensitive(ctlRoster.mnu_roster, FALSE);
  gtk_widget_set_sensitive(ctlRoster.mnu_roster_event_viewer, FALSE);
  gtk_widget_set_sensitive(ctlRoster.mnu_roster_browse_services, FALSE);

  gtk_widget_set_sensitive(ctlRoster.mnu_help_debug, FALSE);

  /* disable presence button */
  gtk_widget_set_sensitive(ctlRoster.mnu_presence,FALSE);

  return TRUE;
}

void gj_gtk_roster_set_status(gchar *message, ...)
{
  va_list args;
  gchar *buffer = NULL;

  va_start(args,message);
  buffer = g_strdup_vprintf(message,args);
  va_end(args);

  if(buffer == NULL)
    {
      g_warning("gj_gtk_roster_set_status: buffer to use was NULL");
      return;
    }

  gtk_label_set_markup(GTK_LABEL(ctlRoster.label_status), buffer);
}

/*
 * MODEL functions
 */
gboolean gj_gtk_roster_model_load(GList *roster)
{
  gj_gtk_roster_set_mode_connected();

  /* populate model */
  if(gj_gtk_roster_model_populate_from_roster(roster) == FALSE)
    {
      g_warning("gj_gtk_roster_model_load: failed to setup roster");
      return FALSE;
    }

  return TRUE;
}

gboolean gj_gtk_roster_model_unload()
{
  GtkTreeView *view = NULL;
  GtkTreeStore *store = NULL;

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_unload: view was NULL");
      return FALSE;
    }

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_unload: store was NULL");
      return FALSE;
    }

  /* clear roster */
  gtk_tree_store_clear(store);
  
  gj_gtk_roster_set_mode_disconnected();

  return TRUE;
}

gboolean gj_gtk_roster_model_setup()
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeSelection *selection = NULL;

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_setup: view was NULL");
      return FALSE;
    }

  if((selection = GTK_TREE_SELECTION(gtk_tree_view_get_selection(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_setup: selection was NULL");
      return FALSE;
    }

  /* store */
  store = gtk_tree_store_new(COL_ROSTER_COUNT,
			     GDK_TYPE_PIXBUF, /* image */
			     GDK_TYPE_PIXBUF, /* old image (used for message/presence icon...etc) */
			     G_TYPE_STRING,   /* name */
			     G_TYPE_STRING,   /* jid */
			     G_TYPE_STRING,   /* group */
			     G_TYPE_STRING,   /* agent */
			     G_TYPE_BOOLEAN,  /* is agent */
			     G_TYPE_INT,      /* subscription */
			     G_TYPE_STRING,   /* resource */
			     G_TYPE_INT,      /* presence type */      
			     G_TYPE_INT,      /* presence show */
			     G_TYPE_INT,      /* timer (used for messages) */
			     G_TYPE_BOOLEAN,  /* visible */
			     G_TYPE_BOOLEAN); /* editable */

			     
  /* model */
  model = GTK_TREE_MODEL(store);
  gtk_tree_view_set_model(view, model);

  g_signal_connect (G_OBJECT(model), "row-inserted", G_CALLBACK(on_treeview_roster_row_inserted), NULL);
  g_signal_connect (G_OBJECT(model), "row-deleted", G_CALLBACK(on_treeview_roster_row_deleted), NULL);

  /* selection */
  gtk_tree_selection_set_mode(selection, GTK_SELECTION_SINGLE);
  g_signal_connect (G_OBJECT(selection), "changed", G_CALLBACK(on_treeview_roster_selection_changed), NULL);

  gj_gtk_roster_model_populate_columns(view);

  /* properties */
  gtk_tree_view_set_enable_search(view, TRUE);
  gtk_tree_view_set_search_column(view, COL_ROSTER_NAME); 
  gtk_tree_view_set_rules_hint(view, FALSE);
  gtk_tree_view_set_headers_visible(view, FALSE);
  gtk_tree_view_set_headers_clickable(view, FALSE);
  gtk_tree_view_columns_autosize(view);
/*   gtk_tree_view_expand_all(view); */

  /* clean up */
  g_object_unref(G_OBJECT(store));

  return TRUE;
}

gboolean gj_gtk_roster_model_populate_columns(GtkTreeView *view)
{
  GtkTreeViewColumn *column = NULL;
  GtkCellRenderer *renderer_text = NULL;
  GtkCellRenderer *renderer_image = NULL;

  if(view == NULL)
    {
      g_warning("gj_gtk_roster_model_populate_columns: view was NULL");
      return FALSE;
    }

  /* cell renderer's */
  renderer_image = gtk_cell_renderer_pixbuf_new();
  renderer_text = gtk_cell_renderer_text_new();

  column = gtk_tree_view_column_new();

  /* COL_ROSTER_IMAGE */
  gtk_tree_view_column_pack_start(column, renderer_image, FALSE);
  gtk_tree_view_column_add_attribute(column,
				     renderer_image,
				     "pixbuf",COL_ROSTER_IMAGE);  

  /* COL_ROSTER_NAME */
  gtk_tree_view_column_pack_end(column, renderer_text, TRUE);
  gtk_tree_view_column_add_attribute(column,
				     renderer_text,
				     "markup",COL_ROSTER_NAME);

  gtk_tree_view_column_add_attribute(column,
				     renderer_text,
				     "editable",COL_ROSTER_EDITABLE);

  /* set extra information required for editing */
  g_object_set_data(G_OBJECT(renderer_text), "column", (gint*)COL_ROSTER_NAME);

  /* insert column */
  gtk_tree_view_insert_column(GTK_TREE_VIEW(view), column, -1);

  return TRUE;
}

gboolean gj_gtk_roster_model_populate_from_roster(GList *roster)
{
  gint index = 0;
  gint count = 0;

  if(roster == NULL)
    {
      g_warning("gj_gtk_roster_model_populate_from_roster: roster was NULL");
      return FALSE;
    }

  /* add contacts to groups */
  for(index=0,count=0;index<g_list_length(roster);index++)
    {
      rosterItem ri = NULL;

      if((ri = (rosterItem) g_list_nth_data(roster, index)) == NULL)
	continue;

      gj_gtk_roster_model_add_contact(ri);
      count++;

      g_message("gj_gtk_roster_model_populate_from_roster: index:%2.2d using jid:'%s'",index, rosterItemGetJID(ri)); 
    }

  g_message("gj_gtk_roster_model_populate_from_roster: %d contacts all together",count);
  return TRUE;
}

gboolean gj_gtk_roster_model_add_contact(rosterItem ri)
{
  presence pres = NULL;

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact: rosterItem was NULL"); 
      return FALSE;
    }

  if((pres = rosterItemGetPresence(ri)) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact: could not get presence from roster item with JID:'%s'", rosterItemGetJID(ri)); 
      return FALSE;
    }
      
  /* check details */
  if(rosterItemGetName(ri) == NULL)
    {
      rosterItemSetName(ri, rosterItemGetJID(ri));
      g_message("gj_gtk_roster_model_add_contact: roster item had no name, using jid:'%s', as name", rosterItemGetJID(ri));
    }

  /* unknown contacts */
  if(rosterItemGetIsPermanent(ri) == FALSE && rosterItemGetSubscription(ri) == rosterItemSubscriptionNone)
    return gj_gtk_roster_model_add_contact_not_permanent(ri);

  /* agents */
  if(gj_gtk_mpf_get_hide_agents() == TRUE)
    {
      g_message("gj_gtk_roster_model_add_contact: agents not to be shown, not adding jid:'%s'", rosterItemGetJID(ri));
      return FALSE;
    }

  g_message("gj_gtk_roster_model_add_contact: roster item's current presence type:%d->'%s'", 
	    presenceGetType(pres), translatePresenceType(presenceGetType(pres)));

  /* offline contacts */
  if(presenceGetType(pres) == presenceTypeUnAvailable || presenceGetType(pres) == presenceTypeSubscribed)
    return gj_gtk_roster_model_add_contact_offline(ri);

  /* all others */
  if(gj_gtk_roster_model_add_contact_permanent(ri) == FALSE)
    return FALSE;

  /* set presence icon */
  gj_gtk_roster_set_presence(ri, presenceGetType(pres), presenceGetShow(pres), presenceGetStatus(pres));
  
  /* should we play sound ? */
  if(gj_gtk_mpf_get_sound_on_user_online() == TRUE)
    gj_gtk_support_sound_play(gj_gtk_mpf_get_sound_file_on_user_online());

  return TRUE;
}

gboolean gj_gtk_roster_model_add_contact_not_permanent(rosterItem ri)
{
  GtkTreeView *view = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter *iter = NULL;
  GtkTreeIter iter_child;

  gchar *group = ROSTER_GROUP_NOT_ON_ROSTER;
  GdkPixbuf *pb = NULL;

  presence pres = NULL;

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_not_permanent: rosterItem was NULL"); 
      return FALSE;
    }

  if((pres = rosterItemGetPresence(ri)) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_not_permanent: could not get presence from roster item with JID:'%s'", rosterItemGetJID(ri)); 
      return FALSE;
    }

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_not_permanent: view was NULL");
      return FALSE;
    }

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_not_permanent: store was NULL");
      return FALSE;
    }

  /* find 'not on roster' group */
  if((iter = gj_gtk_roster_model_find_iter_by_group(group)) == NULL)
    {
      g_message("gj_gtk_roster_model_add_contact_not_permanent: group:'%s' NOT found", group);
      
      if(gj_gtk_roster_model_add_group(group) == TRUE)
	{
	  g_message("gj_gtk_roster_model_add_contact_not_permanent: group:'%s' added", group);
	  iter = gj_gtk_roster_model_find_iter_by_group(group);
	}
      else
	{
	  g_warning("gj_gtk_roster_model_add_contact_not_permanent: group:'%s' could not be added", group);
	  iter = NULL;
	}
    }

  /* set pixbuf */
  pb = gj_gtk_support_pixbuf_new_from_file(FILE_PRESENCE_NONE);
  
  /* add to tree */
  gtk_tree_store_append(store, &iter_child, iter);
  gtk_tree_store_set(store, &iter_child,
		     COL_ROSTER_IMAGE, pb,
		     COL_ROSTER_IMAGE_OLD, NULL,
		     COL_ROSTER_NAME, rosterItemGetName(ri),
		     COL_ROSTER_JID, rosterItemGetJID(ri),
		     COL_ROSTER_GROUP, group,
		     COL_ROSTER_AGENT, rosterItemGetAgent(ri),
		     COL_ROSTER_IS_AGENT, rosterItemGetIsAgent(ri),
		     COL_ROSTER_RESOURCE, rosterItemGetResource(ri),
		     COL_ROSTER_SUBSCRIPTION, rosterItemGetSubscription(ri),
		     COL_ROSTER_PRESENCE_TYPE, presenceGetType(pres),
		     COL_ROSTER_PRESENCE_SHOW, presenceGetShow(pres),
		     COL_ROSTER_TIMER, 0,
		     COL_ROSTER_VISIBLE, TRUE,
		     COL_ROSTER_EDITABLE, FALSE,
		     -1);

  /* clean up */
  if(iter != NULL) gtk_tree_iter_free(iter);
  if(pb != NULL) g_object_unref(G_OBJECT(pb));
      
  return TRUE;
}

gboolean gj_gtk_roster_model_add_contact_offline(rosterItem ri)
{
  GtkTreeView *view = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter *iter = NULL;
  GtkTreeIter iter_child;

  gchar *group = ROSTER_GROUP_OFFLINE;
  gchar *group_list = NULL;
  gchar *name = NULL;
  GdkPixbuf *pb = NULL;

  presence pres = NULL;

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_offline: rosterItem was NULL"); 
      return FALSE;
    }

  if((pres = rosterItemGetPresence(ri)) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_offline: could not get presence from roster item with JID:'%s'", rosterItemGetJID(ri)); 
      return FALSE;
    }

  /* if hide offline contacts do not show */ 
  /* if hide offline group do not show */
  /* if show offline group put contacts in offline group */
  /* if show offline contacts and hide offline group show as normal */

  /*
    if hide offline contacts and hide offline group return
    if hide offline contacts and show offline group SHOULD NOT GET HERE. - so return
    if show offline contacts and hide offline group call gj_gtk_roster_model_add_contact_permanent
    if show offline contacts and show offline group continue
  */

  if(gj_gtk_mpf_get_hide_offline_contacts() == TRUE && gj_gtk_mpf_get_hide_offline_group() == TRUE)
    {
      g_message("gj_gtk_roster_model_add_contact_offline: hiding offline contacts, hiding offline group, not adding jid:'%s'", rosterItemGetJID(ri));
      return FALSE;
    }

  if(gj_gtk_mpf_get_hide_offline_contacts() == TRUE && gj_gtk_mpf_get_hide_offline_group() == FALSE)
    {
      g_message("gj_gtk_roster_model_add_contact_offline: hiding offline contacts, showing offline group, not adding jid:'%s'", rosterItemGetJID(ri));
      return FALSE;
    }

  if(gj_gtk_mpf_get_hide_offline_contacts() == FALSE && gj_gtk_mpf_get_hide_offline_group() == TRUE)
    {
      g_message("gj_gtk_roster_model_add_contact_offline: offline group hidden, showing offline contacts, adding permanent contact jid:'%s'", rosterItemGetJID(ri));
      return gj_gtk_roster_model_add_contact_permanent(ri);
    }


/*   if(gj_gtk_mpf_get_hide_offline_group() == TRUE) */
/*     { */
/*       g_message("gj_gtk_roster_model_add_contact: hiding offline group, not adding jid:'%s'", rosterItemGetJID(ri)); */
/*       return FALSE; */
/*     } */

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_offline: view was NULL");
      return FALSE;
    }

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_offline: store was NULL");
      return FALSE;
    }

  /* find 'not on roster' group */
  if((iter = gj_gtk_roster_model_find_iter_by_group(group)) == NULL)
    {
      g_message("gj_gtk_roster_model_add_contact_offline: group:'%s' NOT found", group);
      
      if(gj_gtk_roster_model_add_group(group) == TRUE)
	{
	  g_message("gj_gtk_roster_model_add_contact_offline: group:'%s' added", group);
	  iter = gj_gtk_roster_model_find_iter_by_group(group);
	}
      else
	{
	  g_warning("gj_gtk_roster_model_add_contact_offline: group:'%s' could not be added", group);
	  iter = NULL;
	}
    }

  /* set pixbuf */
  pb = gj_gtk_support_pixbuf_new_from_file(FILE_PRESENCE_UNAVAILABLE);

  /* set name - include groups */
  group_list = rosterItemGetGroupsAsString(ri);
  name = g_strdup_printf("%s %s%s%s",
			 rosterItemGetName(ri)?rosterItemGetName(ri):rosterItemGetJID(ri),
			 group_list?"[":"",
			 group_list?group_list:"",
			 group_list?"]":"");
  
  if(group_list != NULL) g_free(group_list);

  /* add to tree */
  gtk_tree_store_append(store, &iter_child, iter);
  gtk_tree_store_set(store, &iter_child,
		     COL_ROSTER_IMAGE, pb,
		     COL_ROSTER_IMAGE_OLD, NULL,
		     COL_ROSTER_NAME, name,
		     COL_ROSTER_JID, rosterItemGetJID(ri),
		     COL_ROSTER_GROUP, group,
		     COL_ROSTER_AGENT, rosterItemGetAgent(ri),
		     COL_ROSTER_IS_AGENT, rosterItemGetIsAgent(ri),
		     COL_ROSTER_RESOURCE, rosterItemGetResource(ri),
		     COL_ROSTER_SUBSCRIPTION, rosterItemGetSubscription(ri),
		     COL_ROSTER_PRESENCE_TYPE, presenceGetType(pres),
		     COL_ROSTER_PRESENCE_SHOW, presenceGetShow(pres),
		     COL_ROSTER_TIMER, 0,
		     COL_ROSTER_VISIBLE, TRUE,
		     COL_ROSTER_EDITABLE, FALSE,
		     -1);

  /* clean up */
  if(iter != NULL) gtk_tree_iter_free(iter);
  if(pb != NULL) g_object_unref(G_OBJECT(pb));
      
  return TRUE;
}

gboolean gj_gtk_roster_model_move_contact_online(rosterItem ri)
{
  GtkTreeView *view = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter *iter = NULL;
  GtkTreeIter iter_child;

  gchar *group = NULL;
  GdkPixbuf *pb = NULL;

  presence pres = NULL;

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_model_move_contact_online: rosterItem was NULL"); 
      return FALSE;
    }

  if((pres = rosterItemGetPresence(ri)) == NULL)
    {
      g_warning("gj_gtk_roster_model_move_contact_online: could not get presence from roster item with JID:'%s'", rosterItemGetJID(ri)); 
      return FALSE;
    }

  /* NOTE: what we want to do here is take the details of the 
           offline contact, and replicate them for all the groups
	   that they belong to. plus we want the contact to be in an 
	   available state.  */

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_move_contact_online: view was NULL");
      return FALSE;
    }

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_move_contact_online: store was NULL");
      return FALSE;
    }

  if((iter = gj_gtk_roster_model_find_iter_by_group(group)) == NULL)
    {
      g_message("gj_gtk_roster_model_move_contact_online: group:'%s' NOT found", group);
      
      if(gj_gtk_roster_model_add_group(group) == TRUE)
	{
	  g_message("gj_gtk_roster_model_move_contact_online: group:'%s' added", group);
	  iter = gj_gtk_roster_model_find_iter_by_group(group);
	}
      else
	{
	  g_warning("gj_gtk_roster_model_move_contact_online: group:'%s' could not be added", group);
	  iter = NULL;
	}
    }

  /* set pixbuf */
  pb = gj_gtk_support_pixbuf_new_from_file(FILE_PRESENCE_AVAILABLE);
  
  /* add to tree */
  gtk_tree_store_append(store, &iter_child, iter);
  gtk_tree_store_set(store, &iter_child,
		     COL_ROSTER_IMAGE, pb,
		     COL_ROSTER_IMAGE_OLD, NULL,
		     COL_ROSTER_NAME, rosterItemGetName(ri),
		     COL_ROSTER_JID, rosterItemGetJID(ri),
		     COL_ROSTER_GROUP, group,
		     COL_ROSTER_AGENT, rosterItemGetAgent(ri),
		     COL_ROSTER_IS_AGENT, rosterItemGetIsAgent(ri),
		     COL_ROSTER_RESOURCE, rosterItemGetResource(ri),
		     COL_ROSTER_SUBSCRIPTION, rosterItemGetSubscription(ri),
		     COL_ROSTER_PRESENCE_TYPE, presenceGetType(pres),
		     COL_ROSTER_PRESENCE_SHOW, presenceGetShow(pres),
		     COL_ROSTER_TIMER, 0,
		     COL_ROSTER_VISIBLE, TRUE,
		     COL_ROSTER_EDITABLE, FALSE,
		     -1);

  /* clean up */
  if(iter != NULL) gtk_tree_iter_free(iter);
  if(pb != NULL) g_object_unref(G_OBJECT(pb));
      
  return TRUE;
}

gboolean gj_gtk_roster_model_add_contact_permanent(rosterItem ri)
{
  GtkTreeView *view = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter iter_child;
  
  gint i = 0;

  presence pres = NULL;

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_permanent: rosterItem was NULL"); 
      return FALSE;
    }

  if((pres = rosterItemGetPresence(ri)) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_permanent: could not get presence from roster item with JID:'%s'", rosterItemGetJID(ri)); 
      return FALSE;
    }

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_permanent: view was NULL");
      return FALSE;
    }

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_contact_permanent: store was NULL");
      return FALSE;
    }

  g_message("gj_gtk_roster_model_add_contact_permanent: contact:'%s' belongs to %d groups", 
	    rosterItemGetJID(ri), g_list_length(rosterItemGetGroups(ri)));
  
  /* loop through and add contact for each group they belong to */
  for(i=0;rosterItemGetGroups(ri) != NULL && i < g_list_length(rosterItemGetGroups(ri));i++)
    {
      GtkTreeIter *iter = NULL;
      GdkPixbuf *pb = NULL;
      gchar *group = NULL;

      group = (gchar*) g_list_nth_data(rosterItemGetGroups(ri), i); 
      g_message("gj_gtk_roster_model_add_contact_permanent: looking for group:'%s', index:%d", group, i);
      
      /* find group */
      if((iter = gj_gtk_roster_model_find_iter_by_group(group)) == NULL)
	{
	  g_message("gj_gtk_roster_model_add_contact_permanent: group:'%s' NOT found", group);
	  
	  /* if it doesnt exist should we create one? */
	  if(group != NULL)
	    {
	      g_message("gj_gtk_roster_model_add_contact_permanent: group:'%s' is NOT NULL... creating", group);
	      
	      if(gj_gtk_roster_model_add_group(group) == TRUE)
		{
		  g_message("gj_gtk_roster_model_add_contact_permanent: group:'%s' added", group);
		  iter = gj_gtk_roster_model_find_iter_by_group(group);
		}
	      else
		{
		  g_warning("gj_gtk_roster_model_add_contact_permanent: group:'%s' could not be added", group);
		  iter = NULL;
		}
	    }
	}
      else
	{
	  g_message("gj_gtk_roster_model_add_contact_permanent: group:'%s' found!", group);
	}
      
      /* pixbuf */
      pb = gj_gtk_support_pixbuf_new_from_file(FILE_PRESENCE_UNAVAILABLE);
      
      /* add to store */
      gtk_tree_store_append(store, &iter_child, iter);

      /* set store */
      gtk_tree_store_set(store, &iter_child,
			 COL_ROSTER_IMAGE, pb,
			 COL_ROSTER_IMAGE_OLD, NULL,
			 COL_ROSTER_NAME, rosterItemGetName(ri),
			 COL_ROSTER_JID, rosterItemGetJID(ri),
			 COL_ROSTER_GROUP, group,
			 COL_ROSTER_AGENT, rosterItemGetAgent(ri),
			 COL_ROSTER_IS_AGENT, rosterItemGetIsAgent(ri),
			 COL_ROSTER_RESOURCE, rosterItemGetResource(ri),
			 COL_ROSTER_SUBSCRIPTION, rosterItemGetSubscription(ri),
			 COL_ROSTER_PRESENCE_TYPE, presenceGetType(pres),
			 COL_ROSTER_PRESENCE_SHOW, presenceGetShow(pres),
			 COL_ROSTER_TIMER, 0,
			 COL_ROSTER_VISIBLE, TRUE,
			 COL_ROSTER_EDITABLE, FALSE,
			 -1);
      
      /* clean up */
      if(iter != NULL) gtk_tree_iter_free(iter);
      if(pb != NULL) g_object_unref(G_OBJECT(pb));
    }
  
  /*
    NOTE: this section is used for contacts which do not have a group
    and although this is totally plausable, future considerations 
    may involve contacts having a default pool/group when they do 
    not already belong to one.
  */
  if(rosterItemGetGroups(ri) == NULL)
    {
      GdkPixbuf *pb = NULL;

      g_message("gj_gtk_roster_model_add_contact_permanent: contact:'%s' has no group",rosterItemGetJID(ri));

      /* get image */
      pb = gj_gtk_support_pixbuf_new_from_file(FILE_PRESENCE_UNAVAILABLE);

      /* add to store */
      gtk_tree_store_append(store, &iter_child, NULL);
      gtk_tree_store_set(store, &iter_child,
			 COL_ROSTER_IMAGE, pb,
			 COL_ROSTER_IMAGE_OLD, NULL,
			 COL_ROSTER_NAME, rosterItemGetName(ri),
			 COL_ROSTER_JID, rosterItemGetJID(ri),
			 COL_ROSTER_GROUP, NULL,
			 COL_ROSTER_AGENT, rosterItemGetAgent(ri),
			 COL_ROSTER_IS_AGENT, rosterItemGetIsAgent(ri),
			 COL_ROSTER_RESOURCE, rosterItemGetResource(ri),
			 COL_ROSTER_SUBSCRIPTION, rosterItemGetSubscription(ri),
			 COL_ROSTER_PRESENCE_TYPE, presenceGetType(pres),
			 COL_ROSTER_PRESENCE_SHOW, presenceGetShow(pres),
			 COL_ROSTER_TIMER, 0,
			 COL_ROSTER_VISIBLE, TRUE,
			 COL_ROSTER_EDITABLE, FALSE,
			 -1);

      /* clean up */
      if(pb != NULL) g_object_unref(G_OBJECT(pb));
    }

  return TRUE;
}

gboolean gj_gtk_roster_model_add_group(gchar *group)
{
  GtkTreeView *view = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter *iter = NULL;
  GtkTreeIter iter_new;

  GdkPixbuf *pb = NULL;

  gchar *markup = NULL;

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_group: view was NULL");
      return FALSE;
    }

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_add_group: store was NULL");
      return FALSE;
    }

  if(group == NULL)
    {
      g_warning("gj_gtk_roster_model_add_group: group was NULL");
      return FALSE;
    }

  /* find group */
  if((iter = gj_gtk_roster_model_find_iter_by_group(group)) != NULL)
    {
      g_warning("gj_gtk_roster_model_add_group: group already exists");
      gtk_tree_iter_free(iter);
      return FALSE;
    }

  markup = g_strdup_printf("<b>%s</b>",group);
  pb = gj_gtk_support_pixbuf_new_from_file(FILE_GROUPS);
      
  /* add contact to store */
  gtk_tree_store_prepend(store, &iter_new, NULL);
  gtk_tree_store_set(store, &iter_new,
		     COL_ROSTER_IMAGE, pb,
		     COL_ROSTER_IMAGE_OLD, NULL,
		     COL_ROSTER_NAME, markup,
		     COL_ROSTER_JID, NULL,
		     COL_ROSTER_GROUP, group,
		     COL_ROSTER_AGENT, NULL,
		     COL_ROSTER_IS_AGENT, FALSE,
		     COL_ROSTER_RESOURCE, NULL,
		     COL_ROSTER_SUBSCRIPTION, -1,
		     COL_ROSTER_PRESENCE_TYPE, -1,
		     COL_ROSTER_PRESENCE_SHOW, -1,
		     COL_ROSTER_TIMER, 0,
		     COL_ROSTER_VISIBLE, TRUE,
		     COL_ROSTER_EDITABLE, FALSE,
		     -1);

  /*  gj_gtk_roster_model_groups_add(group);*/

  /* clean up */
  if(markup != NULL) g_free(markup);
  if(pb != NULL) g_object_unref(G_OBJECT(pb));

  return TRUE;
}

gboolean gj_gtk_roster_model_remove_contact(rosterItem ri)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter iter;

  gboolean valid = FALSE;
  gboolean removed = FALSE;
  gint count = 0;

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_model_remove_contact: rosterItem was NULL");
      return FALSE;
    }

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_remove_contact: view was NULL");
      return FALSE;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_remove_contact: model was NULL");
      return FALSE;
    }

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_remove_contact: store was NULL");
      return FALSE;
    }

  /* NOTE: at this point, we need to continue searching
     the roster for other copies of the same JID for different
     groups. */

  /* get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(; valid == TRUE; removed = FALSE)
    {
      /* check for children */
      if(gtk_tree_model_iter_has_child(model,&iter) == TRUE)
	{
	  GtkTreeIter iterchild;
	  gint children = 0;
	  gint index = 0;

	  children = gtk_tree_model_iter_n_children(model,&iter);

	  for(index=0; index<children; index++)
	    {
	      if((valid = gtk_tree_model_iter_nth_child(model, &iterchild, &iter, index)) == TRUE)
		{
		  gchar *jid = NULL;
		  gchar *group = NULL;
		  
		  gtk_tree_model_get(model, &iterchild, 
				     COL_ROSTER_JID, &jid,
				     COL_ROSTER_GROUP, &group,
				     -1);
		  
		  if(jid != NULL)
		    {
		      if(strcmp(jid, rosterItemGetJID(ri)) == 0)
			{
			  g_message("gj_gtk_roster_model_remove_contact: removing contact with jid:'%s' from group:'%s'", jid, group);
			  
			  if(children <= 1)
			    valid = gtk_tree_store_remove(store, &iter);
			  else
			    valid = gtk_tree_store_remove(store, &iterchild);

			  removed = TRUE;
			  count++;
			}
		    }

		  if(jid != NULL) g_free(jid);
		  if(group != NULL) g_free(group);	
		}
	    }
	}
      else
	{
	  gchar *jid = NULL;
	  gchar *group = NULL;
	  
	  gtk_tree_model_get(model, &iter, 
			     COL_ROSTER_JID, &jid,
			     COL_ROSTER_GROUP, &group,
			     -1);
	  
	  if(jid != NULL)
	    {
	      if(strcmp(jid, rosterItemGetJID(ri)) == 0)
	      {
		  g_message("gj_gtk_roster_model_remove_contact: removing contact with jid:'%s' from group:'%s'", jid, group);
		  valid = gtk_tree_store_remove(store, &iter);

		  removed = TRUE;
		  count++;
	      }
	    }
	  
	  if(jid != NULL) g_free(jid);
	  if(group != NULL) g_free(group);
	}  

      /* this has to be done here... because of the condition 
	 if an item is removed, the next item is what the iter is set to. */
       if(removed == FALSE) valid = gtk_tree_model_iter_next(model, &iter);
     }

  if(count == 0)
    g_warning("gj_gtk_roster_model_remove_contact: jid:'%s' NOT found", rosterItemGetJID(ri));
  
  return TRUE;
}

GtkTreeIter *gj_gtk_roster_model_find_iter_by_name(gchar *name)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeIter iter;
  
  gboolean valid = FALSE;

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_find_iter_by_name: view was NULL");
      return NULL;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_find_iter_by_name: model was NULL");
      return NULL;
    } 

  if(name == NULL || strlen(name) < 1)
    {
      g_warning("gj_gtk_roster_model_find_iter_by_name: name was NULL");
      return NULL;
    } 

  /* Get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(;valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      /* name will ALWAYS be a child not a parent like a group will be */

      /* check for chldren */
      if(gtk_tree_model_iter_has_child(model,&iter) == TRUE)
	{
	  GtkTreeIter iterchild;
	  gint children = 0;
	  gint index = 0;

	  children = gtk_tree_model_iter_n_children(model,&iter);

	  for(index=0;index<children;index++)
	    {
	      valid = gtk_tree_model_iter_nth_child(model,&iterchild,&iter,index);

	      if(valid)
		{
		  gchar *text = NULL;
		  
		  gtk_tree_model_get(model, &iterchild, 
				     COL_ROSTER_NAME, &text,
				     -1);
		  
		  if(text != NULL && strcmp(text,name) == 0)
		    {
		      g_free(text);
		      return gtk_tree_iter_copy(&iterchild);
		    }
		  
		  g_free(text);
		  text = NULL;
		}
	    }
	}
    }
  
  return NULL;
}

GtkTreeIter *gj_gtk_roster_model_find_iter_by_group(gchar *group)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeIter iter;
  
  gboolean valid = FALSE;

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_find_iter_by_group: view was NULL");
      return NULL;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_find_iter_by_group: model was NULL");
      return NULL;
    } 

  if(group == NULL || strlen(group) < 1)
    {
      g_warning("gj_gtk_roster_model_find_iter_by_group: group was NULL");
      return NULL;
    } 

  /* Get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(;valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      gchar *text = NULL;
      
      gtk_tree_model_get(model, &iter, 
			 COL_ROSTER_GROUP, &text,
			 -1);
      
      if(text != NULL && strcmp(text,group) == 0)
	{
	  g_free(text);
	  return gtk_tree_iter_copy(&iter);
	}
      
      g_free(text);
      text = NULL;
    }
  
  return NULL;
}

GtkTreeIter *gj_gtk_roster_model_find_iter_by_jid(gchar *jid, GtkTreeIter *iter_start)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeIter *iter_copy = NULL;
  GtkTreeIter iter;

  gboolean valid = FALSE;

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_find_iter_by_jid: view was NULL");
      return NULL;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_find_iter_by_jid: model was NULL");
      return NULL;
    } 

  if(jid == NULL || strlen(jid) < 1)
    {
      g_warning("gj_gtk_roster_model_find_iter_by_jid: jid was NULL");
      return NULL;
    } 

  /* Get the first iter in the list */
  if(iter_start == NULL)
    valid = gtk_tree_model_get_iter_first(model, &iter);
  else
    iter = *iter_start;

  /* !!! should check the validity of the iter at some point */

  for(;valid == TRUE && iter_copy == NULL; valid = gtk_tree_model_iter_next(model, &iter))
    {
      /* check for children */
      if(gtk_tree_model_iter_has_child(model,&iter) == TRUE)
	{
	  GtkTreeIter iterchild;
	  gint children = 0;
	  gint index = 0;

	  children = gtk_tree_model_iter_n_children(model,&iter);

	  for(index=0; index<children && iter_copy == NULL; index++)
	    {
	      if((valid = gtk_tree_model_iter_nth_child(model,&iterchild,&iter,index)) == TRUE)
		{
		  gchar *text = NULL;
		  
		  gtk_tree_model_get(model, &iterchild, 
				     COL_ROSTER_JID, &text,
				     -1);
		  
		  if(text != NULL && strcmp(text,jid) == 0)
		    iter_copy = gtk_tree_iter_copy(&iterchild);
		  
		  g_free(text);
		  text = NULL;
		}
	    }
	}
      else
	{
	  gchar *text = NULL;
	  
	  gtk_tree_model_get(model, &iter, 
			     COL_ROSTER_JID, &text,
			     -1);
	  
	  if(text != NULL && strcmp(text,jid) == 0)
	    iter_copy = gtk_tree_iter_copy(&iter);
	  
	  g_free(text);
	  text = NULL;
	}
    }
  
  return iter_copy;
}

gboolean gj_gtk_roster_model_get_selection(gchar **name, gchar **jid)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeSelection *selection = NULL;
  GtkTreeIter iter;
 
  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_get_selection: view was NULL");
      return FALSE;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_get_selection: model was NULL");
      return FALSE;
    } 

  if((selection = GTK_TREE_SELECTION(gtk_tree_view_get_selection(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_get_selection: selection was NULL");
      return FALSE;
    } 

  if(name == NULL || jid == NULL)
    {
      g_warning("gj_gtk_roster_model_get_selection: name or JID pointers passed were NULL");
      return FALSE;
    }

  if(gtk_tree_selection_get_selected(selection, &model, &iter) == FALSE)
    return FALSE;
  
  gtk_tree_model_get(model, &iter, 
		     COL_ROSTER_NAME, name,
		     COL_ROSTER_JID, jid,
		     -1);     

  return TRUE;
}

/* 
 * ROSTER properties
 */
presenceType gj_gtk_roster_model_get_presence_type(rosterItem ri)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeIter *iter = NULL;
  
  gint type = 0;
/*   gint show = 0; */

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_model_get_presence_type: view was NULL");
      return presenceTypeEnd;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_model_get_presence_type: model was NULL");
      return presenceTypeEnd;
    } 

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_model_get_presence_type: rosterItem was NULL");
      return presenceTypeEnd;
    }

  /* NOTE: only 1 instance of the JID needs to be looked up 
           to aquire the presence from the store, as they should
	   all be the same.  Find the first one, and use that.
  */
  if((iter = gj_gtk_roster_model_find_iter_by_jid(rosterItemGetJID(ri), NULL)) == NULL)
    {
      g_warning("gj_gtk_roster_model_get_presence_type: iterator was NULL");
      return presenceTypeEnd;
    }

  /* get details */
  gtk_tree_model_get(model, iter, 
		     COL_ROSTER_PRESENCE_TYPE, &type,
/* 		     COL_ROSTER_PRESENCE_SHOW, &show, */
		     -1);

  /* clean up */
  gtk_tree_iter_free(iter);

  return type;
}

gboolean gj_gtk_roster_set_presence(rosterItem ri, presenceType type, presenceShow show, gchar *status)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter *iter_find = NULL;
  GtkTreeIter iter;

  gchar *file = FILE_PRESENCE_NONE;
  gboolean valid = FALSE;
  
  gboolean ignore_presence = FALSE;

  /* find roster item by JID */
  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_set_presence: rosterItem was NULL");
      return FALSE;
    }

  /* get widgets */
  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_set_presence: view was NULL");
      return FALSE;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_set_presence: model was NULL");
      return FALSE;
    }

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_set_presence: store was NULL");
      return FALSE;
    }

  /* this statement should only be true when removing an agent.
     for some reason, the presence of the agent is sent AFTER 
     you request to remove it and your subscription from the roster */
  if(type == presenceTypeUnAvailable && status != NULL && strcmp(status,"Unregistered") == 0 &&
     rosterItemGetSubscription(ri) == rosterItemSubscriptionNone &&
     rosterItemGetIsPermanent(ri) == FALSE)
    {
      ignore_presence = TRUE;
    }
      
  /* the event viewer handles presence errors */
  if(type == presenceTypeError)
    ignore_presence = TRUE;

  /* throw this call out if conditions are met */
  if(ignore_presence == TRUE)
    {
      g_message("gj_gtk_roster_set_presence: presence type was error or presence was for a roster item just removed, not adding to the roster, ignoring this event");
      return TRUE;
    }

  /*
   * do we keep it or remove it? 
   */
  if(type == presenceTypeUnAvailable)
    {
      gint remove = 0;
      gboolean remove_forever = FALSE;

      if(rosterItemGetIsAgent(ri) == TRUE && gj_gtk_mpf_get_hide_agents() == TRUE)
	remove += 1;
      
      if(rosterItemGetIsPermanent(ri) == TRUE && rosterItemGetSubscription(ri) != rosterItemSubscriptionNone)
	remove += 1;

      /* if hide offline contacts remove from list and return */
      /* if show offline contacts and show offline group, remove and add again and return */
      /* if show offline contacts and hide offline group, remove from list and continue */

      if(remove > 0)
	{
	  g_message("gj_gtk_roster_set_presence: removing jid:'%s'", rosterItemGetJID(ri));
	  gj_gtk_roster_model_remove_contact(ri);

	  if(gj_gtk_mpf_get_hide_offline_contacts() == FALSE && gj_gtk_mpf_get_hide_offline_group() == FALSE)
	    {
	      g_message("gj_gtk_roster_set_presence: re-adding jid:'%s', into offline group", rosterItemGetJID(ri));
	      gj_gtk_roster_model_add_contact(ri);
	      return TRUE;
	    }
	  else if(gj_gtk_mpf_get_hide_offline_group() == TRUE)
	    {
	      /* continue */
	      g_message("gj_gtk_roster_set_presence: continuing to set presence for jid:'%s'", 
			rosterItemGetJID(ri));
	    }
	  else
	    return TRUE;
	}
    }
  else
    {
      /* if hide offline contacts do nothing, contact will be added */
      /* if show offline contacts and show offline group remove contact so it will be re-added */
      /* if show offline contacts and hide offline group do nothing, contact will be updated */

      if(gj_gtk_mpf_get_hide_offline_contacts() == FALSE && gj_gtk_mpf_get_hide_offline_group() == FALSE)
	{
	  presenceType type = presenceTypeEnd;
	  type = gj_gtk_roster_model_get_presence_type(ri);

	  if(type == presenceTypeUnAvailable || type == presenceTypeSubscribed)
	    {
	      g_message("gj_gtk_roster_set_presence: removing jid:'%s' from offline group, item will be re-added.", rosterItemGetJID(ri));
	      gj_gtk_roster_model_remove_contact(ri);
	    }
	}
    }
  
  if(rosterItemGetSubscription(ri) != rosterItemSubscriptionNone)
    {
      if(type != presenceTypeAvailable)
	{
	  switch(type)
	    {
	    case presenceTypeUnAvailable:
	      file = FILE_PRESENCE_UNAVAILABLE;
	      break;
	    case presenceTypeSubscribe:
	      file = FILE_PRESENCE_SUBSCRIBE;
	      break;
	    case presenceTypeUnSubscribe:
	      file = FILE_PRESENCE_UNSUBSCRIBE;
	      break;
	    case presenceTypeSubscribed:
	      file = FILE_PRESENCE_SUBSCRIBED;
	      break;
	    case presenceTypeUnSubscribed:
	      file = FILE_PRESENCE_UNSUBSCRIBED;
	      break;
	    case presenceTypeError:
	      file = FILE_PRESENCE_ERROR;
	      break;
	    default:
	      g_warning("gj_gtk_roster_set_presence: failed to determin presence 'type'");
	      return FALSE;
	    }
	}
      else
	{
	  switch(show)
	    {
	    case presenceShowAway:
	      file = FILE_PRESENCE_AWAY;
	      break;
	    case presenceShowChat:
	      file = FILE_PRESENCE_CHAT;
	      break;
	    case presenceShowDND:
	      file = FILE_PRESENCE_DND;
	      break;
	    case presenceShowNormal:
	      file = FILE_PRESENCE_NORMAL;
	      break;
	    case presenceShowXA:
	      file = FILE_PRESENCE_XA;
	      break;
	    default:
	      g_warning("gj_gtk_roster_set_presence: failed to determin presence 'show'");
	      return FALSE;
	    }
	}
    }

  g_message("gj_gtk_roster_set_presence: setting for jid:'%s', type:%d, show:%d", rosterItemGetJID(ri), type, show);

  if((iter_find = gj_gtk_roster_model_find_iter_by_jid(rosterItemGetJID(ri), NULL)) == NULL)
    {
      /* 
       * this section strictly is to create the user if 
       * they dont already exist.
       *
       */
      
      g_message("gj_gtk_roster_set_presence: could not find jid:'%s' on roster", rosterItemGetJID(ri));

      if(gj_gtk_roster_model_add_contact(ri) == FALSE)
	{
	  g_warning("gj_gtk_roster_set_presence: jid:'%s' could not be added to roster.", rosterItemGetJID(ri));
	  return FALSE;
	}
    }
  else
    gtk_tree_iter_free(iter_find);

  /* NOTE: at this point, we need to continue searching
     the roster for other copies of the same JID for different
     groups. */

  /* get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(;valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      /* check for children */
      if(gtk_tree_model_iter_has_child(model,&iter) == TRUE)
	{
	  GtkTreeIter iterchild;
	  gint children = 0;
	  gint index = 0;

	  children = gtk_tree_model_iter_n_children(model,&iter);

	  for(index=0; index<children; index++)
	    {
	      if((valid = gtk_tree_model_iter_nth_child(model, &iterchild, &iter, index)) == TRUE)
		{
		  gchar *text = NULL;
		  
		  gtk_tree_model_get(model, &iterchild, 
				     COL_ROSTER_JID, &text,
				     -1);
		  
		  if(text != NULL)
		    {
		      if(strcmp(text, rosterItemGetJID(ri)) == 0)
			{
			    GdkPixbuf *pb = NULL;
			    pb = gj_gtk_support_pixbuf_new_from_file(file);

			    gtk_tree_store_set(store, &iterchild,
					       COL_ROSTER_IMAGE, pb,
					       COL_ROSTER_IMAGE_OLD, NULL,
					       COL_ROSTER_PRESENCE_TYPE, type,
					       COL_ROSTER_PRESENCE_SHOW, show,
					       -1);
			    
			  if(pb != NULL) g_object_unref(G_OBJECT(pb));
			}

		      g_free(text);
		      text = NULL;
		    }
		}
	    }
	}
      else
	{
	  gchar *text = NULL;
	  
	  gtk_tree_model_get(model, &iter, 
			     COL_ROSTER_JID, &text,
			     -1);
	  
	  if(text != NULL)
	    {
	      if(strcmp(text, rosterItemGetJID(ri)) == 0)
		{
		    GdkPixbuf *pb = NULL;
		    pb = gj_gtk_support_pixbuf_new_from_file(file);
		    
		    gtk_tree_store_set(store, &iter,
				       COL_ROSTER_IMAGE, pb,
				       COL_ROSTER_IMAGE_OLD, NULL,
				       COL_ROSTER_PRESENCE_TYPE, type,
				       COL_ROSTER_PRESENCE_SHOW, show,
				       -1);

		    if(pb != NULL) g_object_unref(G_OBJECT(pb));
		}

	      g_free(text);
	      text = NULL;
	    }
	}  
    }

  return TRUE;
}

gboolean gj_gtk_roster_set_message(rosterItem ri, messageType type)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter *iter_find = NULL;
  GtkTreeIter iter;

  gchar *file = NULL;
  gboolean valid = FALSE;

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_set_message: view was NULL");
      return FALSE;
    }

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_set_message: model was NULL");
      return FALSE;
    } 

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_set_message: store was NULL");
      return FALSE;
    } 

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_set_message: rosterItem was NULL");
      return FALSE;
    }

  switch(type)
    {
    case messageTypeNormal:
      file = FILE_MESSAGE_NORMAL;
      break;
    case messageTypeChat:
      file = FILE_MESSAGE_CHAT;
      break;
    case messageTypeGroupChat:
      file = FILE_MESSAGE_GROUPCHAT;
      break;
    case messageTypeHeadline:
      file = FILE_MESSAGE_HEADLINE;
      break;
    case messageTypeError:
      file = FILE_MESSAGE_ERROR;
      break;
      
      case messageTypeXEvent:
	g_message("gj_gtk_roster_set_message: not doing anything with xevent");
	return TRUE;

    default:
      g_warning("gj_gtk_roster_set_message: failed to determin presence 'type'");
      return FALSE;
    }

  if((iter_find = gj_gtk_roster_model_find_iter_by_jid(rosterItemGetJID(ri), NULL)) == NULL)
    {
      /* 
       * this section strictly is to create the user if 
       * they dont already exist.
       *
       */
      
      g_message("gj_gtk_roster_set_presence: could not find jid:'%s' on roster", rosterItemGetJID(ri));

      if(gj_gtk_roster_model_add_contact(ri) == FALSE)
	{
	  g_warning("gj_gtk_roster_set_presence: jid:'%s' could not be added to roster.", rosterItemGetJID(ri));
	  return FALSE;
	}
    }
  else
    gtk_tree_iter_free(iter_find);

  /* NOTE: at this point, we need to continue searching
     the roster for other copies of the same JID for different
     groups. */

  /* get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(;valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      /* check for children */
      if(gtk_tree_model_iter_has_child(model,&iter) == TRUE)
	{
	  GtkTreeIter iterchild;
	  gint children = 0;
	  gint index = 0;

	  children = gtk_tree_model_iter_n_children(model,&iter);

	  for(index=0; index<children; index++)
	    {
	      if((valid = gtk_tree_model_iter_nth_child(model, &iterchild, &iter, index)) == TRUE)
		{
		  gchar *text = NULL;
		  
		  gtk_tree_model_get(model, &iterchild, 
				     COL_ROSTER_JID, &text,
				     -1);
		  
		  if(text != NULL)
		    {
		      if(strcmp(text, rosterItemGetJID(ri)) == 0)
			{
			    GdkPixbuf *pb = NULL;
			    pb = gj_gtk_support_pixbuf_new_from_file(file);

			    gtk_tree_store_set(store, &iterchild,
					       COL_ROSTER_IMAGE, pb,
					       COL_ROSTER_IMAGE_OLD, NULL,
					       -1);
			    
			  if(pb != NULL) g_object_unref(G_OBJECT(pb));
			}

		      g_free(text);
		      text = NULL;
		    }
		}
	    }
	}
      else
	{
	  gchar *text = NULL;
	  
	  gtk_tree_model_get(model, &iter, 
			     COL_ROSTER_JID, &text,
			     -1);
	  
	  if(text != NULL)
	    {
	      if(strcmp(text, rosterItemGetJID(ri)) == 0)
		{
		    GdkPixbuf *pb = NULL;
		    pb = gj_gtk_support_pixbuf_new_from_file(file);
		    
		    gtk_tree_store_set(store, &iter,
				       COL_ROSTER_IMAGE, pb,
				       COL_ROSTER_IMAGE_OLD, NULL,
				       -1);

		    if(pb != NULL) g_object_unref(G_OBJECT(pb));
		}

	      g_free(text);
	      text = NULL;
	    }
	}  
    }

  return TRUE;
}

gboolean gj_gtk_roster_user_set_presence(presenceType type, presenceShow show, gchar *status, gint priority)
{
  GtkWidget *image = NULL;

  gchar *file = NULL;
  gchar *text = NULL;

  /* checks */
  if(priority < 0)
    priority = 0;

  if(type != presenceTypeAvailable)
    {
      switch(type)
	{
	case presenceTypeUnAvailable:
	  file = FILE_PRESENCE_UNAVAILABLE;
	  text = g_strdup_printf("Unavailable");
	  break;
	default:
	  g_warning("gj_gtk_roster_user_set_presence: failed to determin presence 'type'");
	  return FALSE;
	}
    }
  else
    {
      switch(show)
	{
	case presenceShowAway:
	  file = FILE_PRESENCE_AWAY;
	  text = g_strdup_printf("Away");
	  break;
	case presenceShowChat:
	  file = FILE_PRESENCE_CHAT;
	  text = g_strdup_printf("Chat");
	  break;
	case presenceShowDND:
	  file = FILE_PRESENCE_DND;
	  text = g_strdup_printf("Do Not Disturb");
	  break;
	case presenceShowNormal:
	  file = FILE_PRESENCE_NORMAL;
	  text = g_strdup_printf("Normal");
	  break;
	case presenceShowXA:
	  file = FILE_PRESENCE_XA;
	  text = g_strdup_printf("eXtended Away");
	  break;
	default:
	  g_warning("gj_gtk_roster_user_set_presence: failed to determin presence 'show'");
	  return FALSE;
	}
    }

/*   text = g_strconcat("<b>",text,"</b>",NULL); */
/*   gtk_image_set_from_pixbuf(GTK_IMAGE(ctlRoster.image_presence),pixbuf); */
/*   gtk_label_set_markup(GTK_LABEL(ctlRoster.label_presence),text); */
/*   g_free(text); */

  /* set image */
  image = gtk_image_new_from_file(file);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(ctlRoster.mnu_presence),image);
  gtk_widget_show(image);
  
  /* send the status */
  presenceSend(type,show,status,priority);

  return TRUE;
}

void gj_gtk_roster_autoaway_update(guint time)
{
  /* if not connected - do nothing */
  if(gj_me_get_is_connected() == FALSE)
    {
      /*      g_message("gj_gtk_roster_autoaway_update: not connected...");*/
      return;
    }

  if(time > (60 * 1000))
    {
      guint x = time;
      guint seconds = 0;
      guint minutes = 0;
      guint hours = 0;
      guint days = 0;

      gchar *text = NULL;
      
      /* convert ms to seconds */
      x /= 1000;

      /* calculate from there */
      seconds = x % 60;
      x /= 60;
      minutes = x % 60;
      x /= 60;
      hours = x % 24;
      x /= 24;
      days = x;

      /* alert the user */
      text = g_strdup_printf("AutoAway %2.2d:%2.2d:%2.2d (%d days)",hours,minutes,seconds,days);
      gj_gtk_roster_set_status(text);
      g_free(text);

      /* set to autoaway mode */
      gj_me_set_is_auto_away(TRUE);

      /* check the options */
      if((time/1000) >= (gj_config_get_mpf_auto_away_after() * 60) && 
	 (time/1000) < (gj_config_get_mpf_auto_xa_after() * 60) && 
	 gj_me_get_auto_away_presence_show() != presenceShowAway)
	{
	  /* set to away */
	  gj_gtk_roster_user_set_presence(presenceTypeAvailable,
					  presenceShowAway,
					  gj_config_get_mpf_auto_away_status(),
					  0);

	  /* set state */
	  gj_me_set_auto_away_presence_show(presenceShowAway);
	} 
      else if((time/1000) >= (gj_config_get_mpf_auto_xa_after() * 60) && 
	      gj_me_get_auto_away_presence_show() != presenceShowXA)
	{
	  /* set to xa */
	  gj_gtk_roster_user_set_presence(presenceTypeAvailable,
					  presenceShowXA,
					  gj_config_get_mpf_auto_xa_status(),
					  0);

	  /* set state */
	  gj_me_set_auto_away_presence_show(presenceShowXA);
	}
    }
  else
    {
      if(gj_me_get_is_auto_away() == TRUE)
	{
	  presenceShow previous_presence_show = 0;
	  presenceType previous_presence_type = 0;
	  gchar *previous_presence_status = NULL;

	  /* alert the user */
	  gj_gtk_roster_set_status("Returned from AutoAway");

	  /* change presence */
	  /* what was it before?? - check the store? */
	  previous_presence_show = gj_me_get_presence_show();
	  previous_presence_type = gj_me_get_presence_type();
	  previous_presence_status = gj_me_get_presence_status();

	  /* set to normal */
	  gj_gtk_roster_user_set_presence(previous_presence_type,
					  previous_presence_show,
					  previous_presence_status,0);
	  
	  gj_me_set_is_auto_away(FALSE);
	  gj_me_set_auto_away_presence_show(previous_presence_show);
	}
    }
}

/* roster contact functions */
gboolean gj_gtk_roster_contact_read()
{
  GtkTreeSelection *selection = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeIter iter;

  gchar *jid = NULL;
  gchar *name = NULL;

  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(ctlRoster.treeview));
  if(gtk_tree_selection_get_selected(selection,&model,&iter) == FALSE)
    {
      /* return because there is NOTHING currently selected */
      g_message("gj_gtk_roster_contact_read: there is no selection.");
      return FALSE;
    }
  
  gtk_tree_model_get(model, &iter, 
		     COL_ROSTER_NAME, &name,
		     COL_ROSTER_JID, &jid,
		     -1);      
  
  gj_gtk_roster_handle_next_event(jid);
  gj_gtk_roster_handle_next_event_display(jid);
  
  if(name != NULL) g_free(name);
  if(jid != NULL) g_free(jid);
  
  return TRUE;
}

gboolean gj_gtk_roster_contact_new_message()
{
  gchar *jid = NULL;
  gchar *name = NULL;

  gj_gtk_roster_model_get_selection(&name,&jid);
  gj_gtk_mw_send_new(jid);
  
  if(name != NULL) g_free(name);
  if(jid != NULL) g_free(jid);

  return TRUE;
}

gboolean gj_gtk_roster_contact_new_chat()
{
  gchar *jid = NULL;
  gchar *name = NULL;

  gj_gtk_roster_model_get_selection(&name,&jid);
  gj_gtk_cw_send_new(jid);
  
  if(name != NULL) g_free(name);
  if(jid != NULL) g_free(jid);

  return TRUE;
}

gboolean gj_gtk_roster_contact_history()
{
  gchar *jid = NULL; 
  gchar *name = NULL; 
  
  history hist = NULL;
  
  gj_gtk_roster_model_get_selection(&name,&jid);
  
  if((hist = historyFindByJID(jid)) == NULL)
    {
      g_warning("gj_gtk_roster_contact_history: could not find history based on jid:'%s'", jid);
      return FALSE;
    }
  
  gj_gtk_support_open_url(historyGetFilename(hist));
  
  if(name != NULL) g_free(name);
  if(jid != NULL) g_free(jid);
  
  return TRUE;
}

gboolean gj_gtk_roster_contact_information()
{
  gchar *jid = NULL;
  gchar *name = NULL;

  gj_gtk_roster_model_get_selection(&name,&jid);
  gj_gtk_ui_load(jid);
  
  if(name != NULL) g_free(name);
  if(jid != NULL) g_free(jid);

  return TRUE;
}

gboolean gj_gtk_roster_contact_edit_groups()
{
  gchar *jid = NULL;
  gchar *name = NULL;

  gj_gtk_roster_model_get_selection(&name,&jid);
  gj_gtk_eg_load(jid);
  
  if(name != NULL) g_free(name);
  if(jid != NULL) g_free(jid);
  
  return TRUE;
}

gboolean gj_gtk_roster_contact_remove()
{
  gchar *jid = NULL;
  gchar *name = NULL;

  gj_gtk_roster_model_get_selection(&name,&jid);
  gj_gtk_roster_contact_remove_by_jid(jid);
  
  if(name != NULL) g_free(name);
  /* jid is freed later */

  return TRUE;
}

gboolean gj_gtk_roster_contact_remove_by_jid(gchar *jid)
{
  rosterItem ri = NULL;
  gchar *message = NULL;
  GList *contacts = NULL;

  if(jid == NULL || strlen(jid) < 1)
    {
      g_warning("gj_gtk_roster_contact_remove_by_jid: jid was NULL or len was < 1");
      return FALSE;
    }

  if((ri = rosterItemFindByJID(jid)) == NULL)
    {
      g_warning("gj_gtk_roster_contact_remove_by_jid: could not find roster item by jid:'%s'", jid);
      return FALSE;
    }

  if(rosterItemGetIsAgent(ri) == TRUE)
    contacts = rosterGetAllItemsByAgent(rosterItemGetJIDWithoutResource(ri));

  if(contacts != NULL)
    message = g_strdup_printf("You are about to remove agent: <u>%s</u> responsible for <b>%d</b> contacts!", 
			      jid, g_list_length(contacts));
  else
    message = g_strdup_printf("You are about to remove contact: <u>%s</u>!",jid);

  gj_gtk_msg_new(message, 
		 "Remove Contact", 
		 "Are you sure?",
		 TRUE,
		 GJ_GTK_MSG_BUTTON_YES | GJ_GTK_MSG_BUTTON_NO | GJ_GTK_MSG_ICON_QUESTION,
		 (MsgCb)gj_gtk_roster_remove_contact_msgbox_cb,
		 GINT_TO_POINTER(rosterItemGetID(ri)));
  
  /* clean up */
  if(jid != NULL) g_free(jid);
  if(message != NULL) g_free(message);
  if(contacts != NULL)
    {
      g_list_foreach(contacts, (GFunc)g_free, NULL);
      g_list_free(contacts);
    }

  return TRUE;
}

/*
 * EVENT HANDLING
 */
gboolean gj_gtk_roster_handle_next_event(gchar *jid)
{
  rosterItem ri = NULL;
  event ev = NULL;
  eventType type = -1;
  
  gint id = -1;
  gint count = 0;
  
  if((ri = rosterItemFindByJID(jid)) == NULL)
    {
      g_warning("gj_gtk_roster_handle_next_event: failed to get roster item by jid:'%s'",jid);
      return FALSE;
    }
  
  /* if no events waiting, do default action */
  if((count = eventCount(ri)) < 1)
    {
      g_message("gj_gtk_roster_handle_next_event: %d events waiting, therefore starting new chat...",count);

      /* we can start a chat... */
      gj_gtk_cw_default_action(jid);
      
      return TRUE;
    }

  if((id = eventIDNext(ri)) < 0)
    {
      g_warning("gj_gtk_roster_handle_next_event: failed to get eventID from roster item");
      return FALSE;
    }
  
  if((ev = eventFindByEventID(id)) == NULL)
    {
      g_warning("gj_gtk_roster_handle_next_event: failed to find event by ID:%d",id);
      return FALSE;
    }

  /* get event type */
  type = eventGetType(ev);

  g_message("gj_gtk_roster_handle_next_event: handling eventID:%d, type:%d",id,type);
  
  switch(type)
    {
    case eventTypePresence:
      /* shouldnt be here?!?!?!?!!?? */
      break;

    case eventTypeMessage:
      {
	message msg = (message) eventGetData(ev);
	
	if(messageGetType(msg) == messageTypeNormal)
	  {
	    msgWindow mw = NULL;
	    
	    /* notify of msg */
	    if((mw = gj_gtk_mw_notification_new(id, msg)) == NULL)
	      {
		g_warning("gj_gtk_roster_handle_next_event: new notification for eventID:%d returned NULL msg window",id);
		return FALSE;
	      }

	    /* DONT free the event, that is done when it has been handled */
	  }
	else if(messageGetType(msg) == messageTypeChat)
	  {
	    chatWindow cw = NULL;
	    
	    /* notify of chat */
	    if((cw = gj_gtk_cw_notification_new(msg)) == NULL)
	      {
		g_warning("gj_gtk_roster_handle_next_event: new notification for eventID:%d returned NULL chat window",id);
		return FALSE;

	      }

	    /* free event */
	    eventFree(ev);
	    
	    /* look for futher events of type 'chat' in queue */
	    while((ev = eventFindNextByTypeAndMessageType(ri,type,messageTypeChat)) != NULL)
	      {
		msg = (message) eventGetData(ev);
		id = eventGetID(ev);

		if(msg == NULL)
		  {
		    g_warning("gj_gtk_roster_handle_next_event: msg data was NULL, not handling...");

		    /* free event - no use to me now */
		    eventFree(ev);
		    continue;
		  }
		
		g_message("gj_gtk_roster_handle_next_event: handling next event of type:%d, id:%d",type,id);
		gj_gtk_cw_notification_new(msg);
	
		/* free event */
		eventFree(ev);
	      }
	  }
	else if(messageGetType(msg) == messageTypeHeadline)
	  {
	    headlineWindow hw = NULL;
	    
	    /* notify of headline */
	    if((hw = gj_gtk_hw_notification_new(id, msg)) == NULL)
	      {
		g_warning("gj_gtk_roster_handle_next_event: new notification for eventID:%d returned NULL chat window",id);
		return FALSE;

	      }

	    /* free event */
	    eventFree(ev);
	    
	    /* look for futher events of type 'headline' in queue */
	    while((ev = eventFindNextByTypeAndMessageType(ri,type,messageTypeHeadline)) != NULL)
	      {
		msg = (message) eventGetData(ev);
		id = eventGetID(ev);

		if(msg == NULL)
		  {
		    g_warning("gj_gtk_roster_handle_next_event: msg data was NULL, not handling...");

		    /* free event - no use to me now */
		    eventFree(ev);
		    continue;
		  }
		
		g_message("gj_gtk_roster_handle_next_event: handling next event of type:%d, id:%d",type,id);
		gj_gtk_hw_notification_new(id, msg);
	
		/* free event */
		eventFree(ev);
	      }	    
	  }
	else if(messageGetType(msg) == messageTypeError)
	  {
	    gchar *error1 = NULL;
	    gchar *error2 = NULL;
	    error1 = g_strdup_printf("Original Message:\n<i>%s</i>",
				     messageGetBody(msg)?messageGetBody(msg):"Not Available");

	    if(messageGetErrorCode(msg) != NULL && messageGetErrorReason(msg) != NULL)
	      error2 = g_strdup_printf("Error <u>%s</u> - %s.",
				       messageGetErrorCode(msg)?messageGetErrorCode(msg):"unknown code",
				       messageGetErrorReason(msg)?messageGetErrorReason(msg): "unknown reason");

	    gj_gtk_msg_new(error1, 
			   "Error",
			   error2?error2:"", 
			   TRUE,
			   GJ_GTK_MSG_BUTTON_CLOSE | GJ_GTK_MSG_ICON_EXCLAIMATION,
			   (MsgCb)NULL,
			   NULL);

	    if(error1 != NULL) g_free(error1);
	    if(error2 != NULL) g_free(error2);

	    /* free event */
	    eventFree(ev);
	  }
	else
	  {
	    g_message("gj_gtk_roster_handle_next_event: unknown message type:%d",messageGetType(msg));

	    /* if we dont handle certain types of messages (e.g. headlines, groupchats...), free it. */
	    eventFree(ev);
	  }
      }
      break;

    case eventTypeFile:
      break;

    default:
      g_warning("gj_gtk_roster_handle_next_event: unknown event type:%d, freeing...",type);
      
      /* if we dont know about it, free it. */
      eventFree(ev);

      break;
    }

  eventPrintAll(ri);
  
  return TRUE;
}

gboolean gj_gtk_roster_handle_next_event_display(gchar *jid)
{
  event ev = NULL;
  eventType type = -1;

  rosterItem ri = NULL;
  presence pres = NULL;
  
  gint id = 0;
  gint count = 0;
  
  if((ri = rosterItemFindByJID(jid)) == NULL)
    {
      g_warning("gj_gtk_roster_handle_next_event_display: failed to get roster item by jid:'%s'",jid);
      return FALSE;
    }

  if((pres = rosterItemGetPresence(ri)) == NULL)
    {
      g_warning("gj_gtk_roster_handle_next_event_display: could not get presence from roster item with JID:'%s'",jid); 
      return FALSE;
    }

  if((count = eventCount(ri)) < 1)
    {
      g_message("gj_gtk_roster_handle_next_event_display: changing presence, %d events remaining",count);

      /* stop flashing */
      gj_gtk_roster_timeout_stop(ri);

      /* no events pending, set icon to status */
      gj_gtk_roster_set_presence(ri, presenceGetType(pres), presenceGetShow(pres), presenceGetStatus(pres));     
    }
  else
    {
      /* events pending, so get the next in the list and show its icon */
      if((id = eventIDNext(ri)) == -1)
	{
	  g_warning("gj_gtk_roster_handle_next_event_display: failed to get next event, perhaps there are none?!");
	  return FALSE;
	}

      if((ev = eventFindByEventID(id)) == NULL)
	{
	  g_warning("gj_gtk_roster_handle_next_event_display: failed to find roster item event from id:%d",id);
	  return FALSE;
	}

      type = eventGetType(ev);
      
      switch(type)
	{
	case eventTypePresence:
	  /* !!!! SHOULDNT BE HERE */
	  return TRUE;

	case eventTypeMessage:
	  {
	    message msg = (message) eventGetData(ev);
	    gj_gtk_roster_set_message(ri, messageGetType(msg));

	    /* start flashing */
	    gj_gtk_roster_timeout_start(ri);

	  }
	default:
	  break;
	}
    }

  return TRUE;
}

gboolean gj_gtk_roster_timeout_start(rosterItem ri)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter *iter_copy = NULL;
  
  guint id = 0;

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_timeout_start: rosterItem was NULL");
      return FALSE;
    }

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_start: view was NULL");
      return FALSE;
    } 

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_start: model was NULL");
      return FALSE;
    } 

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_start: store was NULL");
      return FALSE;
    } 

  /* NOTE: at this point i thought about having two different
           timers for each jid in all the groups they were a part of
	   and decided not to.  it is easier and less mess to clean
	   up if i just make the items flash on the one callback
  */
  if((iter_copy = gj_gtk_roster_model_find_iter_by_jid(rosterItemGetJID(ri), NULL)) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_start: could not find jid:'%s' in model", rosterItemGetJID(ri));
      return FALSE;      
    }

  /* get from model */
  gtk_tree_model_get(model, iter_copy,
		     COL_ROSTER_TIMER, &id,
		     -1);

  if(id <= 0)
    {
      gint ri_id = 0;
      gpointer user_data = NULL;

      ri_id = rosterItemGetID(ri);
      user_data = GINT_TO_POINTER(ri_id);

      id = gtk_timeout_add(750, /* 1/1000ths of a sec */
			   gj_gtk_roster_timeout_function,
			   user_data);
      g_message("gj_gtk_roster_timeout_start: adding timeout with id:%d",id);

      /* set the store */
      gtk_tree_store_set(store, iter_copy,
			 COL_ROSTER_TIMER, id,
			 -1);
    }

  /* clean up */
  gtk_tree_iter_free(iter_copy);

  return TRUE;
}

gboolean gj_gtk_roster_timeout_stop(rosterItem ri)
{ 
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter *iter_copy = NULL;
  
  guint id = 0;

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_timeout_stop: rosterItem was NULL");
      return FALSE;
    }

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_stop: view was NULL");
      return FALSE;
    } 

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_stop: model was NULL");
      return FALSE;
    } 

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_stop: store was NULL");
      return FALSE;
    } 

  if((iter_copy = gj_gtk_roster_model_find_iter_by_jid(rosterItemGetJID(ri), NULL)) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_stop: could not find jid:'%s' in model", rosterItemGetJID(ri));
      return FALSE;      
    }

  /* get from model */
  gtk_tree_model_get(model, iter_copy,
		     COL_ROSTER_TIMER, &id,
		     -1);

  if(id > 0)
    {
      g_message("gj_gtk_roster_timeout_stop: removing timeout with id:%d", id);
      gtk_timeout_remove(id);

      gtk_tree_store_set(store, iter_copy,
			 COL_ROSTER_TIMER, 0,
			 -1);
    }

  /* clean up */
  gtk_tree_iter_free(iter_copy);

  return TRUE;
}

gboolean gj_gtk_roster_timeout_function(gpointer data)
{
  GtkTreeView *view = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeStore *store = NULL;

  GtkTreeIter iter;
 
  GdkPixbuf *pixbuf;
  GdkPixbuf *pixbuf_old;
  gboolean valid = FALSE;
  gint ri_id = 0;

  rosterItem ri = NULL;

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_function: view was NULL");
      return FALSE;
    } 

  if((model = GTK_TREE_MODEL(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_function: model was NULL");
      return FALSE;
    } 

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_function: store was NULL");
      return FALSE;
    } 

  if(data == NULL)
    {
      g_warning("gj_gtk_roster_timeout_function: data was NULL, can not proceed, canceling timeout.");
      return FALSE;   
    }

  ri_id = GPOINTER_TO_INT(data);

  if((ri = rosterItemFindByID(ri_id)) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_function: could not find rosterItem by id:%d", ri_id);
      return FALSE;
    }

  /* get the first iter in the list */
  valid = gtk_tree_model_get_iter_first(model, &iter);

  for(;valid == TRUE; valid = gtk_tree_model_iter_next(model, &iter))
    {
      /* check for children */
      if(gtk_tree_model_iter_has_child(model,&iter) == TRUE)
	{
	  GtkTreeIter iterchild;
	  gint children = 0;
	  gint index = 0;

	  children = gtk_tree_model_iter_n_children(model,&iter);

	  for(index=0; index<children; index++)
	    {
	      if((valid = gtk_tree_model_iter_nth_child(model, &iterchild, &iter, index)) == TRUE)
		{
		  gchar *text = NULL;
		  
		  gtk_tree_model_get(model, &iterchild, 
				     COL_ROSTER_JID, &text,
				     -1);
		  
		  if(text != NULL)
		    {
		      if(strcmp(text, rosterItemGetJID(ri)) == 0)
			{
			    gtk_tree_model_get(model, &iterchild,
					       COL_ROSTER_IMAGE, &pixbuf,
					       COL_ROSTER_IMAGE_OLD, &pixbuf_old,
					       -1);
			    
			    gtk_tree_store_set(store, &iterchild,
					       COL_ROSTER_IMAGE, pixbuf_old,
					       COL_ROSTER_IMAGE_OLD, pixbuf,
					       -1);
			}

		      g_free(text);
		      text = NULL;
		    }
		}
	    }
	}
      else
	{
	  gchar *text = NULL;
	  
	  gtk_tree_model_get(model, &iter, 
			     COL_ROSTER_JID, &text,
			     -1);
	  
	  if(text != NULL)
	    {
	      if(strcmp(text, rosterItemGetJID(ri)) == 0)
		{
		    gtk_tree_model_get(model, &iter,
				       COL_ROSTER_IMAGE, &pixbuf,
				       COL_ROSTER_IMAGE_OLD, &pixbuf_old,
				       -1);

		    gtk_tree_store_set(store, &iter,
				       COL_ROSTER_IMAGE, pixbuf_old,
				       COL_ROSTER_IMAGE_OLD, pixbuf,
				       -1);
		}

	      g_free(text);
	      text = NULL;
	    }
	}  
    }

#if 0

  if((iter_copy = gj_gtk_roster_model_find_iter_by_jid((gchar*)data, NULL)) == NULL)
    {
      g_warning("gj_gtk_roster_timeout_function: could not find jid:'%s' in model",(gchar*)data);
      return FALSE;      
    }

  while(iter_copy != NULL)
    {
      /* get from model */
      gtk_tree_model_get(model, iter_copy,
			 COL_ROSTER_IMAGE, &pixbuf,
			 COL_ROSTER_IMAGE_OLD, &pixbuf_old,
			 -1);
      
      /* show original image */
      gtk_tree_store_set(store, iter_copy,
			 COL_ROSTER_IMAGE, pixbuf_old,
			 COL_ROSTER_IMAGE_OLD, pixbuf,
			 -1);


      /* NOTE: at this point, we need to continue searching
	 the roster for other copies of the same JID for different
	 groups.  
      */
      
      iter_old = iter_copy;

      if(gtk_tree_model_iter_has_child(model, iter_copy) == FALSE && 
	 gtk_tree_store_iter_depth(store, iter_copy) > 0)
	{
	  /* set iter to top level... iter is currently in the group level OR on its own! */
	  path = gtk_tree_model_get_path(model, iter_copy);
	  if(gtk_tree_path_up(path) == TRUE)  
	    {
	      if(gtk_tree_model_get_iter(model, iter_copy, path) == FALSE)
		g_warning("gj_gtk_roster_timeout_function: could not get iter from path for jid:'%s'", (gchar*)data);
	    }
	  else
	    g_warning("gj_gtk_roster_timeout_function: could not go up the path for jid:'%s'", (gchar*) data);
	}

      /* find next */
      iter_copy = gj_gtk_roster_model_find_iter_by_jid((gchar*)data, iter_copy);
      
      /* clean up */
      gtk_tree_iter_free(iter_old);
    }

#endif

  /* return FALSE to stop timeout */
  return TRUE;
}


gboolean gj_gtk_roster_user_set_presence_and_save(presenceType type, presenceShow show, gchar *status, gint priority)
{
  if(gj_gtk_roster_user_set_presence(type,show,status,priority) == FALSE)
    {
      g_warning("gj_gtk_roster_user_set_presence_and_save: not saving config, setting presence failed");
      return FALSE;
    }

  /* remember details */
  gj_me_set_presence_type(type);
  gj_me_set_presence_show(show);
  gj_me_set_presence_status(status);  
  gj_me_set_presence_priority(priority);  
  
  return TRUE;
}

/*
 * CALLBACK functions
 */
void gj_gtk_roster_event_proc(gint eventID)
{
  rosterItem ri = NULL;
  event ev = NULL;
  eventType type = 0;

  if((ev = eventFindByEventID(eventID)) == NULL)
    {
      g_warning("gj_gtk_roster_event_proc: failed to find event by ID:%d",eventID);
      return;
    }
  
  /* event type */
  type = eventGetType(ev);
  g_message("gj_gtk_roster_event_proc: received new event, eventID:%d, type:%d->'%s'",
	    eventID, type, translateEventType(type));

  /* find roster item */
  if((ri = eventGetRosterItem(ev)) == NULL)
    {
      /* create contact */
      g_message("gj_gtk_roster_event_proc: couldn't find JID:'%s', adding temporary contact for event:%d...", eventGetJID(ev), eventID);

      /* adding temporary (to this session) user and group */
      if((ri = rosterItemNewUnknownByJID(eventGetJID(ev))) == NULL)
	{
	  g_warning("gj_gtk_roster_event_proc: couldn't add temporary roster item");
	  return;
	}

      /* set new roster item */
      eventSetRosterItem(ev, ri);

      /* NOTE: THE ONLY two times so far that someone should not be visually
	       created on the roster is when the event is a presence event
	       and it is an error.  This can occur when the user deletes an
	       agent and then all the contacts associated with it.

	       * The error 407: registration required is received as a presence
	       event. 

	       * The other time is after removing an agent from the roster, a 
	       presence event is received to say that they are are unavailable. 
       */
      if(eventGetType(ev) == eventTypePresence && (presenceGetType(eventGetData(ev)) == presenceTypeError || presenceGetType(eventGetData(ev)) == presenceTypeUnAvailable))
	g_message("gj_gtk_roster_event_proc: not creating a visual contact because the event is an presence error or unavailability, event jid:'%s'", eventGetJID(ev));
      else
	/* add visual contact */
	gj_gtk_roster_model_add_contact(ri);

      /* NOTE: when should this user be removed? should we wait till
	       the event has been accessed by the user then close it? or
	       leave the contact on the roster until the application is restarted
	       or the user disconnects? */
    }

  /* notify event viewer */
  gj_gtk_ev_model_add_from_event(ev);

  /* handle event */
  switch(type)
    {
    case eventTypePresence:
      {
	gchar *text = NULL;

	presence pres = NULL;
	chatWindow cw = NULL;

	pres = (presence) eventGetData(ev);

	/* 
	   details stored for roster item, 
	   event no longer needed 
	*/

	/* set new presence */
	if(pres == NULL)
	  {
	    g_warning("gj_gtk_roster_event_proc: could not set roster item's presence information, it was NULL, eventID:%d, jid:'%s'", 
		      eventID, 
		      rosterItemGetJID(ri));

	    /* DO SOMETHING ?? */
	  }

#if 0
	/* for status bar */
	text = g_strdup_printf("%s%s%s ", 
			       rosterItemGetName(ri), 
			       rosterItemGetResource(ri)?"/":"",
			       rosterItemGetResource(ri)?rosterItemGetResource(ri):"");

	text = g_strconcat(text, translatePresenceType(presenceGetType(pres)), NULL);
	if(presenceGetType(pres) == presenceTypeAvailable)
	  text = g_strconcat(text," (", translatePresenceShow(presenceGetShow(pres)), ")", NULL);
	
	/* set status bar */
	gj_gtk_roster_set_status(text);

	/* clean up */
	if(text != NULL) g_free(text);
#endif

	if((cw = gj_gtk_cw_find_by_jid(rosterItemGetJID(ri))) != NULL)
	  {
	    /* what if there are MORE than one chat window available in the future? */
	    gj_gtk_cw_presence_update(cw, (presence) eventGetData(ev));
	  }

	/* exceptions are subscriptions */
	if(presenceGetType(pres) == presenceTypeSubscribe)
	  {
	    /* we may not add here... it is up to the user
	       therefore we show the dialog and let the dialog add the user... */
	    
	    gj_gtk_sr_load(pres);
	  }
	else if(presenceGetType(pres) == presenceTypeUnSubscribed)
	  {
	    gchar *message = NULL;
	    gchar *jid = NULL;

	    message = g_strdup_printf("You have been denied presence from jid: <u>%s</u>", presenceGetFromJID(pres));
	    jid = g_strdup(presenceGetFromJID(pres));

	    gj_gtk_msg_new(message, 
			   "Contact Unsubscribed", 
			   "Do you want to remove them from your roster?",
			   FALSE,
			   GJ_GTK_MSG_BUTTON_YES | GJ_GTK_MSG_BUTTON_NO | GJ_GTK_MSG_ICON_EXCLAIMATION,
			   (MsgCb)gj_gtk_roster_unsubscribed_contact_msgbox_cb,
			   jid);	    

	    /* clean up */
	    if(message != NULL)
	      g_free(message);
	  }
	else
	  rosterItemSetPresence(ri, pres);


	eventFree(ev);
      }
      break;
    case eventTypeMessage:
      {
	message msg = (message) eventGetData(ev);

	if(messageGetType(msg) == messageTypeNormal)
	  {
	    msgWindow mw = NULL;
 
	    if((mw = gj_gtk_mw_find_by_jid(messageGetFromJID(msg))) != NULL)
	      {
		/* post notification to message window */
		gj_gtk_mw_notification_new(eventID, msg);
	      }
	    else
	      g_message("gj_gtk_roster_event_proc: no message window open, nothing to post new message to (eventID:%d).",eventID);

	    /* should we play sound ? */
	    if(gj_gtk_mpf_get_sound_on_receive_message() == TRUE)
	      gj_gtk_support_sound_play(gj_gtk_mpf_get_sound_file_on_receive_message());
	  }
	else if(messageGetType(msg) == messageTypeChat)
	  {
	    chatWindow cw = NULL;
 
	    if((cw = gj_gtk_cw_find_by_jid(messageGetFromJID(msg))) != NULL)
	      {
		/* post notification to chat window */
		gj_gtk_cw_notification_new(msg);

		/* remove event as chat has been dealt with */
		eventFree(ev);
	      }
	    else
	      g_message("gj_gtk_roster_event_proc: no chat window open, nothing to post new message to (eventID:%d).",eventID);

	    if(gj_gtk_mpf_get_sound_on_receive_chat() == TRUE)
	      gj_gtk_support_sound_play(gj_gtk_mpf_get_sound_file_on_receive_chat());
	  }
	else if(messageGetType(msg) == messageTypeError)
	  {
	    /* should we play sound ? */
	    if(gj_gtk_mpf_get_sound_on_receive_error() == TRUE)
	      gj_gtk_support_sound_play(gj_gtk_mpf_get_sound_file_on_receive_error());
	  }
	else if(messageGetType(msg) == messageTypeXEvent)
	{
	    /* NOTE: what we want to do is find the window with 
	       the last message id the same as the message id 
	       that we have this event for */
	    
	    chatWindow cw = NULL;
  	    msgWindow mw = NULL; 
	    gboolean found_window = FALSE;

 	    if((mw = gj_gtk_mw_find_by_last_msg_sent_xevent_id(messageGetXEventMessageID(msg))) != NULL)
 		found_window = TRUE; 
	    if((cw = gj_gtk_cw_find_by_last_sent_xevent_id(messageGetXEventMessageID(msg))) != NULL)
		found_window = TRUE;
		
	    if(found_window == TRUE)
	    {
		/* post event to window */
		gj_gtk_cw_notification_of_xevent_new(cw, msg);
	    }
	    else
		g_warning("gj_gtk_roster_event_proc: could not find chat window, xevent not dealt with but removed");

	    /* remove event it has been dealt with */
	    eventFree(ev);
	}
      }
      break;

      case eventTypeFile:
	break;
	
      default:
	g_warning("gj_gtk_roster_event_proc: unknown event type:%d",type);
	break;
    }

  gj_gtk_roster_handle_next_event_display(rosterItemGetJID(ri));
}

void gj_gtk_roster_event_presence_from(presence pres)
{
  /* show debugging */
  g_message("++++++++++ received presence id:%3.3d ++++++++++", presenceGetRequestID(pres));
  g_message("++++");

  g_message("++++ to:'%s', resource:'%s'", presenceGetToJID(pres), presenceGetToResource(pres));
  g_message("++++ from:'%s', resource:'%s'", presenceGetFromJID(pres), presenceGetFromResource(pres));

  if(presenceGetType(pres) != -1)
    g_message("++++ type:'%d'->'%s'",presenceGetType(pres), translatePresenceType(presenceGetType(pres)));

  if(presenceGetShow(pres) != -1)
    g_message("++++ show:'%d'->'%s'",presenceGetShow(pres), translatePresenceShow(presenceGetShow(pres)));

  g_message("++++ priority:'%d'",presenceGetPriority(pres));  

  if(presenceGetStatus(pres) != NULL)
    g_message("++++ status:'%s'",presenceGetStatus(pres));

  if(presenceGetErrorCode(pres) != NULL)
    g_message("++++ error code:'%s'", presenceGetErrorCode(pres));
  if(presenceGetErrorReason(pres) != NULL)
    g_message("++++ error reason:'%s'", presenceGetErrorReason(pres));

  g_message("++++");
  g_message("++++++++++++++++++++++++++++++++++++++++++++++");

  /* create new event */
  if(eventNewByPostFromJID(presenceGetFromJID(pres), eventTypePresence, (void*)pres) == FALSE)
    {
      g_warning("gj_gtk_roster_event_presence_from: failed to create new event");
      return;
    } 
}

void gj_gtk_roster_event_message_from(message msg)
{
  if(msg == NULL)
    return;

  g_message("++++++++++ received message id:%3.3d ++++++++++",messageGetRequestID(msg));
  g_message("++++");

  g_message("++++ type:'%d'->'%s'",messageGetType(msg), translateMessageType(messageGetType(msg)));

  if(messageGetID(msg) != NULL) g_message("++++ id:'%s'",messageGetID(msg));
  if(messageGetToJID(msg) != NULL) g_message("++++ to:'%s'",messageGetToJID(msg));
  if(messageGetToResource(msg) != NULL) g_message("++++ resource:'%s'",messageGetToResource(msg));
  if(messageGetFromJID(msg) != NULL) g_message("++++ from:'%s'",messageGetFromJID(msg));
  if(messageGetFromResource(msg) != NULL) g_message("++++ resource:'%s'",messageGetFromResource(msg));
  if(messageGetSubject(msg) != NULL) g_message("++++ subject:'%s'",messageGetSubject(msg));
  if(messageGetThread(msg) != NULL) g_message("++++ thread:'%s'",messageGetThread(msg));
  if(messageGetBody(msg) != NULL) g_message("++++ body:'%s'",messageGetBody(msg));  

  if(messageGetXEventType(msg) != 0) 
  {
      gchar *translation = NULL;
      translation = translateMessageXEventType(messageGetXEventType(msg));
      g_message("++++ x:event type:'%d'->'%s'",messageGetXEventType(msg), translation);  
      if(translation != NULL) g_free(translation);
  }


  if(messageGetXEventMessageID(msg) != NULL) g_message("++++ x:event message id:'%s'",messageGetXEventMessageID(msg));  
  if(messageGetXOOBURL(msg) != NULL) g_message("++++ x:oob url:'%s'",messageGetXOOBURL(msg));  
  if(messageGetXOOBDescription(msg) != NULL) g_message("++++ x:oob description:'%s'",messageGetXOOBDescription(msg));  

  if(messageGetErrorCode(msg) != NULL)
    g_message("++++ error code:'%s'",messageGetErrorCode(msg));  
  if(messageGetErrorReason(msg) != NULL)
    g_message("++++ error reason:'%s'",messageGetErrorReason(msg));  
 
  g_message("++++");
  g_message("+++++++++++++++++++++++++++++++++++++++++++++");

  if(messageGetType(msg) != messageTypeXEvent)
  {
      /* if XEvents ask to be notified when the message has 
	 been displayed, this is the time to send that notification */
      if(messageGetXEventType(msg) & messageXEventTypeDelivered)
	  messageSendXEvent(messageXEventTypeDelivered, messageGetFromJID(msg), messageGetID(msg));
  }

  if(eventNewByPostFromJID(messageGetFromJID(msg), eventTypeMessage, (void*)msg) == FALSE)
    {
      g_warning("gj_gtk_roster_event_message_from: failed to create new event");
      return;
    } 
}

void gj_gtk_roster_user_changed_cb(guint id)
{
  infoquery iq = NULL;

  g_message("gj_gtk_roster_user_changed_cb: response with requestID:%d",id);

  if((iq = infoqueryFindByEventID(id)) == NULL)
    {
      g_warning("gj_gtk_roster_user_changed_cb: failed to find IQ based on responseID:%d",id);

      return;
    }

  /* clean up */
  infoqueryFreeEventAndRelatedByRelatedID(id);
}

void gj_gtk_roster_unsubscribed_contact_msgbox_cb(gint response, void *userdata)
{
  if(userdata == NULL)
    {
      g_warning("gj_gtk_roster_unsubscribed_contact_msgbox_cb: userdata (with JID) was NULL");
      return;
    }

  if(response == GJ_GTK_MSG_BUTTON_YES)
    {
      g_message("gj_gtk_roster_unsubscribed_contact_msgbox_cb: removing contact:'%s'", (gchar*)userdata);
      infoqueryRequestRosterRemoveContact((gchar*)userdata, gj_gtk_roster_remove_contact_completion_cb);
    }
  else
    g_message("gj_gtk_roster_unsubscribed_contact_msgbox_cb: not removing contact:'%s'", (gchar*)userdata);

  /* free jid */
  g_free(userdata);
}

void gj_gtk_roster_remove_contact_msgbox_cb(gint response, void *userdata)
{
  rosterItem ri = NULL;
  
  if(userdata == NULL)
    {
      g_warning("gj_gtk_roster_remove_contact_msgbox_cb: userdata (with JID) was NULL");
      return;
    }
  
  if((ri = rosterItemFindByID(GPOINTER_TO_INT(userdata))) == NULL)
    {
      g_warning("gj_gtk_roster_remove_contact_msgbox_cb: could not get roster item from userdata");
      return;
    }
  
  if(response == GJ_GTK_MSG_BUTTON_YES)
    {
      gchar *jid = NULL;

      /* NOTE: we make a copy of the roster item JID because the agent will be removed! */
      jid = g_strdup(rosterItemGetJIDWithoutResource(ri));

      g_message("gj_gtk_roster_remove_contact_msgbox_cb: removing contact:'%s'", rosterItemGetJID(ri));
      infoqueryRequestRosterRemoveContact(rosterItemGetJID(ri), gj_gtk_roster_remove_contact_completion_cb);

      if(rosterItemGetIsAgent(ri) == TRUE)
	{
	  gchar *message = NULL;
	  
	  message = g_strdup_printf("Do you want to remove all contacts associated with agent:'%s'?", rosterItemGetJID(ri));
	  gj_gtk_msg_new("Note: If the agent is removed, the contacts will be of no use on the roster!", 
			 "Remove Agent Contacts", 
			 message,
			 TRUE,
			 GJ_GTK_MSG_BUTTON_YES | GJ_GTK_MSG_BUTTON_NO | GJ_GTK_MSG_ICON_QUESTION,
			 (MsgCb)gj_gtk_roster_remove_agent_contacts_msgbox_cb,
		 	 jid);
      
	  if(message != NULL) g_free(message);
	}
      else
	if(jid != NULL) g_free(jid);
    }
  else
    g_message("gj_gtk_roster_remove_contact_msgbox_cb: not removing contact:'%s'", rosterItemGetJID(ri));
}

void gj_gtk_roster_remove_agent_contacts_msgbox_cb(gint response, void *userdata)
{
  rosterItem ri = NULL;
  
  if(userdata == NULL)
    {
      g_warning("gj_gtk_roster_remove_agent_contacts_msgbox_cb: userdata (with JID) was NULL");
      return;
    }
  
  if(response == GJ_GTK_MSG_BUTTON_YES)
    {
      GList *contacts = NULL;
      gint i = 0;
      
      contacts = rosterGetAllItemsByAgent((gchar*)userdata);
      
      for(i=0; i<g_list_length(contacts); i++)
	{
	  gchar *jid = NULL;
	  
	  jid = (gchar*) g_list_nth_data(contacts, i);
	  if(jid == NULL) continue;
	
	  g_message("gj_gtk_roster_remove_agent_contacts_msgbox_cb: removing contact:'%s'", jid);
	  infoqueryRequestRosterRemoveContact(jid, gj_gtk_roster_remove_contact_completion_cb);
	} 
    }
  else
    g_message("gj_gtk_roster_remove_agent_contacts_msgbox_cb: not removing all contacts associated with agent:'%s'", rosterItemGetJID(ri));

  g_free(userdata);
}


void gj_gtk_roster_remove_contact_completion_cb(guint id)
{
  infoquery iq = NULL;
  infoquery iq_related = NULL;

  xmlNodePtr node = NULL;

  xmlChar *type = NULL;
  guint eventIDRelated = 0;

  g_message("gj_gtk_roster_remove_contact_completion_cb: response with requestID:%d",id);

  if((iq = infoqueryFindByEventIDRelated(id)) == NULL)
    {
      g_warning("gj_gtk_roster_remove_contact_completion_cb: failed to find IQ based on eventIDRelated:%d",id);

      return;
    }

  eventIDRelated = infoqueryGetEventIDRelated(iq);

  if((iq_related = infoqueryFindByEventID(eventIDRelated)) == NULL)
    {
       gj_gtk_msg_new("Failed to register.", 
		      "Unregister Account", 
		      "Invalid response received.",
		      TRUE,
		      GJ_GTK_MSG_BUTTON_CLOSE | GJ_GTK_MSG_ICON_EXCLAIMATION,
		      (MsgCb)NULL,
		      NULL);
       
      g_warning("gj_gtk_roster_unregister_cb: failed to find IQ based on eventIDRelated:%d",eventIDRelated);

      return;
    }

  /* check for errors? */
  node = infoqueryGetXML(iq);
  type = parserFindByAttrAndReturn(node, (guchar*)"type");

  if(type != NULL && xmlStrcmp(type, (guchar*)"error") == 0)
    {
      gchar *detail = NULL;

      xmlChar *errorCode = NULL;
      xmlChar *errorMessage = NULL;

      if((node = parserFindByNode(node, (guchar*)"error")) == NULL)
	{
	  g_warning("gj_gtk_roster_remove_contact_completion_cb: failed to find node 'error'");

	  infoqueryFreeByEventID(id);
	  return;
	}

      if((errorCode = parserFindByAttrAndReturn(node, (guchar*)"code")) != NULL)
	{
	  detail = g_strdup_printf("Error:%s",errorCode);
	}

      if((errorMessage = parserFindByNodeAndReturn(node, (guchar*)"error")) != NULL) 
	{
	  if(detail != NULL)
	    detail = g_strdup_printf("%s - %s",detail,errorMessage);
	}

       gj_gtk_msg_new("Failed to remove contact, error occured.", 
		      "Roster Contact Remove", 
		      detail,
		      TRUE,
		      GJ_GTK_MSG_BUTTON_CLOSE | GJ_GTK_MSG_ICON_ERROR,
		      (MsgCb)NULL,
		      NULL);
       
       g_warning("gj_gtk_roster_remove_contact_completion_cb: IQ type is error, registration failed for requestID:%d",id);
        
       /* clean up */
       g_free(detail);
       infoqueryFreeEventAndRelatedByRelatedID(id);
         
       return;
    }

  /* NOTE: we do not remove from the roster here... 
     we are sent a message to do this */
  
#if 0
  gj_gtk_msg_new("Removed successfully.", 
		 "Roster Contact Remove", 
		 "No errors.",
		 FALSE,
		 GJ_GTK_MSG_BUTTON_CLOSE | GJ_GTK_MSG_ICON_INFORMATION,
		 (MsgCb)NULL,
		 NULL);
#endif

  /* clean up */
  infoqueryFreeEventAndRelatedByRelatedID(id);
}

void gj_gtk_roster_unregister_msgbox_cb(gint response, void *userdata)
{
  if(response == GJ_GTK_MSG_BUTTON_YES)
    {
      g_message("gj_gtk_roster_unregister_msgbox_cb: user clicked yes.");

      infoqueryRequestUnRegister(gj_gtk_cs_get_server(),
				 gj_gtk_roster_unregister_cb);    
    }
  else
    g_message("gj_gtk_roster_unregister_msgbox_cb: user clicked no, taking no action.");
}

void gj_gtk_roster_unregister_cb(guint id)
{
  infoquery iq = NULL;
  infoquery iq_related = NULL;

  guint eventIDRelated = 0;

  xmlChar *type = NULL;
  xmlNodePtr node = NULL;

  g_message("gj_gtk_roster_unregister_cb: response with id:%d",id);
  
  if((iq = infoqueryFindByEventID(id)) == NULL)
    {
       gj_gtk_msg_new("Failed to register.", 
		      "Unregister Account", 
		      "Invalid response received.",
		      TRUE,
		      GJ_GTK_MSG_BUTTON_CLOSE | GJ_GTK_MSG_ICON_EXCLAIMATION,
		      (MsgCb)NULL,
		      NULL);
       
       g_warning("gj_gtk_roster_unregister_cb: failed to find IQ based on id:%d",id);

      return;
    }

  eventIDRelated = infoqueryGetEventIDRelated(iq);

  if((iq_related = infoqueryFindByEventID(eventIDRelated)) == NULL)
    {
       gj_gtk_msg_new("Failed to register.", 
		      "Unregister Account", 
		      "Invalid response received.",
		      TRUE,
		      GJ_GTK_MSG_BUTTON_CLOSE | GJ_GTK_MSG_ICON_EXCLAIMATION,
		      (MsgCb)NULL,
		      NULL);
       
      g_warning("gj_gtk_roster_unregister_cb: failed to find IQ based on eventIDRelated:%d",eventIDRelated);

      return;
    }

  /* check for errors? */
  node = infoqueryGetXML(iq_related);
  type = parserFindByAttrAndReturn(node, (guchar*)"type");

  if(type != NULL && xmlStrcmp(type, (guchar*)"error") == 0)
    {
      gchar *detail = NULL;

      xmlChar *errorCode = NULL;
      xmlChar *errorMessage = NULL;

      if((node = parserFindByNode(node, (guchar*)"error")) == NULL)
	{
	  g_warning("gj_gtk_roster_unregister_cb: failed to find node 'error'");

	  infoqueryFreeByEventID(id);
	  return;
	}

      if((errorCode = parserFindByAttrAndReturn(node, (guchar*)"code")) != NULL)
	{
	  detail = g_strdup_printf("Error:%s",errorCode);
	}

      if((errorMessage = parserFindByNodeAndReturn(node, (guchar*)"error")) != NULL) 
	{
	  if(detail != NULL)
	    detail = g_strdup_printf("%s - %s",detail,errorMessage);
	}

       gj_gtk_msg_new("Failed to register, error occured.", 
		      "Unregister Account", 
		      detail,
		      TRUE,
		      GJ_GTK_MSG_BUTTON_CLOSE | GJ_GTK_MSG_ICON_ERROR,
		      (MsgCb)NULL,
		      NULL);
       
       g_warning("gj_gtk_roster_unregister_cb: IQ type is error, registration failed for id:%d",id);
        
       /* clean up */
       g_free(detail);
       infoqueryFreeEventAndRelatedByRelatedID(id);
       
       return;
    }

  gj_gtk_msg_new("Account unregistered successfully.", 
		 "Unregister Account", 
		 "No errors.",
		 FALSE,
		 GJ_GTK_MSG_BUTTON_CLOSE | GJ_GTK_MSG_ICON_INFORMATION,
		 (MsgCb)NULL,
		 NULL);

  /* clean up */
  infoqueryFreeEventAndRelatedByRelatedID(id);

  /* disconnect */
  gj_gtk_roster_model_unload();
  infoqueryRequestGoodbye(gj_gtk_cs_get_server());
}

/*
 * GUI events
 */
void on_treeview_roster_selection_changed(GtkTreeSelection *treeselection, gpointer user_data)
{
  GtkTreeModel *model = NULL;
  GtkTreeIter iter;

  gchar *jid = NULL;
  gboolean is_agent = FALSE;

  if(gtk_tree_selection_get_selected(treeselection, &model, &iter) == FALSE)
    {
      g_message("on_treeview_roster_selection_changed: there is nothing selected");
      return;
    }

  gtk_tree_model_get(GTK_TREE_MODEL(model), &iter,
		     COL_ROSTER_IS_AGENT, &is_agent,
		     COL_ROSTER_JID, &jid,
		     -1);

#if 0
  /* THIS menu does not exist at the moment */
  if(is_agent == FALSE && jid != NULL)
    {
      /* set menu to be available */
      gtk_widget_set_sensitive(ctlRoster.mnu_roster_contact, TRUE);
    }
  else
    {
      /* set menu to be available */
      gtk_widget_set_sensitive(ctlRoster.mnu_roster_contact, FALSE);
    }
#endif

  if(jid != NULL)
    g_free(jid);
}

void on_treeview_roster_row_inserted(GtkTreeModel *treemodel, GtkTreePath *path, GtkTreeIter *iter, gpointer user_data)
{
  GtkTreeIter iter_new;
  GtkTreePath *path_new = NULL;

  gchar *group = NULL;
  gchar *title = NULL;
  guint count = 0;
  gchar *path_str = NULL;

  if(path == NULL)
    {
      g_warning("on_treeview_roster_row_inserted: path was NULL");
      return;
    }

  if(iter == NULL)
    {
      g_warning("on_treeview_roster_row_inserted: iter was NULL");
      return;
    }

  if(gtk_tree_model_iter_parent(GTK_TREE_MODEL(treemodel), &iter_new, iter) == FALSE)
    {
      g_message("on_treeview_roster_row_inserted: iter is at the toplevel already, doing nothing...");
      return;
    }
  
  if((path_new = gtk_tree_model_get_path(GTK_TREE_MODEL(treemodel), &iter_new)) == NULL)
    {
      g_warning("on_treeview_roster_row_inserted: could not get path from toplevel iterator");
      return;
    }

  path_str = gtk_tree_path_to_string(path_new);

  if(path_str != NULL)
    {
      g_message("on_treeview_roster_row_inserted: path is:'%s'", path_str);
      g_free(path_str);
      path_str = NULL;
    }

  count = gtk_tree_model_iter_n_children(GTK_TREE_MODEL(treemodel), &iter_new);
  g_message("on_treeview_roster_row_inserted: %d contacts in group",count);

  gtk_tree_model_get(GTK_TREE_MODEL(treemodel), &iter_new,
		     COL_ROSTER_GROUP, &group,
		     -1);

  if(group != NULL && strcmp(group, ROSTER_GROUP_OFFLINE) != 0)
    {
      /* expand */
      if(gtk_tree_view_row_expanded(GTK_TREE_VIEW(ctlRoster.treeview), path_new) == FALSE)
	gtk_tree_view_expand_row(GTK_TREE_VIEW(ctlRoster.treeview), path_new, TRUE);
    }

  title = g_strdup_printf("<b>%s</b> (%d)",group,count);

  gtk_tree_store_set(GTK_TREE_STORE(treemodel), &iter_new,
		     COL_ROSTER_JID, group,
		     COL_ROSTER_NAME, title,
		     -1);

  /* clean up */
  if(group != NULL) g_free(group);
  if(title != NULL) g_free(title);
       
  return;
}

void on_treeview_roster_row_deleted(GtkTreeModel *treemodel, GtkTreePath *path, gpointer user_data)
{
  GtkTreeView *view = NULL;
  GtkTreeStore *store = NULL;
  GtkTreeIter iter_parent; 
  
  gchar *group = NULL; 
  gchar *title = NULL; 
  gchar *path_str = NULL;
  gchar **v_path_str = NULL;
  guint count = 0; 
  gboolean can_delete = FALSE;

  if((view = GTK_TREE_VIEW(ctlRoster.treeview)) == NULL)
    {
      g_warning("on_treeview_roster_row_deleted: view was NULL");
      return;
    } 

  if((store = GTK_TREE_STORE(gtk_tree_view_get_model(view))) == NULL)
    {
      g_warning("on_treeview_roster_row_deleted: store was NULL");
      return;
    } 

  if(path == NULL)
    {
      g_warning("on_treeview_roster_row_deleted: path was NULL");
      return;
    }

  path_str = gtk_tree_path_to_string(path);
  if(path_str != NULL)
    {
      g_message("on_treeview_roster_row_deleted: path is:'%s'", path_str);

      /* hack for the get parent function which doesnt work correctly. */
      if((v_path_str = g_strsplit(path_str, ":", -1)) == NULL)
	g_warning("on_treeview_roster_row_deleted: could not split path str:'%s'", path_str);

      /* clean up */
      g_free(path_str);
      path_str = NULL;

      if(v_path_str == NULL)
	return;

      if(v_path_str[1] != NULL)
	can_delete = TRUE;

      /* clean up */
      g_strfreev(v_path_str);
    }

  /* get parent */
  if(gtk_tree_path_up(path) == FALSE || can_delete == FALSE)
    {
      g_message("on_treeview_roster_row_deleted: no parent associated with row deleted.");
      return;
    }

  if(gtk_tree_model_get_iter(GTK_TREE_MODEL(treemodel), &iter_parent, path) == FALSE)
    {
      g_warning("on_treeview_roster_row_deleted: could not get iter for parent associated with row deleted.");
      return;
    }

  /* get count */
  count = gtk_tree_model_iter_n_children(GTK_TREE_MODEL(treemodel), &iter_parent);
  g_message("on_treeview_roster_row_deleted: %d contacts in this group",count);

  if(count < 1)
    {
      g_message("on_treeview_roster_row_deleted: removing group, it is empty");
    }
  else
    {
      gtk_tree_model_get(treemodel, &iter_parent,
			 COL_ROSTER_GROUP, &group,
			 -1);
      
      title = g_strdup_printf("<b>%s</b> (%d)",group,count);
      
      gtk_tree_store_set(store, &iter_parent,
			 COL_ROSTER_NAME, title,
			 -1);

      if(group != NULL) g_free(group);  
      if(title != NULL) g_free(title); 
    }
}

gboolean on_treeview_roster_button_press_event(GtkWidget *widget, GdkEventButton *gdk_event, gpointer user_data)
{
  if(gdk_event->type == GDK_2BUTTON_PRESS && gdk_event->button == 1)
    {
      gchar *name = NULL;
      gchar *jid = NULL;

      if(gj_gtk_roster_model_get_selection(&name,&jid) == FALSE)
	return FALSE;
      
      gj_gtk_roster_handle_next_event(jid);
      gj_gtk_roster_handle_next_event_display(jid);

      if(name != NULL) g_free(name);
      if(jid != NULL) g_free(jid);
    }

  return FALSE;
}

gboolean gj_gtk_roster_generate_mnu_user(rosterItem ri, GdkEventButton *gdk_event)
{
  GtkWidget *menu = NULL;
  GtkWidget *submenu = NULL;
  GtkWidget *item = NULL;
  GtkWidget *image = NULL;

  event ev = NULL;

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_generate_mnu_user: rosterItem was NULL");
      return FALSE;
    }

  if(gdk_event == NULL)
    {
      g_warning("gj_gtk_roster_generate_mnu_user: gdk event was NULL");
      return FALSE;
    }

  ev = eventFindNextByType(ri, eventTypeMessage);

  /*   user_mnu_read = 1, */
  /*   user_mnu_new_message, */
  /*   user_mnu_new_chat, */
  /*   user_mnu_send_file, */
  /*   user_mnu_send_contacts, */
  /*   user_mnu_view_headlines, */
  /*   user_mnu_history, */
  /*   user_mnu_information, */
  /*   user_mnu_subscription_request, */
  /*   user_mnu_subscription_cancel, */
  /*   user_mnu_edit_groups, */
  /*   user_mnu_rename, */
  /*   user_mnu_add, */
  /*   user_mnu_remove */

  menu = gtk_menu_new();
  
  item = gtk_menu_item_new_with_mnemonic("Read...");
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item); 
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
		      GINT_TO_POINTER(user_mnu_read));

  if(ev == NULL)
    gtk_widget_set_sensitive(GTK_WIDGET(item), FALSE);


  item = gtk_separator_menu_item_new();
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);

  item = gtk_image_menu_item_new_with_mnemonic("New _Message");
  image = gj_gtk_support_image_new_from_file(FILE_MESSAGE_NORMAL);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
		      GINT_TO_POINTER(user_mnu_new_message));

  item = gtk_image_menu_item_new_with_mnemonic("New _Chat"); 
  image = gj_gtk_support_image_new_from_file(FILE_MESSAGE_CHAT);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
		      GINT_TO_POINTER(user_mnu_new_chat));

  item = gtk_image_menu_item_new_with_mnemonic("Vie_w Headlines");
  image = gj_gtk_support_image_new_from_file(FILE_MESSAGE_HEADLINE);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
		      GINT_TO_POINTER(user_mnu_view_headlines));

  item = gtk_separator_menu_item_new();
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);

  item = gtk_image_menu_item_new_with_mnemonic("_History");
  image = gtk_image_new_from_stock(GTK_STOCK_JUSTIFY_FILL, GTK_ICON_SIZE_MENU);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
		      GINT_TO_POINTER(user_mnu_history));

  item = gtk_image_menu_item_new_from_stock(GTK_STOCK_DIALOG_INFO, NULL);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);  
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
		      GINT_TO_POINTER(user_mnu_information));

  if(rosterItemGetIsPermanent(ri) == TRUE)
    {
      item = gtk_menu_item_new_with_mnemonic("Edit _Groups...");
      gtk_menu_shell_append(GTK_MENU_SHELL(menu), item); 
      gtk_signal_connect (GTK_OBJECT (item), "activate", 
			  GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
			  GINT_TO_POINTER(user_mnu_edit_groups));

      item = gtk_menu_item_new_with_mnemonic("Rename...");
      gtk_menu_shell_append(GTK_MENU_SHELL(menu), item); 
      gtk_signal_connect (GTK_OBJECT (item), "activate", 
			  GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
			  GINT_TO_POINTER(user_mnu_rename));
    }

  item = gtk_separator_menu_item_new();
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);

  submenu = gtk_menu_new();
  
  item = gtk_menu_item_new_with_mnemonic("_Request");
  gtk_menu_shell_append(GTK_MENU_SHELL(submenu), item); 
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
		      GINT_TO_POINTER(user_mnu_subscription_request));

  item = gtk_menu_item_new_with_mnemonic("_Cancel");
  gtk_menu_shell_append(GTK_MENU_SHELL(submenu), item); 
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
		      GINT_TO_POINTER(user_mnu_subscription_cancel));

  item = gtk_menu_item_new_with_mnemonic("Subscription");
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item); 
  
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), submenu);

  item = gtk_separator_menu_item_new();
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);

  if(rosterItemGetIsPermanent(ri) == FALSE)
    {
      item = gtk_image_menu_item_new_from_stock(GTK_STOCK_ADD, NULL);
      gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
      gtk_signal_connect (GTK_OBJECT (item), "activate", 
			  GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
			  GINT_TO_POINTER(user_mnu_add));
    }

  item = gtk_image_menu_item_new_from_stock(GTK_STOCK_REMOVE, NULL);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_user_menu_cb), 
		      GINT_TO_POINTER(user_mnu_remove));

  /* show */
  gtk_widget_show_all(GTK_WIDGET(menu));
  gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, gdk_event->button, gdk_event->time);

  /* clean up */
  gtk_object_sink(GTK_OBJECT(menu));

  return TRUE;
}

gboolean gj_gtk_roster_generate_mnu_agent(rosterItem ri, GdkEventButton *gdk_event)
{
  GtkWidget *menu = NULL;
  GtkWidget *submenu = NULL;
  GtkWidget *item = NULL;
  GtkWidget *image = NULL;

  if(ri == NULL)
    {
      g_warning("gj_gtk_roster_generate_mnu_user: rosterItem was NULL");
      return FALSE;
    }

  if(gdk_event == NULL)
    {
      g_warning("gj_gtk_roster_generate_mnu_user: gdk event was NULL");
      return FALSE;
    }

  /*   agent_mnu_new_message = 1, */
  /*   agent_mnu_view_headlines, */
  /*   agent_mnu_information, */
  /*   agent_mnu_log_in, */
  /*   agent_mnu_log_out, */
  /*   agent_mnu_subscription_request, */
  /*   agent_mnu_subscription_cancel, */
  /*   agent_mnu_edit_groups, */
  /*   agent_mnu_rename, */
  /*   agent_mnu_remove */

  menu = gtk_menu_new();
      
  item = gtk_image_menu_item_new_with_mnemonic("New _Message");
  image = gj_gtk_support_image_new_from_file(FILE_MESSAGE_NORMAL);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_agent_menu_cb), 
		      GINT_TO_POINTER(agent_mnu_new_message));

  item = gtk_image_menu_item_new_with_mnemonic("View _Headlines");
  image = gj_gtk_support_image_new_from_file(FILE_MESSAGE_HEADLINE);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_agent_menu_cb), 
		      GINT_TO_POINTER(agent_mnu_view_headlines));

  item = gtk_separator_menu_item_new();
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  
  item = gtk_image_menu_item_new_from_stock(GTK_STOCK_DIALOG_INFO, NULL);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);  
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_agent_menu_cb), 
		      GINT_TO_POINTER(agent_mnu_information));

  item = gtk_menu_item_new_with_mnemonic("Edit _Groups...");
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item); 
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_agent_menu_cb), 
		      GINT_TO_POINTER(agent_mnu_edit_groups));

  item = gtk_menu_item_new_with_mnemonic("Rename...");
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item); 
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_agent_menu_cb), 
		      GINT_TO_POINTER(agent_mnu_rename));

  item = gtk_separator_menu_item_new();
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  
  item = gtk_image_menu_item_new_with_mnemonic("Log _In");
  image = gtk_image_new_from_stock(GTK_STOCK_YES, GTK_ICON_SIZE_MENU);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);  
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_agent_menu_cb), 
		      GINT_TO_POINTER(agent_mnu_log_in));


  item = gtk_image_menu_item_new_with_mnemonic("Log _Out");
  image = gtk_image_new_from_stock(GTK_STOCK_NO, GTK_ICON_SIZE_MENU);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);   
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_agent_menu_cb), 
		      GINT_TO_POINTER(agent_mnu_log_out));

  item = gtk_separator_menu_item_new();
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);

  submenu = gtk_menu_new();

  item = gtk_menu_item_new_with_mnemonic("_Request");
  gtk_menu_shell_append(GTK_MENU_SHELL(submenu), item); 
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_agent_menu_cb), 
		      GINT_TO_POINTER(agent_mnu_subscription_request));

  item = gtk_menu_item_new_with_mnemonic("_Cancel");
  gtk_menu_shell_append(GTK_MENU_SHELL(submenu), item); 
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_agent_menu_cb), 
		      GINT_TO_POINTER(agent_mnu_subscription_cancel));

  item = gtk_menu_item_new_with_mnemonic("Subscription");
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item); 
  
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), submenu);

  item = gtk_separator_menu_item_new();
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);

  item = gtk_image_menu_item_new_from_stock(GTK_STOCK_REMOVE, NULL);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_agent_menu_cb), 
		      GINT_TO_POINTER(agent_mnu_remove));

  /* show */
  gtk_widget_show_all(GTK_WIDGET(menu));
  gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, gdk_event->button, gdk_event->time);

  /* clean up */
  gtk_object_sink(GTK_OBJECT(menu));

  return TRUE;
}

gboolean gj_gtk_roster_generate_mnu_group(rosterItem ri, GdkEventButton *gdk_event)
{
  GtkWidget *menu = NULL;
  GtkWidget *item = NULL;
  GtkWidget *image = NULL;

  gchar *name = NULL;
  gchar *jid = NULL;

/*   if(ri == NULL) */
/*     { */
/*       g_warning("gj_gtk_roster_generate_mnu_group: rosterItem was NULL"); */
/*       return FALSE; */
/*     } */

  if(gdk_event == NULL)
    {
      g_warning("gj_gtk_roster_generate_mnu_group: gdk event was NULL");
      return FALSE;
    }

  gj_gtk_roster_model_get_selection(&name,&jid);
  if(name == NULL || strlen(name) < 1 || jid == NULL || strlen(jid) < 1)
    return FALSE;
    
  /*   group_mnu_send_message_to_all = 1, */
  /*   group_mnu_rename, */
  /*   group_mnu_remove */

  menu = gtk_menu_new();
      
  item = gtk_image_menu_item_new_with_mnemonic("Send _Message to All");
  image = gj_gtk_support_image_new_from_file(FILE_MESSAGE_NORMAL);
  gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_group_menu_cb), 
		      GINT_TO_POINTER(group_mnu_send_message_to_all));
  if(strcmp(jid, ROSTER_GROUP_OFFLINE) == 0 ||
     strcmp(jid, ROSTER_GROUP_NOT_ON_ROSTER) == 0)
    {
      /* only if not a key group (like "offline", or "not on roster") */
      gtk_widget_set_sensitive(GTK_WIDGET(item), FALSE);
    }

  item = gtk_separator_menu_item_new();
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  
  item = gtk_menu_item_new_with_mnemonic("Rename");
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item); 
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_group_menu_cb), 
		      GINT_TO_POINTER(group_mnu_rename));

  if(strcmp(jid, ROSTER_GROUP_OFFLINE) == 0 ||
     strcmp(jid, ROSTER_GROUP_NOT_ON_ROSTER) == 0)
    {
      /* only if not a key group (like "offline", or "not on roster") */
      gtk_widget_set_sensitive(GTK_WIDGET(item), FALSE);
    }


  item = gtk_image_menu_item_new_from_stock(GTK_STOCK_REMOVE, NULL);
  gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
  gtk_signal_connect (GTK_OBJECT (item), "activate", 
		      GTK_SIGNAL_FUNC(gj_gtk_roster_group_menu_cb), 
		      GINT_TO_POINTER(group_mnu_remove));
  gtk_widget_set_sensitive(GTK_WIDGET(item), FALSE);

  /* show */
  gtk_widget_show_all(GTK_WIDGET(menu));
  gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, gdk_event->button, gdk_event->time);

  /* clean up */
  gtk_object_sink(GTK_OBJECT(menu));

  return TRUE;
}

gboolean on_treeview_roster_button_release_event(GtkWidget *widget, GdkEventButton *gdk_event, gpointer user_data)
{
  if(gdk_event->type == GDK_BUTTON_RELEASE && gdk_event->button == 3)
    {
      /* 
       * RIGHT SINGLE CLICK 
       */

      gchar *jid = NULL;
      gchar *name = NULL;
      gboolean is_group = FALSE;

      rosterItem ri = NULL;

      if(gj_gtk_roster_model_get_selection(&name,&jid) == FALSE)
	{
	  g_message("on_treeview_roster_button_release_event: no selection to show menu");
	  return FALSE;
	}
      
      if((ri = rosterItemFindByJID(jid)) == NULL)
	{
	  g_message("on_treeview_roster_button_release_event: selected jid is NULL, this must be a group.");
	  is_group = TRUE;
	}

      if(name != NULL) g_free(name);
      if(jid != NULL) g_free(jid);

      if(is_group == FALSE)
	{
	  if(rosterItemGetIsAgent(ri) == FALSE)
	    gj_gtk_roster_generate_mnu_user(ri, gdk_event);
	  else
	    gj_gtk_roster_generate_mnu_agent(ri, gdk_event);
	}
      else
	gj_gtk_roster_generate_mnu_group(ri, gdk_event);
    }
  else if(gdk_event->type == GDK_2BUTTON_PRESS && gdk_event->button == 1)
    { 
      /* 
       * LEFT DOUBLE CLICK 
       */
      
      gchar *name = NULL;
      gchar *jid = NULL;
      
      if(gj_gtk_roster_model_get_selection(&name,&jid) == FALSE)
	{
	  g_message("on_treeview_roster_button_release_event: no selection to act on double click event");
	  return FALSE;
	}

      gj_gtk_roster_handle_next_event(jid);
      gj_gtk_roster_handle_next_event_display(jid);
      
      if(name != NULL) g_free(name);
      if(jid != NULL) g_free(jid);
    }
  
  return FALSE;
}

#if 0
void on_treeview_roster_cell_edited(GtkCellRendererText *cell, const gchar *path_string, const gchar *new_name, gpointer data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreePath *path = gtk_tree_path_new_from_string(path_string);
  GtkTreeIter iter;

  gint *column;

  column = g_object_get_data(G_OBJECT(cell), "column");
  gtk_tree_model_get_iter(model, &iter, path);

  switch(GPOINTER_TO_INT(column))
    {
    case COL_ROSTER_NAME:
      {
	gint i = 0;
	gchar *original_name = NULL;

	gchar *jid = NULL;
	gchar *group = NULL;

        gtk_tree_model_get(model, &iter, 
			   column, &original_name,
			   COL_ROSTER_JID, &jid,
			   COL_ROSTER_GROUP, &group,
			   -1);

	g_message("on_treeview_roster_cell_edited: replacing cell at path:'%s' content:'%s' with :'%s' for jid:'%s' in group:'%s'", 
		  path_string, 
		  original_name, 
		  new_name, 
		  jid,
		  group);

	i = gtk_tree_path_get_indices(path)[0];
	gtk_tree_store_set(GTK_TREE_STORE(model), &iter, column, new_name, -1);

	/* save to jabber server */
	infoqueryRequestUserChange(jid, (gchar *)new_name, group, gj_gtk_roster_user_changed_cb);

	/* clean up */
	if(original_name != NULL) g_free(original_name);
	if(jid != NULL) g_free(jid);
	if(group != NULL) g_free(group);
      }
      break;
    }

  gtk_tree_path_free(path);
}

void on_mnu_user_edit_groups_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  GtkTreeModel *model;
  GtkTreePath *path = NULL;
  GtkTreeIter iter;
  GtkTreeViewColumn *column = NULL;
  GtkTreeSelection *selection = NULL;

  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(ctlRoster.treeview));
  if(gtk_tree_selection_get_selected(selection,&model,&iter) == FALSE)
    {
      /* return because there is NOTHING currently selected */
      g_message("on_mnu_user_rename_activate: no selection...");
      return;
    }
  
  path = gtk_tree_model_get_path(model,&iter);
  column = gtk_tree_view_get_column(GTK_TREE_VIEW(ctlRoster.treeview), 1);
  gtk_tree_view_set_cursor(GTK_TREE_VIEW(ctlRoster.treeview), path, column, TRUE);
}


#endif

void on_button_iqs_clicked(GtkButton *button, gpointer user_data)
{
/*  gj_gtk_gd_load();*/

/*   g_mem_profile(); */

/*    gtk_tree_view_collapse_all(GTK_TREE_VIEW(ctlRoster.treeview));  */
/*    gtk_tree_view_expand_all(GTK_TREE_VIEW(ctlRoster.treeview));  */
  
/*  infoqueryPrintAll();*/
}

void on_mnu_jabber_connect_activate(GtkMenuItem *menuitem, gpointer user_data)
{
    gj_gtk_cp_load(gj_gtk_roster_cb_connected, gj_gtk_roster_cb_disconnected);
}

void on_mnu_jabber_disconnect_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_roster_model_unload();
  infoqueryRequestGoodbye(gj_gtk_cs_get_server());
}

void on_mnu_jabber_register_new_account_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_rn_load();
}

void on_mnu_jabber_unregister_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_msg_new("Are you sure you wish to unregister this account?.", 
		 "Unregister Account", 
		 "If you select 'Yes' you will be disconnected from the server immediately if successfull.",
		 TRUE,
		 GJ_GTK_MSG_BUTTON_YES | GJ_GTK_MSG_BUTTON_NO | GJ_GTK_MSG_ICON_EXCLAIMATION,
		 (MsgCb)gj_gtk_roster_unregister_msgbox_cb,
		 NULL);
}

void on_mnu_jabber_change_password_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_pc_load();
}

void on_mnu_jabber_preferences_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_mpf_load();
}

void on_mnu_jabber_connection_settings_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_cs_load();
}

void on_mnu_jabber_my_information_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_mi_load();
}

void on_mnu_jabber_quit_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gnome_jabber_quit();
}

void on_mnu_roster_add_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_ac_load(NULL);
}

void on_mnu_roster_send_message_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_sm_load();
}

void on_mnu_roster_export_activate(GtkMenuItem *menuitem, gpointer user_data)
{
}
void on_mnu_roster_import_activate(GtkMenuItem *menuitem, gpointer user_data)
{
}

void on_mnu_roster_event_viewer_activate(GtkMenuItem *menuitem, gpointer user_data)
{
    gj_gtk_ev_load();
}

void on_mnu_roster_browse_services_activate(GtkMenuItem *menuitem, gpointer user_data)
{
    gj_gtk_bs_load();
}

void on_mnu_help_homepage_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_support_open_url("http://gnome-jabber.sourceforge.net/");
}

void on_mnu_help_project_information_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_support_open_url(PACKAGE_BUGREPORT);
}

void on_mnu_help_log_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_log_load();
}

void on_mnu_help_debug_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_debug_load();
}

void on_mnu_help_about_activate(GtkMenuItem *menuitem, gpointer user_data)
{
  gj_gtk_about_load(PACKAGE_NAME,
		    "Instant Messenger for the Jabber Protocol",
		    0, /* major version */
		    1, /* minor version */
		    0, /* revision version / pre release */
		    BUILD_ID,
		    "Protected Under the GNU Public License.",
		    "Written By Martyn Russell\n\nhttp://sourceforge.net/projects/gnome-jabber/\nhttp://www.jabber.org",
		    "");
}

void gj_gtk_roster_user_menu_cb(GtkMenuItem *menuitem, gpointer user_data)
{
  gchar *name = NULL;
  gchar *jid = NULL;
  gint callback_action = -1;

  if(user_data == NULL)
    {
      g_warning("gj_gtk_roster_user_menu_cb: user data was NULL");
      return;
    }

  /* get action */
  callback_action = GPOINTER_TO_INT(user_data);

  g_message ("gj_gtk_roster_user_menu_cb: agent menu activated menuitem:0x%.8x, callback action:%d", 
	     (gint)menuitem, callback_action);

  gj_gtk_roster_model_get_selection(&name,&jid);

  switch(callback_action)
    {
    case user_mnu_read:
      gj_gtk_roster_contact_read();
      break;

    case user_mnu_new_message:
      gj_gtk_roster_contact_new_message();
      break;

    case user_mnu_new_chat:
      gj_gtk_roster_contact_new_chat();
      break;

    case user_mnu_send_file:
    case user_mnu_send_contacts:
      break;

    case user_mnu_view_headlines:
       if(gj_gtk_hw_load_by_jid(jid) == FALSE)
	{
	  gj_gtk_msg_new("This user has had no headlines", 
			 "View Headlines", 
			 "Click Ok to continue.",
			 FALSE,
			 GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_EXCLAIMATION,
			 (MsgCb)NULL,
			 NULL);
	}
      break;

    case user_mnu_history:
      gj_gtk_roster_contact_history();
      break;

    case user_mnu_information:
      gj_gtk_roster_contact_information();
      break;

    case user_mnu_subscription_request:
      presenceSendTo(jid, presenceTypeSubscribe, presenceShowEnd, NULL, 0);
      break;

    case user_mnu_subscription_cancel:
      presenceSendTo(jid, presenceTypeUnSubscribed, presenceShowEnd, NULL, 0);
      break;

    case user_mnu_edit_groups:
      gj_gtk_roster_contact_edit_groups();
      break;

    case user_mnu_rename:
      gj_gtk_rc_load(jid, name);
      break;

    case user_mnu_add:
      gj_gtk_ac_load(jid);
      break;

    case user_mnu_remove:
      gj_gtk_roster_contact_remove();
      break;
    }

  /* clean up */
  if(name != NULL) g_free(name);
  if(jid != NULL) g_free(jid);  
}

void gj_gtk_roster_agent_menu_cb(GtkMenuItem *menuitem, gpointer user_data)
{
  gchar *name = NULL;
  gchar *jid = NULL;
  gint callback_action = -1;

  if(user_data == NULL)
    {
      g_warning("gj_gtk_roster_agent_menu_cb: user data was NULL");
      return;
    }

  /* get action */
  callback_action = GPOINTER_TO_INT(user_data);

  g_message ("gj_gtk_roster_agent_menu_cb: agent menu activated menuitem:0x%.8x, callback action:%d", 
	     (gint)menuitem, callback_action);

  gj_gtk_roster_model_get_selection(&name,&jid);

  switch(callback_action)
    {
    case agent_mnu_new_message:
      gj_gtk_roster_contact_new_message();
      break;

    case agent_mnu_view_headlines:
      if(gj_gtk_hw_load_by_jid(jid) == FALSE)
	{
	  gj_gtk_msg_new("This agent has had no headlines", 
			 "View Headlines", 
			 "Click Ok to continue.",
			 FALSE,
			 GJ_GTK_MSG_BUTTON_OK | GJ_GTK_MSG_ICON_EXCLAIMATION,
			 (MsgCb)NULL,
			 NULL);
	}
      break;

    case agent_mnu_information:
      gj_gtk_roster_contact_information();
      break;

    case agent_mnu_log_in:
      presenceSendTo(jid,presenceTypeAvailable,presenceShowNormal,NULL,0);
      break;

    case agent_mnu_log_out:
      presenceSendTo(jid,presenceTypeUnAvailable,presenceShowNormal,NULL,0);
      break;

    case agent_mnu_subscription_request:
    case agent_mnu_subscription_cancel:
      break;

    case agent_mnu_edit_groups:
      gj_gtk_roster_contact_edit_groups();
      break;

    case agent_mnu_rename:
      gj_gtk_rc_load(jid, name);
      break;

    case agent_mnu_remove:
      gj_gtk_roster_contact_remove();
      break;
    }

  /* clean up */
  if(name != NULL) g_free(name);
  if(jid != NULL) g_free(jid);  
}

void gj_gtk_roster_group_menu_cb(GtkMenuItem *menuitem, gpointer user_data)
{
  gchar *name = NULL;
  gchar *jid = NULL;
  gint callback_action = -1;

  if(user_data == NULL)
    {
      g_warning("gj_gtk_roster_group_menu_cb: user data was NULL");
      return;
    }

  /* get action */
  callback_action = GPOINTER_TO_INT(user_data);

  g_message ("gj_gtk_roster_group_menu_cb: agent menu activated menuitem:0x%.8x, callback action:%d", 
	     (gint)menuitem, callback_action);

  gj_gtk_roster_model_get_selection(&name,&jid);

  switch(callback_action)
    {
    case group_mnu_send_message_to_all:
      gj_gtk_gm_load(jid);
      break;
    case group_mnu_rename:
      gj_gtk_rg_load(jid);
      break;
    case group_mnu_remove:
      break;
    }

  /* clean up */
  if(name != NULL) g_free(name);
  if(jid != NULL) g_free(jid);  
}

void gj_gtk_roster_presence_menu_cb(GtkMenuItem *menuitem, gpointer user_data)
{
  gint callback_action = -1;

  if(user_data == NULL)
    {
      g_warning("gj_gtk_roster_presence_menu_cb: user data was NULL");
      return;
    }

  /* get action */
  callback_action = GPOINTER_TO_INT(user_data);

  g_message ("gj_gtk_roster_presence_menu_cb: agent menu activated menuitem:0x%.8x, callback action:%d", 
	     (gint)menuitem, callback_action);

  switch(callback_action)
    {
    case presence_mnu_available:
      gj_gtk_mp_load(presenceTypeAvailable, presenceShowNormal);
      break;
    case presence_mnu_chat:
      gj_gtk_mp_load(presenceTypeAvailable, presenceShowChat);
      break;
    case presence_mnu_away:
      gj_gtk_mp_load(presenceTypeAvailable, presenceShowAway);
      break;
    case presence_mnu_xa:
      gj_gtk_mp_load(presenceTypeAvailable, presenceShowXA);
      break;
    case presence_mnu_dnd:
      gj_gtk_mp_load(presenceTypeAvailable, presenceShowDND);
      break;
    case presence_mnu_unavailable:
      gj_gtk_mp_load(presenceTypeUnAvailable, presenceShowEnd);
      break;
    }
}


gboolean on_roster_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
  gnome_jabber_quit();

  return TRUE;
}

#ifdef __cplusplus
}
#endif

