/* 
 * $RCSfile: gj_gtk_roster.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/02 09:58:19 $
 * 
 * $Revision: 1.4 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_gtk_roster_h
#define __gj_gtk_roster_h

#include "gj_presence.h"
#include "gj_message.h"
#include "gj_roster.h"

gboolean gj_gtk_roster_load();
gboolean gj_gtk_roster_unload();

void gj_gtk_roster_cb_connected();
void gj_gtk_roster_cb_disconnected();

/*
 * roster functions 
 */
gboolean gj_gtk_roster_model_load(GList *roster);
gboolean gj_gtk_roster_model_unload();

gboolean gj_gtk_roster_show();
gboolean gj_gtk_roster_hide();

gboolean gj_gtk_roster_model_add_contact(rosterItem ri);
gboolean gj_gtk_roster_model_add_group(gchar *group);
gboolean gj_gtk_roster_model_remove_contact(rosterItem ri);

/* visual changes */
void gj_gtk_roster_set_status(gchar *message, ...);

/* gboolean gj_gtk_roster_set_presence_from_store(gchar *jid); */
gboolean gj_gtk_roster_set_presence(rosterItem ri, presenceType type, presenceShow show, gchar *status);
gboolean gj_gtk_roster_set_message(rosterItem ri, messageType type);

/* events */
gboolean gj_gtk_roster_handle_next_event_display(gchar *jid); 

/*
 * user functions
 */
gboolean gj_gtk_roster_user_set_presence_and_save(presenceType type, presenceShow show, gchar *status, gint priority);
gboolean gj_gtk_roster_user_set_presence(presenceType type, presenceShow show, gchar *status, gint priority);

/* auto away */
void gj_gtk_roster_autoaway_update(guint time);

#endif

#ifdef __cplusplus
}
#endif
