/* 
 * $RCSfile: gj_history.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/04/22 10:54:30 $
 * 
 * $Revision: 1.2 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_history_h
#define __gj_history_h

#include <glib.h>

typedef struct t_history *history;

gboolean historyInit();
gboolean historyTerm();

/* item */
history historyNew(gchar *jid);
gboolean historyFree(history hist);

/* find */
history historyFindByJID(gchar *jid);

/* member sets */
gboolean historySetFilename(history hist, gchar *filename);

/* member gets */
gchar *historyGetJID(history hist);
gchar *historyGetFilename(history hist);
GIOChannel *historyGetChannel(history hist);

/* utils */
void historyPrintAll();
void historyPrint(history hist);

/* functions used by chat windows */
gboolean historyStart(history hist);

gboolean historyWriteSentByJID(gchar *jid, gchar *date, gchar *subject, gchar *message);
gboolean historyWriteSent(history hist, gchar *date, gchar *subject, gchar *message);
gboolean historyWriteReceivedByJID(gchar *jid, gchar *date, gchar *subject, gchar *message);
gboolean historyWriteReceived(history hist, gchar *date, gchar *subject, gchar *message);

#endif

#ifdef __cplusplus
}
#endif
