/* 
 * $RCSfile: gj_iq.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/04/26 11:09:58 $
 * 
 * $Revision: 1.3 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_iq_h
#define __gj_iq_h

#include <glib.h>

#include <libxml/tree.h>

#include "gj_connection.h"

/* 
 * Information Query
 */
typedef enum infoqueryType {
    infoqueryTypeNull = 0,
    infoqueryTypeGet,
    infoqueryTypeSet,
    infoqueryTypeResult,
    infoqueryTypeError
} infoqueryType;

typedef struct t_infoquery *infoquery;

typedef void (*infoqueryCallback)(guint requestID);

gboolean infoqueryInit();
gboolean infoqueryTerm();

/* create / free */
infoquery infoqueryNew(infoqueryType type);
void infoqueryFree(infoquery iq);
void infoqueryFreeByEventID(guint eventID);
void infoqueryFreeEventAndRelatedByEventID(guint eventID);
void infoqueryFreeEventAndRelatedByRelatedID(guint eventIDRelated);

/* formation */
gboolean infoqueryBuild(infoquery iq, xmlNodePtr node);
gboolean infoqueryBuildFromList(infoquery iq, GList *nodes);
gboolean infoquerySend(infoquery iq);

/*
 * members 
 */

/* set */
gboolean infoquerySetUserData(infoquery iq, void *userdata);
gboolean infoquerySetID(infoquery iq, gchar *id);
gboolean infoquerySetTo(infoquery iq, gchar *to);
gboolean infoquerySetFrom(infoquery iq, gchar *from);
gboolean infoquerySetType(infoquery iq, infoqueryType type);
gboolean infoquerySetXML(infoquery iq, xmlNodePtr node);
gboolean infoquerySetCallback(infoquery iq, infoqueryCallback cb);
gboolean infoquerySetEventID(infoquery iq, guint eventID);
gboolean infoquerySetEventIDRelated(infoquery iq, guint eventID);
gboolean infoquerySetAssociatedJID(infoquery iq, gchar *jid);

/* get */
void *infoqueryGetUserData(infoquery iq);
gchar *infoqueryGetID(infoquery iq);
gchar *infoqueryGetTo(infoquery iq);
gchar *infoqueryGetFrom(infoquery iq);
infoqueryType infoqueryGetType(infoquery iq);
xmlNodePtr infoqueryGetXML(infoquery iq);
void *infoqueryGetCallback(infoquery iq);
guint infoqueryGetEventID(infoquery iq);
guint infoqueryGetEventIDRelated(infoquery iq);
gchar *infoqueryGetAssociatedJID(infoquery iq);

/* finding */
infoquery infoqueryFindByID(gchar *id);

infoquery infoqueryFindByEventID(guint id);
infoquery infoqueryFindByEventIDRelated(guint id);

/* print */
void infoqueryPrintAll();
void infoqueryPrint(infoquery iq);

/* other - used by parser */
void infoqueryReceive(connection c, xmlNodePtr node);


/*
 * Roster information
 */
typedef void (*infoqueryRosterResponseProc)(GList *roster);

void infoqueryRosterResponse(guint requestID);

#endif

#ifdef __cplusplus
}
#endif
