/* 
 * $RCSfile: gj_parser.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/04/26 11:09:58 $
 * 
 * $Revision: 1.3 $
 *
 */

#ifndef __gj_parser_h
#define __gj_parser_h

#include <libxml/tree.h>
#include <libxml/parser.h>

#include "gj_connection.h"

void parserInput(connection c, gchar *buf, gint nBytes);
void parserInputFromConnection(connection c, gchar *text);
gboolean parserOutput(xmlNodePtr node);
gboolean parserOutputFromText(gchar *text);

/* stats */
gint parserCountToplevelNodes(xmlDocPtr doc);
xmlNodePtr parserPrintTree(xmlNodePtr node, gint depth);

/* finding values (and returning) */
xmlChar *parserFindByAttrAndReturn(xmlNodePtr node, xmlChar *attrname);
xmlChar *parserFindByNodeAndReturn(xmlNodePtr node, xmlChar *text);
const xmlChar *parserFindByNsAndReturn(xmlNodePtr node);

const xmlChar *parserGetElement(xmlNodePtr node);
const xmlChar *parserGetContent(xmlNodePtr node);


/* find parts of the tree */
xmlNodePtr parserFindByNode(xmlNodePtr node, xmlChar *text);
xmlNodePtr parserFindByNodeOnSameParent(xmlNodePtr node, xmlChar *text);
xmlNodePtr parserFindByNodeContents(xmlNodePtr node, xmlChar *contents);
xmlAttrPtr parserFindByAttr(xmlAttrPtr prop, xmlChar *text);
xmlNodePtr parserFindByNs(xmlNodePtr node);
xmlNodePtr parserFindByNodeWithAttr(xmlNodePtr node, xmlChar *nodeName, xmlChar *attrName, xmlChar *attrVal);

GList *parserFindByNodeAndReturnByList(xmlNodePtr node, xmlChar *text);
GList *parserFindByNodeOnSameParentAndReturnByList(xmlNodePtr node, xmlChar *text);
GList *parserFindByNodeAndReturnContentsByList(xmlNodePtr node, xmlChar *text);
GList *parserFindByNodeOnSameParentAndReturnContentsByList(xmlNodePtr node, xmlChar *text);

/* conversions */
gchar * parserGetStrFromNode(xmlNodePtr node);        /* converts an xml tree into text */

gchar *parserCheckText(gchar *text);

#endif

