/* 
 * $RCSfile: gj_registration.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/06/28 13:38:30 $
 * 
 * $Revision: 1.3 $ 
 *
 */
#ifndef __gj_register_h
#define __gj_register_h

#include <glib.h> 

typedef struct t_registration *registration;

typedef void (*registrationCallback)(registration rgr, gint error_code, gchar *error_reason);
typedef void (*registrationRequestCallback)(registration rgr, gint error_code, gchar *error_reason);


/* list functions */
gboolean registrationInit();
gboolean registrationTerm();

/* list functions */
GList *registrationListGet();

/* item functions */
registration registrationNew();
void registrationFree(registration rgr);

/* find */
registration registrationFindByID(gchar *id);
registration registrationFindByTo(gchar *to);
registration registrationFindByFrom(gchar *from);

/* sets */
gboolean registrationSetID(registration rgr, gchar *id);
gboolean registrationSetTo(registration rgr, gchar *to);
gboolean registrationSetFrom(registration rgr, gchar *to);
gboolean registrationSetInstructions(registration rgr, gchar *instructions);
gboolean registrationSetUsername(registration rgr, gchar *username);
gboolean registrationSetPassword(registration rgr, gchar *password);
gboolean registrationSetEmail(registration rgr, gchar *email);
gboolean registrationSetRequireUsername(registration rgr, gboolean required);
gboolean registrationSetRequirePassword(registration rgr, gboolean required);
gboolean registrationSetRequireEmail(registration rgr, gboolean required);
gboolean registrationSetRequireNickname(registration rgr, gboolean required);
gboolean registrationSetKey(registration rgr, gchar *key);
gboolean registrationSetCallback(registration rgr, registrationCallback cb);

/* gets */
gchar *registrationGetID(registration rgr);
gchar *registrationGetTo(registration rgr);
gchar *registrationGetFrom(registration rgr);
gchar *registrationGetInstructions(registration rgr);
gchar *registrationGetUsername(registration rgr);
gchar *registrationGetPassword(registration rgr);
gchar *registrationGetEmail(registration rgr);
gboolean registrationGetRequireUsername(registration rgr);
gboolean registrationGetRequirePassword(registration rgr);
gboolean registrationGetRequireEmail(registration rgr);
gboolean registrationGetRequireNickname(registration rgr);
gchar *registrationGetKey(registration rgr);
registrationCallback registrationGetCallback(registration rgr);

/*
 * parsing functions  
 */
gboolean registrationRequestRequirements(gchar *server, registrationRequestCallback cb);
gboolean registrationRequest(gchar *server, registrationRequestCallback cb, 
			     gchar *key, gchar *username, gchar *password, gchar *email, gchar *nickname);
#endif

