/* 
 * $RCSfile: gj_stream.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/05/11 12:19:36 $
 * 
 * $Revision: 1.4 $
 *
 */

#ifndef __gj_stream_h
#define __gj_stream_h

#include <libxml/tree.h>

#include "gj_connection.h"

/* 
 * Streams
 */
typedef struct t_stream *stream;

typedef void (*streamCallback)(stream stm, gint error);


gboolean streamInit();
gboolean streamTerm();

stream streamNew();
gboolean streamFree(stream stm);

/* find */
stream streamFindByID(gchar *id);
stream streamFindByUniqueID(guint id);
stream streamFindByConnection(connection c);
stream streamFindByRequestID(gint requestID);
stream streamFindByTo(gchar *to);

/* set */
gboolean streamSetTo(stream stm, gchar *to);
gboolean streamSetPort(stream stm, guint port);

gboolean streamSetConnectedCallback(stream stm, streamCallback cb);
gboolean streamSetDisconnectedCallback(stream stm, streamCallback cb);
gboolean streamSetErrorCallback(stream stm, streamCallback cb);

/* get */
gchar *streamGetID(stream stm);
guint streamGetUniqueID(stream stm);
gint streamGetRequestID(stream stm);

gchar *streamGetTo(stream stm);
guint streamGetPort(stream stm);

gchar *streamGetStream(stream stm);
xmlDocPtr streamGetXML(stream stm);
void *streamGetCallback(stream stm);

connection streamGetConnection(stream stm);

/* building */
gboolean streamOpen(stream stm);  /* build then open the stream...! */
gboolean streamClose(stream stm);
gboolean streamCloseByTo(gchar *to);
gboolean streamSend(stream stm, gchar *text);
gboolean streamSendByTo(gchar *to, gchar *text);

gboolean streamBuild(stream stm);

/* input from parser */
void streamReceive(connection c, xmlNodePtr node);

#endif

