/* 
 * $RCSfile: gj_translate.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/02 00:06:31 $
 * 
 * $Revision: 1.3 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <stdlib.h>
#include <string.h>

#include <glib.h>

#include "gj_roster.h"
#include "gj_presence.h"
#include "gj_message.h"
#include "gj_translate.h"
#include "gj_event.h"

/*
 * NOTE: should we allocate memory for each function which returns a value?
 *       or should we simply return "my translation" instead?
 */

const gchar *translateRosterItemType(rosterItemType type)
{
  switch(type)
    {
    case rosterItemTypeNone: return "none";
    case rosterItemTypeContact: return "contact";
    case rosterItemTypeAgent: return "agent";
    case rosterItemTypeGroup: return "group";
    case rosterItemTypeEnd: return "ROSTER ITEM TYPE NOT SET";
    }

  return "unknown";
}

const gchar *translateRosterItemSubscription(rosterItemSubscription subscription)
{
  switch(subscription)
    {
    case rosterItemSubscriptionNone: return "none";
    case rosterItemSubscriptionTo: return "to";
    case rosterItemSubscriptionFrom: return "from";
    case rosterItemSubscriptionBoth: return "both";
    case rosterItemSubscriptionEnd: return "ROSTER ITEM SUBSCRIPTION NOT SET";
    }

  return "unknown";
}

const gchar *translateRosterItemSubscriptionAsDescription(rosterItemSubscription subscription)
{
  switch(subscription)
    {
    case rosterItemSubscriptionNone: return "Neither users have presence";
    case rosterItemSubscriptionTo: return "You can see the users presence.";
    case rosterItemSubscriptionFrom: return "The user can see your presence.";
    case rosterItemSubscriptionBoth: return "Presence is available to and from the user.";
    case rosterItemSubscriptionEnd: return "Subscription has not been set";
    }

  return "unknown";
}

const gchar *translateEventType(eventType type)
{
  switch(type)
    {
    case eventTypePresence: return "presence";
    case eventTypeMessage: return "message";
    case eventTypeFile: return "file";
    case eventTypeEnd: return "EVENT TYPE NOT SET";
    }

  return "unknown";
}

const gchar *translatePresenceType(presenceType type)
{
  switch(type)
    {
    case presenceTypeAvailable: return "available";
    case presenceTypeUnAvailable: return "unavailable";
    case presenceTypeProbe: return "probe";
    case presenceTypeSubscribe: return "subscribe";
    case presenceTypeUnSubscribe: return "unsubscribe";
    case presenceTypeSubscribed: return "subscribed";
    case presenceTypeUnSubscribed: return "unsubscribed";
    case presenceTypeError: return "error";
    case presenceTypeEnd: return "PRESENCE TYPE NOT SET";
    }

  return "unknown";
}

const gchar *translatePresenceShow(presenceShow show)
{
  switch(show)
    {
    case presenceShowAway: return "away";
    case presenceShowChat: return "chat";
    case presenceShowDND: return "dnd";
    case presenceShowNormal: return "normal";
    case presenceShowXA: return "extended away";
    case presenceShowEnd: return "PRESENCE SHOW NOT SET";
    }

  return "unknown";
}

const gchar *translateMessageType(messageType type)
{
  switch(type)
    {
    case messageTypeNormal: return "normal";
    case messageTypeChat: return "chat";
    case messageTypeGroupChat: return "groupchat";
    case messageTypeHeadline: return "headline";
    case messageTypeError: return "error";
      case messageTypeXEvent: return "xevent";
    case messageTypeEnd: return "MESSAGE TYPE NOT SET";
    }

  return "unknown";
}

gchar *translateMessageXEventType(gint type)
{
    gchar *retval = "";

    if(type & messageXEventTypeCancelled)
	return g_strdup_printf("cancelled");

    if(type & messageXEventTypeOffline)
	retval = g_strconcat(retval, "offline | ", NULL);
    if(type & messageXEventTypeDelivered)
	retval = g_strconcat(retval, "delivered | ", NULL);
    if(type & messageXEventTypeDisplayed)
	retval = g_strconcat(retval, "displayed | ", NULL);
    if(type & messageXEventTypeComposing) 
	retval = g_strconcat(retval, "composing | ", NULL);

    return retval;
}

#ifdef __cplusplus
}
#endif
